2009-07-06  James Youngman  <jay@gnu.org>

	Prepare for release of findutils version 4.5.5.
	* configure.ac: Set version number to 4.5.5.
	* NEWS: Likewise.

2009-07-06  Andreas Metzler  <gnu@downhill.at.eu.org>

	* doc/find.texi: Various typo fixes.

2009-07-05  James Youngman  <jay@gnu.org>

	Fix typo in -execdir documentation.
	* doc/find.texi (Single File): Typo correction; we're describing
	-execdir, not -exec.
	* NEWS: Mention the bugfix.

2009-05-12  James Youngman  <jay@gnu.org>

	#26537: find -prune now makes sure it has valid stat() information.
	* NEWS: Added Savannah bug number for Colin's bugfix.

2009-05-07  Colin Watson  <cjwatson@ubuntu.com>

	* find/parser.c (parse_prune): -prune needs stat information if
	-depth is not in use.
	* find/pred.c (pred_prune): Assert that stat information is
	available if needed.
	* find/testsuite/find.posix/prune-stat.exp: New test.
	* find/testsuite/find.posix/prune-stat.xo: New test.
	* find/testsuite/Makefile.am (EXTRA_DIST_EXP, EXTRA_DIST_XO): Added
	prune-stat.exp, prune-stat.xo.
	* NEWS: Mention this bugfix.

2009-07-05  James Youngman  <jay@gnu.org>

	* lib/check-regexprops.sh: New test.  Run regexprops as a check,
	and compare its output against the contents of doc/regexprops.texi.
	* lib/Makefile.am: Run check-regexprops.sh for 'make check'.
	* doc/Makefile.am: don't clean regexprops.texi, and don't generate
	it automatically.
	* doc/regexprops.texi: add into source control.
	* doc/.gitignore: don't ignore regexprops.texi

2009-07-04  James Youngman  <jay@gnu.org>

	* configure.ac (AC_CONFIG_FILES): order the entries alphabetically
	and remove duplicates.  Put po/Makefile.in before
	po/Makefile, since the former is required in order to
	config.status to generate the latter.

2009-07-04  gettextize  <bug-gnu-gettext@gnu.org>

	* configure.ac (AC_CONFIG_FILES): Add po/Makefile.in.
	(AM_GNU_GETTEXT_VERSION): Bump to 0.17.

2009-05-12  Eric Blake  <ebb9@byu.net>

	xargs: fix compilation on cygwin
	* xargs/xargs.c (main): Check that ARG_MAX is defined.

	xargs: avoid compiler warning
	* xargs/xargs.c (get_char_oct_or_hex_escape): Pass correct type to
	ctype macro.

2009-05-04  James Youngman  <jay@gnu.org>

	* find/util.c (get_info): Don't fall off the end of the function
	without returning a value.

2009-04-25  James Youngman  <jay@gnu.org>

	* AUTHORS: Add Andreas Metzler.

2009-04-25  Andreas Metzler  <gnu@downhill.at.eu.org> (tiny change)

	Correct a typo "diagnositcs".
	* doc/find.texi (Environment Variables): Correct a typo.

2009-04-24  A. Costa  <agcosta@gis.net> (tiny change)

	Correct a typo "diagnositcs".
	* find/find.1 (POSIXLY_CORRECT): Correct a typo.

2009-04-24  James Youngman  <jay@gnu.org>

	* find/ftsfind.c (consider_visiting): Print a message for "-D
	search" both on entry to the function and at the point where we
	have decided not to ignore this file.

2009-04-12  James Youngman  <jay@gnu.org>

	* NEWS: Mention the fix for bug #22708 in the correct section.

	Avoid mixing declarations and statements.
	* lib/buildcmd.c (bc_do_exec): Declare variables at the top of the
	relevant block, in order to avoid mixing declarations and
	statements.
	* xargs/xargs.c (main): Likewise.

2009-04-12  Leslie Polzer  <leslie.polzer@gmx.net>

	Merge Leslie Polzer's ARG_MAX enhancements to xargs which were
	produced as part of the Google Summer of Code 2007.
	These changes fix Savannah bug #22708.
	* find/pred.c (launch): The struct buildcmd_control* argument is
	no longer const.
	* find/defs.h: Likewise
	* lib/buildcmd.c (bc_do_insert): The struct buildcmd_control*
	argument is no longer const.
	(bc_push_arg): Likewise.
	(cb_exec_noop): Likewise.
	(get_stringv_len): New function; measures the length of
	a NULL-terminated argv sequence.
	(bc_do_exec): Rename from do_exec, and make global.  Modify the
	function to react to exec failing with E2BIG by trying again
	with fewer arguments.
	* xargs/xargs.1: Mention that xargs automatically adopts to the
	situation where exec fails with E2BIG.
	* xargs/xargs.c: (parent): New variable, the PID of the parent
	process.
	(main): initialise the variable 'parent'.   Don't fail immediately
	due to lack of space when the environment is large.  Call
	xargs_do_exec via bc_do_exec.
	(xargs_do_exec): The struct buildcmd_control* argument is no
	longer const.   When exec fails in the child, communicate the
	errno value back to the parent through a pipe which is
	close-on-exec; this allows us to accurately determine the cause of
	the failure and also to distinguish exec failures from all
	possible exit codes in the child.
	(wait_for_proc): If the utility cannot be found or cannot be run,
	we now find out about this by reading an errno value from the
	pipe, so this means that exit codes 126 and 127 in the child no
	longer have a special interpretation.
	* NEWS: mention these changes.

2009-04-13  James Youngman  <jay@gnu.org>

	* import-gnulib.config (gnulib_version): Update to current head
	version.

2009-04-13  Andreas Metzler <gnu@downhill.at.eu.org>

	Fix Savannah bug# 26092: find.1 still marks -iwholename as prefered
	* find/find.1 (-iwholename): Indicate that this option is no
	longer preferred over -ipath.

2009-03-07  James Youngman  <jay@gnu.org>

	Update the code to better reflect the semantics of digest_mode().
	* find/defs.h: Pass the file mode to digest_mode() by reference
	(as a pointer) rather than by value to make it unnecessary for the
	caller to know that the value passed should become dead.
	* find/util.c (digest_mode): Change the implementation.
	* find/find.c (process_path): Update caller.
	* find/ftsfind.c (consider_visiting): Update caller.

2009-03-10  James Youngman  <jay@gnu.org>

	Remove "lib/wait.h", since gnulib provides <sys/wait.h>.
	* lib/Makefile.am (EXTRA_DIST): Remove wait.h, since gnulib
	provides it.
	* lib/wait.h: Not needed.
	* find/pred.c: Include <sys/wait.h> instead of "wait.h".
	* lib/waitpid.c: Likewise.
	* xargs/xargs.c: Likewise.

	Remove unnecessary include guards.
	* lib/dircallback.c: gnulib provides <locale.h>, so no need for
	include guards.
	* locate/locate.c: Likewise.
	* lib/listfile.c: Likewise.
	* lib/savedirinfo.c: Likewise with <sys/stat.h>
	* find/defs.h: gnulib provides <inttypes.h>, so no need for
	include guards.
	* lib/nextelem.c: Likewise with <string.h> and <stdlib.h>.
	* locate/bigram.c: Likewise.
	* locate/frcode.c: Likewise.
	* lib/buildcmd.c: Likewise with <locale.h> and <wchar.h>
	* xargs/xargs.c: Likewise with <locale.h>, <wchar.h> and <stdlib.h>
	* import-gnulib.config (modules): Import the mbrtowc and whchar
	modules.
	* lib/qmark.c (multibyte_qmark_chars):  Don't surround with
	HAVE_MBRTOWC, since we now have a replacement for mbrtowc.
	Likewise, don't protect inclusion of <string.h> with
	HAVE_STRING_H.  Likewise with <wchar.h>.
	(multibyte_qmark_chars): Rename to qmark_chars.
	(qmark_chars): Remove old version (since it is replaced by the
	function that used to be multibyte_qmark_chars).
	* lib/printquoted.c: Don't include <wchar.h>, we don't need it.

	Prepare for release of findutils-4.5.4.
	* configure.ac (AC_INIT): Set version number to 4.5.4.
	* NEWS: Likewise.

	Remove obsolete regex.c copy fixup.
	* Makefile.am (jy-regex-fix) Delete.
	(dist-hook): Remove jy-regex-fix.

	Update to version 0.17 of GNU gettext.
	* configure.ac: Update to version 0.17 of gettext.
	* import-gnulib.sh (refresh_output_files): Run autopoint too.
	* ABOUT-NLS: Remove the file from source control, since gettext
	produces it.
	* .gitignore: Ignore ABOUT-NLS.
	* po/Makefile.in.in: Likewise.
	* po/.gitignore: Ignore po/Makefile.in.in.

	Correct the changelog-driver argument list.
	* import-gnulib.sh (check_merge_driver): Add the missing arguments
	to the changelog driver.  Change the name of the merge driver from
	cl-merge to merge-changelog, for consistency with gnulib,
	coreutils, autoconf, libtool, and m4.

2009-03-08  James Youngman  <jay@gnu.org>

	Switch to using a merge driver for the ChangeLog file.
	* import-gnulib.sh (check_merge_driver): New function; verifies
	that we have a merge driver installed for the ChangeLog file (if
	we're on the master or release branch, the check is skipped).
	Also check that the .gitattributes file exists.
	* README-hacking: Point out that using a merge driver for
	ChangeLog is a good idea.
	* .gitattributes: New file

	Optimise away calls to stat if all we need is the inode number.
	This fixes Savannah bug #24342.
	* find/util.c (get_info): call get_statinfo if need_inum and we
	don't already have the inode number.
	(apply_predicate): Call get_info if need_inum.
	* find/defs.h (enum EvaluationCost): Add NeedsInodeNumber.
	(struct predicate): Add need_inum.
	* find/tree.c (get_new_pred): Default need_inum to false.
	(get_new_pred_chk_op): Likewise.
	* find/ftsfind.c (consider_visiting): Copy the value of st_ino
	into statbuf.st_ino.
	* find/parser.c (parse_inum): Set need_inum=true.
	(parse_samefile): Set need_inum=false, but add a comment
	indicating that there is an optimisation opportunity.
	(make_segment): For -printf %i, set NeedsInodeNumber rather than
	NeedsStat.
	* find/pred.c (pred_inum): assert that the inode number is known
	(i.e. non-zero).
	(print_optlist): Print "[need inum]" when need_inum is  true.
	* find/tree.c (opt_expr): Also reorder expressions if the right
	hand expression is -inum (that is, consider that test to be no
	more expensive than -type).
	(set_new_parent): Default need_inum to false.
	(costlookup): Set pred_inum=NeedsInodeNumber.
	(get_pred_cost): need_inum implies a data cost of
	NeedsInodeNumber.
	(cost_table): Add NeedsInodeNumber.
	(print_tree): Handle need_inum.

	For -samefile, skip stat if inode numbers differ.
	* find/pred.c (pred_samefile): Skip stat if the inode numbers are
	different.
	Enable -Wall compiler warnings and fix them.
	* configure.ac: Turn on -Wall warnings.
	* find/find.c (process_dir): Print unsigned values of unspecified
	width as uintmax_t.
	* xargs/xargs.c: Include <inttypes.h> and <stdint.h>, but without
	the include guards (since we assume an ISO C platform anyway).
	* import-gnulib.config (modules): Add modules inttypes and stdint.

2009-03-07  James Youngman  <jay@gnu.org>

	Remove unused Debian files; the Debian package doesn't use them.
	* debian.rules: Delete.
	* debian/README.debian: Delete.
	* debian/TODO: Delete.
	* debian/changelog: Delete.
	* debian/conffiles: Delete.
	* debian/control: Delete.
	* debian/copyright: Delete.
	* debian/cron.find: Delete.
	* debian/doc-base: Delete.
	* debian/postinst: Delete.
	* debian/preinst: Delete.
	* debian/prerm: Delete.
	* debian/rules: Delete.
	* debian/substvars: Delete.
	* debian/updatedb.conf: Delete.
	* debian/.cvsignore: Delete.
	* debian/.gitignore: Delete.

2009-03-06  James Youngman  <jay@gnu.org>

	Change suffix for non-release versions from -CVS to -git.
	* configure.ac(AC_INIT): Change the suffix used to indicate that
	the version number doesn't correspond to a source release from
	-CVS to -git.
	* NEWS: Likewise.

	Delete the INSTALL file; rely on Autoconf providing it.
	* INSTALL: Delete; this file can be copied/generated by Autoconf,
	so do that rather than keeping it under source control.
	* .gitignore: Ignore INSTALL.

	Updated translation po files from translationproject.org.
	* po/bg.po: Updated Bulgarian translation.
	* po/de.po: Updated German translation.
	* po/ga.po: Updated Irish translation.
	* po/hu.po: Updated Hungarian translation.
	* po/lt.po: Updated Lithuanian translation.
	* po/nl.po: Updated Dutch translation.
	* po/pl.po: Updated Polish translation.
	* po/sl.po: Updated Slovenian translation.
	* po/sv.po: Updated Swedish translation.
	* po/tr.po: Updated Turkish translation.
	* po/uk.po: Updated Ukranian translation.
	* po/vi.po: Updated Vietnamese translation.
	* NEWS: Mention these updates.

2009-03-05  James Youngman  <jay@gnu.org>

	Fix Savannah bug #25764, duplicate entry for proc in PRUNEFS.
	* locate/updatedb.sh (PRUNEFS): Remove duplicate entry for proc.
	* locate/Makefile.am (updatedb): add dependency on Makefile, and
	add a comment explaining why updatedb is generated by make, not
	configure.
	* NEWS: Mention this bugfix.

	Provide more detailed help on how to work with the git sources.
	* README-CVS: Rename to README-hacking.
	* README-hacking: Add more specific information about using topic
	branches, test cases, documentation, coding standards and how to
	submit patches.   Much of this is adapted from the files
	README-hacking and HACKING in the coreutils source tree.
	* Makefile.am: Generate tool-versions.txt, which is a list of the
	--version outputs of the tools that the maintainer used to build a
	release.
	* NEWS: Mention these improvements.

2009-03-04  James Youngman  <jay@gnu.org>

	Upgrade to gnulib version 86a37c05846ff3772afd1300f135866dd1d271c6.
	* import-gnulib.config(gnulib_version): Update.
	* xargs/Makefile.am: Add $(LIB_CLOSE) to $(LDADD), as suggested by
	gnulib's unistd module.
	* locate/Makefile.am: Likewise.
	* find/Makefile.am: Likewise.

	Removed trailing white space.
	* Makefile.am: Removed trailing white space.
	* NEWS, build-aux/check-testfiles.sh, build-aux/src-sniff.py,
	doc/Makefile.am, doc/find-maint.texi, doc/find.texi, find/Makefile.am,
	find/defs.h, find/find.1, find/find.c, find/finddata.c, find/fstype.c,
	find/ftsfind.c, find/parser.c, find/pred.c, find/tree.c, find/util.c,
	import-gnulib.sh, lib/Makefile.am, lib/buildcmd.c, lib/buildcmd.h,
	lib/dircallback.c, lib/dircallback.h, lib/extendbuf.c,
	lib/extendbuf.h, lib/findutils-version.c, lib/findutils-version.h,
	lib/forcefindlib.c, lib/gnulib-version.h, lib/listfile.c,
	lib/modetype.h, lib/nextelem.c, lib/nextelem.h, lib/printquoted.c,
	lib/printquoted.h, lib/qmark.c, lib/regexprops.c, lib/regextype.c,
	lib/savedirinfo.c, lib/savedirinfo.h, lib/strspn.c, lib/wait.h,
	lib/waitpid.c, locate/bigram.c, locate/code.c, locate/locate.1,
	locate/locate.c, locate/locatedb.5, locate/locatedb.h,
	locate/updatedb.1, locate/updatedb.sh, locate/word_io.c,
	m4/findlib.m4, m4/nullsort.m4, m4/withfts.m4, xargs/xargs.1:
	Likewise.
	* m4/nullsort.m4: Removed occurrences of space followed by tab.

	Enabled GCC warnings for declarations after statements.
	* import-gnulib.config: Import the gnulib module 'warnings'
	* configure.ac: Add GCC warning -Wdeclaration-after-statement.
	* Makefile.am: Add AM_CFLAGS and set it to $(WARN_CFLAGS).
	* find/Makefile.am, doc/Makefile.am, lib/Makefile.am: Likewise.
	* locate/Makefile.am, xargs/Makefile.am: Likewise.

2009-03-03  James Youngman  <jay@gnu.org>

	Fix Savannah bug #25359, more efficiently (suggestion by Nick Fortino).
	* find/ftsfind.c (consider_visiting): revert the previous change
	which discarded type information, and instead simply ensure that
	state.curdepth holds the correct value before digest_mode() is
	called.
	(find): revert the previous change.
	(visit): we no longer need to set state.curdepth here, since it
	will have been set already in consider_visiting().

2009-03-02  James Youngman  <jay@gnu.org>

	Fix Savannah bug #25359.
	* find/ftsfind.c (consider_visiting): discard mode information
	from fts when the -H option is in effect and the current file is a
	symbolic link.
	(find): don't decode the mode information that find is trying to
	pass to us in that case, since we don't want to use it.
	* find.posix/sv-bug-25359.exp: new test for this bug.
	* find.posix/sv-bug-25359.xo: expected output for the test.
	* NEWS: Mention this bugfix.

2009-02-21  James Youngman  <jay@gnu.org>

	Updated the email address for Eric B. Decker.
	* ChangeLog: Updated Eric's address
	* find/find.c: Likewise
	* find/ftsfind.c: Likewise

2009-02-21  Jim Meyering  <meyering@redhat.com>

	find: take advantage of new gnulib/fts leaf-optimization
	* find/ftsfind.c (ftsoptions): Set the FTS_CWDFD bit.
	This is required in order to take advantage of fts' leaf-optimization.
	* find/ftsfind.c (consider_visiting): Allow state.type to be 0
	when fts_info is FTS_NSOK;

	This allows find to process an fts entry for which fts_read returns
	FTS_NSOK (no stat) but for which find requires only type info.
	This happens on file systems that lack dirent.dtype information.
	Currently, only reiserfs is handled this way.  Until the recent
	gnulib/fts change, [97d5b66] "fts: arrange not to stat non-directories
	in more cases" this change was not necessary, because fts would always
	stat non-dir entries on a file system with no dirent.dtype information.

	However, combined with the gnulib change, this change lets find
	avoid many per-non-directory stat-like syscalls (i.e. fstatat)
	in some very common cases, like "find . -print" on reiserfs --
	which can be a huge performance savings.

	find: avoid warning about unused local
	* find/pred.c (scan_for_digit_differences): Remove declaration of
	unused local, "ok". (second time, really applying that patch).

2009-02-21  James Youngman  <jay@gnu.org>

	Update gnulib version.
	* import-gnulib.config (gnulib_version): Update from
	d4b129b8e5f8a8d1198020fd6fc79310d305936c to
	df70a4bf4a1e84171918db09b639ae1a14c2a9b2.  This pulls in the
	following relevant changes:
	fts: correct internal computation of nlinks (optimization-related)
	fts: move a function definition "up" (no semantic change)
	fts: arrange not to stat non-directories in more cases
	fts: add #if guards so that the fts_lgpl module still builds
	fts: avoid used-uninitialized error due to recent change
	regex: avoid compilation failure with upcoming gcc-4.4
	regex: fix glibc bug 697
	regex: fix glibc bug 9697
	Other changes may also be relevant; for details please check gnulib/ChangeLog.

	Improvements to import-gnulib.config, import-gnulib.sh.
	* import-gnulib.config (gpl3_update_files): No longer need to
	update the licenses of build-aux/mdate-sh, build-aux/texinfo.tex
	or build-aux/ylwrap as they are already GPLv3+.
	(modules): Use the strdup-posix module instead of strdup, and stop
	using the obsolete modules memcmp and memset, since we now assume
	those functions will already be present on the host system.
	* import-gnulib.sh (rehack): Be more verbose about which files
	actually needed a license edit and which did not.

	Follow gnulib-tool's Makefile.am edit suggestions.
	* find/Makefile.am (LDADD): Use $(LIBINTL) instead of @INTLLIBS@
	and use $(LIB_CLOCK_GETTIME) instead of @LIB_CLOCK_GETTIME@.
	* lib/Makefile.am: Likewise.
	* locate/Makefile.am: Likewise.
	* xargs/Makefile.am: Likewise.
	* import-gnulib.sh (hack_gnulib_tool_output): Add
	m4/gnulib-cache.m4 to EXTRA_DIST in gnulib/Makefile.am, as
	gnulib-tool suggests.

2009-02-21  Jim Meyering  <meyering@redhat.com>

	find: avoid warning about unused local, remove unnecessary include.
	* find/pred.c (scan_for_digit_differences): Remove declaration of
	unused local, "ok".
	(do_time_format): Remove decl of "done"; replace sole use with a
	constant, "true".  Initialize "i" and "n".
	* lib/dircallback.c: Don't include unistd.h.  Not needed.

2009-01-17  Thien-Thi Nguyen  <ttn@gnuvola.org>

	find: Fix -regexptype parse specification bug: declare as POSOPT.
	* find/parser.c (parse_table): Parse -regextype as POSOPT.

2008-12-26  Jim Meyering  <meyering@redhat.com>

	find: avoid using undefined statbuf
	* /ftsfind.c (consider_visiting): Use local variable, mode,
	rather than possibly undefined statbuf.st_mode.

2008-12-23  James Youngman  <jay@gnu.org>

	Fix Savannah bug #25154: Failure to compile with GCC-2.95.4
	* find/parser.c (do_parse_xmin): Move declaration of struct
	timespec origin before the statements; declarations after
	statements are a GCC extension we were accidentally relying on.

2008-12-21  James Youngman  <jay@gnu.org>

	Fix Savannah bug #25144: Misleading message for find -user unknown.
	* find/parser.c (parse_user): If there is no known group for the
	specified user (and it does not appear to be a uid), issue a
	fatal error message instead of returning false, because the error
	message that results from a return of false is "invalid argument",
	which is misleading in this case.  Similarly for a missing or an
	empty argument.

2008-12-01  James Youngman  <jay@gnu.org>

	* po/fr.po: Updated French translation.

	* po/id.po: Updated Indonesian translation.

2008-12-01  Geoff Gole  <geoffgole@gmail.com>

	* xargs/xargs.1 (STANDARDS CONFORMANCE): Fix typo.

2008-11-30  Jim Meyering  <meyering@redhat.com>

	Pass file type information in dirent.d_type from fts to find.
	* find/ftsfind.c (consider_visiting): When fts provides usable
	dirent.d_type information, and the only stat information required
	by find's predicates is the file-type information normally found
	in stat.st_mode (that is, not the permissions information), skip
	the now-redundant stat calls.  This change is useful only with the
	very latest version of fts.c from gnulib.  Requires gnulib version
	d4b129b8e5f8a8d1198020fd6fc79310d305936c or later.
	* find/ftsfind.c (find): Set state.have_type if fts returned type
	information.

2008-11-08  James Youngman  <jay@gnu.org>

	* import-gnulib.config (gnulib_version): Update version of gnulib,
	mainly in order to pull in Jim Meyering's efficiency improvements
	to fts.  See http://git.savannah.gnu.org/gitweb/?p=gnulib.git;a=commit;h=2f2978ede97205c49d3e568ccffa5a04fb53326b
	* lib/dircallback.c: gnulib's lstat.h is now gone, instead it
	provides <sys/stat.h> where that is needed.

2008-11-08  Jim Meyering <meyering@redhat.com>

	* README-CVS: tiny typo fix (s/fileutils/findutils/).

2008-09-07  James Youngman  <jay@gnu.org>

	Fix bug #23996 (integer overflow when parsing "-used 3").
	* find/parser.c (get_relative_timestamp): Check for overflow after
	the fact by comparing the relative sizes of the result and the
	operands.  This prevents an incorrect diagnosis of overflow when
	the resulting tv_sec is correctly negative (as is normally the
	case for -used).

2008-08-31  James Youngman  <jay@gnu.org>

	New Czech translation.
	* po/cs.po: New Czech translation.
	* configure.ac: Added cs (Czech) to ALL_LINGUAS.

	Fix Savannah bug #24169 (-neweraa without following arg coredumps).
	* find/parser.c (parse_newerXY): Issue a fatal error message if
	there is no following argument.
	* find/testsuite/find.gnu/sv-bug-24169.exp: Test case for this
	bug.
	* find/testsuite/Makefile.am (EXTRA_DIST_EXP): Also distribute
	this new test file.
	* NEWS: Mention this change.

2008-08-04  James Youngman  <jay@gnu.org>

	* find/find.1: correct typo seach->seach (reported by Bobby
	R. Ward).
	* locate/updatedb.1: correct typo Any -> any (reported by Reuben
	Thomas).

2008-06-28  James Youngman  <jay@gnu.org>

	Fix savannah bug #23070 (find.1 needs update for -perm /000)
	* find/find.1 (-perm /mode): The all-bits-zero behaviour has
	already changed.
	* NEWS: Mention the fix.

2008-06-21  James Youngman  <jay@gnu.org>

	* import-gnulib.config (gnulib_version): Updated to current HEAD
	gnulib.

	Fix Savannah bug #23663, crash in some locales for %AX.
	* find/pred.c (do_time_format): Fix off-by-one error in handling
	of the buffer used to print timestamps.   This caused a crash in
	some locales when handling the %AX format specifier.
	* NEWS: Mention this bugfix.

2008-06-20  RB  <aoz.syn@gmail.com>

	* doc/find.texi (Finding the Shallowest Instance): Add worked
	example explaining how to efficiently locate the shallowest
	instances of '.svn' or 'CVS' in a forest of project trees.
	* find/find.1 (EXAMPLES): Add the same example here (with slightly
	briefer wording).

2008-06-19  Per Starbäck  <starback@stp.lingfil.uu.se> (tiny change)

	* doc/find.texi (Unusual characters in filenames): Directory
	separator is the slash, not the backslash.

2008-06-19  James Youngman  <jay@gnu.org>

	* po/zh_CN.po: Updated the Chinese (simplified) translation.
	* NEWS: Mention this change.

2008-06-19  Stepan Kasal  <skasal@redhat.com>

	* doc/find.texi (Cleaning Up): Move the note about -depth up.

2008-06-19  James Youngman  <jay@gnu.org>

	* po/lt.po: New Lithuanian translation.
	* NEWS: Mention this change.
	* configure.ac: Add "lt" to ALL_LINGUAS.

2008-05-28  James Youngman  <jay@gnu.org>

	Bugfix to the code that was previously supposed to fix bug #22662
	in 4.5.0.
	* find/pred.c (scan_for_digit_differences): Remember that wesaw
	the first differing digit and also get the order of the
	subtractionoperands right.
	(do_time_format): Off by one error on checking for a nondigit
	after the sequence of changed digits.
	* NEWS: Mention this change.

2008-05-18  James Youngman  <jay@gnu.org>

	Update gnulib.
	* import-gnulib.config (gnulib_version): Update to current head
	version of gnulib.

	Document effect of gnulib update, mainly on yesno().
	* doc/find.texi (Unusual Characters in File Names): Explain that
	the LC_CTYPE variable affects which characters are considered to
	be printable by -printf %p, -print and -fprint.
	(Querying): Explain in more detail how environment variables
	affect the interpretation of the response to -ok and -okdir.
	(Regular Expressions): Indicate that the locale configuration
	affects the interpretation of regular expressions.
	(Environment Variables): Describe how LC_COLLATE and LC_CTYPE
	affect the interpretation of regular expressions.  Indicate that
	LC_MESSAGES affects the interpretation of the response to -ok.
	* find/find.1 (-ok): Describe the effect of POSIXLY_CORRECT,
	LC_CTYPE and LC_COLLATE.
	(-okdir): Likewise.
	(UNUSUAL FILENAMES): Describe how LC_CTYPE affects -printf %p,
	-print, -fprint.
	(STANDARDS CONFORMANCE): -ok and -okdir now obey the system's
	defintion of yes/no if POSIXLY_CORRECT is set.  In any case,
	LC_CTYPE and LC_COLLATE may have some effect.  Point out that
	the setting of LC_MESSAGES deternmines what pattern is used to
	interpret the user's response to -ok/-okdir.
	* find/parser.c: Remove definition of ISUPPER, which we no longer
	need.
	* NEWS: mention these changes.

2008-04-25  Eric Blake  <ebb9@byu.net>

	Support cygwin 1.7.0.
	* find/parser.c (parse_newerXY)
	[HAVE_STRUCT_STAT_ST_BIRTHTIM_TV_NSEC]: Add support for another
	form of birthtime.
	* import-gnulib.config (gnulib_version): Update to pick up change
	necessary for cygwin fstatat.

2008-03-21  James Youngman  <jay@gnu.org>

	* find/testsuite/find.gnu/xtype-symlink.exp: Removed unnecessary
	test code which created a insecure tempfile.

2008-03-16  James Youngman  <jay@gnu.org>

	Update gnulib.
	* import-gnulib.config (gnulib_version): Update to a newer version
	of gnulib.

	Find optimises at -O2 by default.
	* find/util.c (set_option_defaults): Use a default optimisation
	level of 2 rather than 0.
	* NEWS: Mention this change.

	Begin work on findutils-4.5.x.
	* configure.ac: We're now working on the 4.5.x release series, so
	change the version number.
	* NEWS: Likewise.

2008-03-10  Justin Pryzby  <justinpryzby@users.sourceforge.net> (tiny change)

	* doc/find.texi: Various typo corrections.

2008-03-10  Eric Blake  <ebb9@byu.net>

	Don't truncate printed ino values.  Fixes Savannah bug #15472.
	* find/find.c (wd_sanity_check): Use PRIuMAX for platforms with
	64-bit ino_t.
	* NEWS: Document this.

2008-03-10  Jim Meyering  <meyering@redhat.com>

	Rename local and member "dirfd" to avoid shadowing the function.
	This avoids many warnings from gcc -Wshadow:
	* lib/buildcmd.h (struct buildcmd_state) [dir_fd]: Rename member
	from dirfd.
	* find/defs.h (struct exec_val) [dir_fd]: Likewise.
	Rename parameter in prototype.
	* find/ftsfind.c (inside_dir): Rename parameter: s/dirfd/dir_fd/
	* find/parser.c (new_insert_exec_ok, insert_exec_ok): Likewise.
	* find/pred.c (new_impl_pred_exec, prep_child_for_exec, launch):
	s/dirfd/dir_fd/
	* find/util.c (do_complete_pending_execdirs): Likewise.
	(complete_pending_execdirs): Likewise
	* lib/buildcmd.c (bc_init_state, bc_clear_args): Likewise.
	* lib/dircallback.c (run_in_dir): Likewise.
	* lib/dircallback.h (DIRCALLBACK_H): Likewise.
	* lib/listfile.c (list_file, get_link_name_at): Likewise.
	* lib/listfile.h (LISTFILE_H): Likewise.

	Avoid link failure with -fno-common.
	* locate/code.c (program_name): Declare "extern".

2008-03-09  James Youngman  <jay@gnu.org>

	Fix (documentation) bug #20873, / and . in file names for -path.
	* doc/find.texi (Full Name Patterns): Mention that * in the "find
	-path" pattern will match both / and leading dots.

2008-03-08  Jim Meyering  <meyering@redhat.com>

	Fix doc typos.
	* doc/find-maint.texi (Security): s/ongest/longest/
	(Making Releases): s/the the/the/

	Avoid link failure with gcc -fno-common.
	* find.c (program_name, starting_desc): Declare "extern".

2008-02-15  Eric Blake  <ebb9@byu.net>

	Avoid compiler warnings.
	* find/pred.c (pred_name_common): Remove unused variable.
	* locate/locate.c (print_stats): Avoid undefined format string.

2008-02-15  James Youngman  <jay@gnu.org>

	* README-CVS: Explain how to update the translations from the
	translation project.

	* NEWS, configure.ac: Change release number to 4.3.14-CVS.

2008-02-13  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de> (tiny change)

	* import-gnulib.config: Add progname.

	* lib/Makefile.am (LDADD): Use @LIBINTL@ instead of @INTLLIBS@.

	* xargs/xargs.1: Fix a couple of typos.

2008-02-12  James Youngman  <jay@gnu.org>

	Updated translations: German, Irish, Dutch, Polish, Vietnamese.
	* po/de.po, po/ga.po, po/nl.po, po/pl.po, po/vi.po: Updated from
	the Translation Project.

	Fix Savannah bug #22056, -Xtime tests are off by one second.
	* find/defs.h (struct options): Change cur_day_start from time_t
	to strct timespec.
	* find/util.c (set_option_defaults): Likewise.
	* find/parser.c (get_relative_timestamp): Change the origin
	argument from time_t to struct timespec.
	(estimate_timestamp_success_rate): Ignore the nanoseconds field of
	the timestamp when estimating the probable success rate.
	(parse_daystart): Handle the nanoseconds field too.
	(do_parse_xmin): The origin argument to get_relative_timestamp()
	is of type struct timespec, not time_t.
	(parse_used): Likewise.
	(parse_time): Likewise.
	* find/pred.c (pred_timewindow): in the COMP_EQ case, accept times
	exactly at the end of the window and do not accept times exactly
	at the start (reversing the previous treatment of the bounds).
	* find/testsuite/Makefile.am (EXTRA_DIST_EXP): Added test for
	-mtime 0; find.posix/mtime0.{exp,xo}.
	* NEWS: mention this bugfix.

2008-02-09  James Youngman  <jay@gnu.org>

	* doc/find.texi (xargs options): Moved documentation of xargs'
	options into this new section.
	(Invoking the shell from xargs): New section providing examples
	about "xargs sh -c '...'".

	* xargs/xargs.1: Indicate that the "sh -c" trick with xargs
	achieves the same thing as BSD's "xargs -o", but in a more
	flexible way.

	* locate/updatedb.sh: Actually rename the old database to the new
	one atomically, instead of just claiming the rename is atomic in a
	comment :)  This fixes Savannah bug #22057.

	* find/find.c (ngettext): Introduce a new macro to help with
	internationalising plurals.   Use it to allow better
	translations of format strings.
	* locate/locate.c: Likewise.

2008-01-07  James Youngman  <jay@gnu.org>

	* xargs/xargs.c: (main): Standardise on "Warning" instead of
	"warning" in messages.

	* xargs/xargs.c: (add_proc): Use x2nrealloc to extend the pids
	array, rather than doubling the size of the buffer (since the old
	aproach was vulnerable to overflow).

	Reap all available child processes before every fork.  This fixes
	Savannah bug #21960.
	* xargs/xargs.c: (proc_max): since this is a non-negative
	quantity, make it unsigned.
	(procs_executing): Likewise.
	(pids_alloc): Likewise (using size_t).
	(procs_executed): In order to prevent possible overflow, make this
	a boolean, not a count.  We only cared if the previous counter was
	zero or not, anwyay.
	(add_proc): Set procs_executed to true rather than incrementing it.
	(wait_for_proc): When called, always reap all available children.
	Add an extra argument which is the minimum number of children we
	must reap before returning.
	(wait_for_proc_all): Pass the new extra argument.
	(xargs_do_exec): Call wait_for_proc() to reap all available
	children before forking a new child.  Modify other calls to
	wait_for_proc to pass the new extra argument.
	* NEWS: Mention this change.

2007-12-20  James Youngman  <jay@gnu.org>

	* find/fstype.c, find/ftsfind.c, find/parser.c, find/pred.c,
	find/tree.c, lib/regextype.c, locate/locate.c, xargs/xargs.c,
	find.c: Backed out positional paremeter change, as the use of
	positional parameters was over-complex and unnecessary.  We'll
	re-apply the pluralisation support change soon, but without the
	positional parameters.

2007-12-20  Jakub Bogusz <qboosh@pld-linux.org> (tiny change)

	* xargs/xargs.c (parse_num): Corrected typo in format string
	message.

2007-12-20  Clytie Siddall <clytie@riverland.net.au> (tiny change)

	* find/find.c (wd_sanity_check): Corrected typo in the format
	string for an error message, which might cause a crash in
	"oldfind" if a directory we moved into turned out to be a symbolic
	link that moved while we were trying to change directory.

2007-12-20  James Youngman  <jay@gnu.org>

	* configure.ac: Advance the version number, as we are moving on
	from 4.3.12.
	* NEWS: Likewise

2007-12-19  James Youngman  <jay@gnu.org>

	* find/find.c (ngettext): Introduce a new macro to help with
	internationalising plurals.   Use it with positional parameters in
	order to allow better translations of format strings.
	* find/fstype.c, find/ftsfind.c, find/parser.c, find/pred.c,
	find/tree.c, lib/regextype.c, locate/locate.c, xargs/xargs.c: Likewise.

2007-12-19  Benno Schulenberg <coordinator@translationproject.org> (tiny change)

	* find/find.1: Corrected two typos.

2007-12-19  James Youngman  <jay@gnu.org>

	* po/nl.po: Updated Dutch translation from the Translation project.
	* po/pl.po: Likewise for the Polish translation.
	* po/sv.po: Likewise for the Swedish translation.
	* po/vi.po: Likewise for the Vietnamese translation.

2007-12-13  Eric Blake  <ebb9@byu.net>

	Allow bootstrapping with autoconf 2.61a.
	* configure.ac (AC_AIX, AC_ISC_POSIX): Delete, now that gnulib
	takes care of this.
	(jy_AC_TYPE_INTMAX_T): Delete, now that gnulib stdint module takes
	care of this.

2007-12-09  James Youngman  <jay@gnu.org>

	* doc/perm.texi: Updated from the upstream source.

	* po/nl.po, po/pt.po: Updated from the Translation Project.

2007-12-08  James Youngman  <jay@gnu.org>

	* xargs/xargs.1: Added examples on stdin handling and more
	efficient core file deletion.
	* NEWS: Mention this.

	* doc/.cvsignore: Ignore regexprops-generic.texi.
	* doc/.gitignore: ditto

2007-12-04  James Youngman  <jay@gnu.org>

	Fix Savannah bug #15384, find misbehaves when parent directory is
	not readable.
	* find/testsuite/find.posix/parent.exp: New test
	* find/testsuite/find.posix/parent.xo: New test
	* find/testsuite/Makefile.am (EXTRA_DIST_EXP, EXTRA_DIST_XO):
	Added parent.exp, parent.xo.
	* find/find.c (safely_chdir): If safely_chdir_nofollow fails with
	SafeChdirFailDestUnreadable, fall back on safely_chdir_lstat.

	* find/find.1: Formatting fixes; options should be in bold.

2007-12-02  James Youngman  <jay@gnu.org>

	Fix Savannah bug #20802, find -delete anomalies
	* find/pred.c (pred_delete): Set find's exit status to nonzero if
	-delete fails.
	* find/find.1 (-delete): Document this.
	* doc/find.texi (Delete Files): Document this.
	* NEWS: Mention the fix.

2007-11-30  James Youngman  <jay@gnu.org>

	Fix Savannah bug #20865 (-prune -delete without an explicit
	-depth is now an error).
	* find/parser.c (check_option_combinations): Diagnose the
	situation where -delete and -prune are both used, because -delete
	turns on -depth and -depth makes -prune do nothing.
	* find/tree.c (build_expression_tree): call
	check_option_combinations().
	* find/defs.h (struct options): Add new boolean field
	explicit_depth.
	Also declare check_option_combinations.
	* find/util.c (set_option_defaults): Initialise explicit_depth.
	* NEWS: Mention this fix.

2007-11-29  James Youngman  <jay@gnu.org>

	Support the generation of regexprops-generic.texi.
	* lib/regextype.h (get_regex_type_context): Used to indicate if a
	particular type of regular expression is of interest for
	regexprops.texi (which is findutils-specific) or
	regexprops-generic.texi (which is not).   The "context" is simply
	a flag set in a word.
	* lib/regextype.c (get_regex_type_context): Implement this.
	(regex_map): Assign a context to each regular expression type.
	* lib/regexprops.c: Use the context information from regextype.c
	to decide which regular expression types to docuemnt in the
	output.  The selection is indicated on the command line; "generic"
	and "findutils" are supported.
	(copying): New function, which emits a copyright header into the
	output.
	(comment): New function for emitting a comment.
	(ignore): New function which returns nonzero when the indicated
	type of regular expression is not of interest for this version of
	the document.
	(menu): Miss out the non-interesteing regex types.
	(get_next): Returns the regex type name for the "next" pointer,
	taking into account which regex types are ignored.
	(describe_all): Take into account which regex types are ignored,
	and emit a copying header also.   Include a comment indicating
	which "context" was of interest when generating the output.
	* doc/Makefile.am: Add regexprops-generic.texi.  Generate this
	file from regexprops.c.

	Check gnulib out with native git, rather than git-cvspserver.
	This fixes Savannah bug #21568, for the second time.
	* import-gnulib.config (gnulib_version): Switch to using a git
	commit id and native git, since git-cvspserver silently fails to
	support "cvs update -D".
	* import-gnulib.sh (do_checkout): Check gnulib out with git rather
	than CVS.
	(main): Require 'git' to be available.
	(move_cvsdir): Remove any pre-existing gnulib-cvs directory.
	* doc/find-maint.texi (Using the GNU Portability Library): Desribe
	how we now obtain gnulib.  Update the instructions on how we patch
	gnulib.
	* .gitignore: Ignore gnulib-git, not gnulib-cvs
	* .cvsignore: Ditto
	* Makefile.am (findutils-check-smells): Change from gnulib-cvs to
	gnulib-git.
	* README-CVS: Mention the extra dependency on git.
	* NEWS: Mention this change.

	Add test case for Savannah bug #20803 (-prune return value).
	* find/testsuite/find.posix/prune-result.exp: New test for
	Savannah bug #20803.
	* find/testsuite/find.posix/prune-result.xo: Expected otuput for
	new test prune-result.exp.
	* find/testsuite/Makefile.am (EXTRA_DIST_EXP): Added
	find.posix/prune-result.exp
	(EXTRA_DIST_XO): Added find.posix/prune-result.xo

2007-11-27  James Youngman  <jay@gnu.org>

	* find/pred.c (pred_prune): Always return true.  This fixes
	Savannah bug #20803.
	* doc/find.texi (Directories): Document the change to -prune.
	* find/find.1: Document the change.
	* NEWS: Mention the fix.

2007-11-26  James Youngman  <jay@gnu.org>

	Fix Savannah bug #20970, handling of trailing slashes with -name.
	* find/pred.c (pred_name_common): Strip trailing slashes from the
	pathname before applying fnmatch() to it.  This fixes Savannah bug
	#20970.
	* find/testsuite/find.posix/nameslash.exp: Test case for bug #20970.
	* find/testsuite/find.posix/nameslash.xo: Expected output file for
	same.
	* find/testsuite/Makefile.am (EXTRA_DIST_EXP): Added nameslash.exp.
	(EXTRA_DIST_XO): Added nameslash.xo.

	Fix Savannah bug #21634, No copy of FDL1.2 included in source
	code.
	* doc/find.texi: Change license to the GNU Free Documentation
	License 1.2.
	(GNU Free Documentation License): Include fdl.texi
	* doc/find-maint.texi (GNU Free Documentation License): Include a
	copy of the FDL (it was already under this license).
	* doc/Makefile.am (find_maint_TEXINFOS): Include fdl.texi
	(find_TEXINFOS): Include fdl.texi
	* import-gnulib.config (modules): Include gpl-3.0 and fdl.

	* doc/perm.texi: Added copyright license, following the license of
	the original source document (perm.texi from coreutils).

2007-11-25  James Youngman  <jay@gnu.org>

	* Makefile.am (jy-regex-fix): Comment that the regex.c fix needs
	to stay until we no longer support Automate-1.9.

	* doc/perm.texi (Mode Structure): Fix setgid/setuid typo.

2007-11-24  James Youngman  <jay@gnu.org>

	* doc/find.texi (Mode Bits): Correct the warning about the change
	in behaviour of -perm /000 to indicate that the change has
	happened now.  This fixes Savannah bug #21628.
	* NEWS: Mention this.

2007-11-22  James Youngman  <jay@gnu.org>

	POSIXLY_CORRECT turns off warnings.
	* find/defs.h (struct options): Added member posixly_correct.
	This is set when the POSIXLY_CORRECT environment variable is set.
	* find/util.c (set_option_defaults): Set options.posixly_correct
	if the POSIXLY_CORRECT environment variable is set.
	(set_option_defaults): Turn off warnings when POSIXLY_CORRECT is
	in force.
	* find/find.1: Document this.
	(Environment Variables): Likewise.
	(Warning Messages): Likewise.

	Non-POSIX compliant arguments to -perm generate an error when
	POSIXLY_CORRECT is set.
	* find/parser.c (parse_table): Indicate which primaries are
	defined by POSIX.
	(non_posix_mode): New function; issues an error message when a
	non-POSIX-compliant argument to -perm is used (and POSIXLY_CORRECT
	is in force).
	(parse_perm): Call non_posix_mode when a non-POSIX-compliant mode
	argument is seen.
	* find/testsuite/find.gnu/posix-perminvalid.exp: New file; tests
	invalid arguments to -perm.
	* find/testsuite/Makefile.am (EXTRA_DIST_EXP): Add
	posix-perminvalid.exp.
	* find/find.1: Document this.
	* doc/find.texi (Mode Bits): Likewise
	(Environment Variables): Likewise


	* xargs/xargs.1: Options should be bold, not italic; filenames
	should also be italic.  OPTIONS should be a section, not a
	subsection.  In the description of --max-lines, "max-args" was
	corrected to "max-lines".  Turn off hyphenation in the SYNOPSIS
	section.  This fixes Savannah bug #21270.

2007-11-13  James Youngman  <jay@gnu.org>

	* NEWS, configure.ac: Prepare for the release of findutils-4.3.10.

	* import-gnulib.sh (usage): If the existing CVS working tree for
	gnulib in the source tree does not yet point at the
	git-cvs-pserver repository, move the old gnulib working tree out
	of the way and do a fresh checkout.  This fixes Savannah bug
	#21568.

2007-11-11  James Youngman  <jay@gnu.org>


	* configure.ac: Prepared for release of findutils-4.3.9.
	* NEWS: Likewise.

	* po/POTFILES.in: Use gnulib/lib/getdate.y rather than
	gnulib/lib/getdate.c, because the former is the source file, and
	because without this change the update-po target of po/Makefile
	fails.

	* import-gnulib.config (gnulib_version): Move to gnulib
	2007-11-10.

	* po/hu.po, po/nl.po: Updated from Translation Project.

2007-09-08  James Youngman  <jay@gnu.org>

	Better documentation on $PATH security checks.
	* doc/find.texi (Single File): Better explanation of what makes
	certain values of $PATH insecure.  This fixes Savannah bug
	#20951.
	* find/find.1 (-execdir): Likewise.

	Document interaction of -depth/-delete/-prune.
	* doc/find.texi (Directories): Mention that "-prune ... -delete"
	will not do what you want and will cause the deletion of more
	files than you probably intended.
	(Delete Files): Likewise, suggest using "-depth" when testing
	command lines you plan to eventually add "-delete" to.
	(Cleaning Up): Add -depth explicitly to an example which uses
	-delete.
	* find/find.1 (-depth): Mention that -delete also implies -depth.
	(-delete): Warn against putting -delete first.
	(-prune): Also warn against -prune ... -delete.
	NEWS: Mention these changes.

2007-08-23  Eric Blake  <ebb9@byu.net>

	Pick up gnulib change to getline module.
	* import-gnulib.config (gnulib_version): Bump date.
	* locate/bigram.c: Use <stdio.h>, not getline.h.
	* locate/code.c: Likewise.
	* locate/frcode.c: Likewise.
	* locate/locate.c: Likewise.

	* po/ChangeLog: Delete, merge into this file.

2007-08-23  James Youngman  <jay@gnu.org>

	* po/nl.po: Updated from Translation Project

	* find/parser.c (check_path_safety): Assume the path is safe is
	$PATH is not set.  This avoids a segfault in that situation
	and thus fixes Savannah bug #20834.

2007-08-22  James Youngman  <jay@gnu.org>

	* find/parser.c (parse_path): This is the 'canonical' name once
	again.
	(parse_wholename): This is not.
	(parse_ipath): No longer deprecated.
	* NEWS: Mention this.

2007-08-22  Eric Blake  <ebb9@byu.net>

	Fix Savannah bug #20871.
	* find/find.c (main): Remove bogus assertion.
	* NEWS: Document the fix.

	Update to recent gnulib addition of idcache.h.
	* lib/listfile.c (getuser, getgroup): Use header rather than
	declaring things ourself.
	* po/POTFILES.in (locate/frcode.c): Add missing file.

2007-08-21  Eric Blake  <ebb9@byu.net>

	Fix for Savannah bug #20273, find -ok with seekable stdin.
	* find/find.c (main): Use close_stdin, not close_stdout.
	* import-gnulib.config (gnulib_version): Pick up yesno tests.
	* NEWS: Document the change.
	* build-aux/.cvsignore: Ignore compile.

2007-08-20  Paul Eggert  <eggert@cs.ucla.edu>
	and Eric Blake  <ebb9@byu.net>

	Improve translation of xstrtol messages.
	* import-gnulib.config (destdir): Upgrade gnulib to 2007-08-11.
	* locate/locate.c (dolocate): Adjust to API change of xstrtol
	gnulib module.
	* po/POTFILES.in: Likewise.
	* NEWS: Document the enhancement.

2007-08-20  James Youngman  <jay@gnu.org>

	* doc/find.texi (Directories): Clarify that built commands which
	have not been executed yet will be executed before find quits,
	even with -quit.  Also clarify the difference between -prune and
	-quit.

2007-08-18  Eric Blake  <ebb9@byu.net>

	Fix Savannah bug #20751.
	* lib/listfile.c (list_file): Accomodate gnulib change of 3 Jul
	2006.
	* NEWS: Document this.
	Reported by Nigel Stepp.
	* THANKS: Sort and update.
	* AUTHORS: Add myself.

2007-08-05  Eric Blake  <ebb9@byu.net>

	Fix Savannah bugs #20662, #20688.
	* find/find.c (at_top): Avoid memory leak.
	* find/pred.c (do_fprintf, pred_iname, pred_name): Likewise.
	(pred_name_common): New function, factored from pred_iname and
	pred_name.
	* find/parser.c (check_name_arg): Let -nowarn silence -name /.
	* locate/locate.c (visit_basename): Avoid memory leak.
	* NEWS: Document the changes.
	* doc/find.texi (Warning Messages): Document -nowarn's effect on
	-name and -iname.
	* find/testsuite/find.gnu/name-slash.exp: New test, to ensure
	20662 doesn't regress on '-name /', and that 20688 silences the
	warning.
	* find/testsuite/find.gnu/printf-slash.exp: Likewise.
	* find/testsuite/find.gnu/name-slash.xo: Expected results.
	* find/testsuite/find.gnu/printf-slash.xo: Likewise.
	* find/testsuite/Makefile.am (EXTRA_DIST_XO, EXTRA_DIST_EXP):
	Distribute new tests.

2007-07-31  Eric Blake  <ebb9@byu.net>

	Allow choice of default arg size, Savannah bug #20594.
	* configure.ac (DEFAULT_ARG_SIZE): Check environment for a default
	size override.
	* lib/buildcmd.c (bc_use_sensible_arg_max): Use default size from
	configure, if requested.
	* README (DEFAULT_ARG_SIZE): Mention the ability to tune this at
	configure time.
	* NEWS: Document the change.

2007-07-29  James Youngman  <jay@gnu.org>

	* po/tr.po: Updated from Translation Project.

2007-07-26  Eric Blake  <ebb9@byu.net>

	* doc/.cvsignore: Ignore more generated documentation.

2007-07-23  Eric Blake  <ebb9@byu.net>

	* find/parser.c (parse_version): Avoid compiler warning.
	* locate/code.c (includes): Likewise.

2007-07-22  Eric Blake  <ebb9@byu.net>

	* po/POTFILES.in: Add lib/findutils-version.c.

2007-07-22  James Youngman  <jay@gnu.org>

	* find/find.1: Corrected a number of typos and fixed up the
	alphabetical section ordering.  This fixes Savannah bug #20552.

	Version banners now comply with the GNU coding standard.
	* find/parser.c (parse_version): Use display_findutils_version()
	instead of printing the information manually.  Don't include
	gnulib-version.h since we no longer directly use that header.
	* lib/findutils-version.c: Added
	* lib/findutils-version.h: Added
	* import-gnulib.config (modules): Added version-etc and
	version-etc-fsf.
	* lib/Makefile.am (libfind_a_SOURCES): added findutils-version.c.
	* find/version.c: Removed
	* find/Makefile.am: Remove version.c
	* locate/Makefile.am: Don't link ../find/version.o
	* xargs/Makefile.am: Ditto
	* xargs/xargs.c (main): Use display_findutils_version()
	* locate/code.c (main): Ditto
	* locate/frcode.c (main): Ditto
	* locate/locate.c (dolocate): Ditto
	* locate/updatedb.sh (version): Display copyright information in
	the right format.   Also ensure that we exit with a nonzero status
	if there was an output error for --help and --version.
	* find/testsuite/config/unix.exp (find_version): Adjust for
	--version format change
	* locate/testsuite/config/unix.exp (locate_version): Ditto
	* xargs/testsuite/config/unix.exp (xargs_version): Ditto
	* NEWS: Mention the change

2007-07-19  Eric Blake  <ebb9@byu.net>

	* po/POTFILES.in: Update to reflect current location of
	translatable strings.

2007-07-17  Eric Blake  <ebb9@byu.net>

	Ensure 'make distcheck' can pass on cygwin.
	* configure.in: Rename...
	* configure.ac: ...to this, to match automake recommendations.
	* NEWS: Add release dates.
	* doc/find-maint.texi: Remove trailing whitespace.
	(Documentation): Document where release dates are usefully
	recorded.
	* locate/Makefile.am (AM_INSTALLCHECK_STD_OPTIONS_EXEMPT): Be
	aware of .exe.
	* .cvsignore: Ignore 'make dist' files.
	* po/.cvsignore: Ignore remove-potcdate.sed.

2007-07-14  Eric Blake  <ebb9@byu.net>

	* import-gnulib.config (gnulib_version): Bump date, to pick
	up fix in canonicalize module testing.

2007-07-06  James Youngman  <jay@gnu.org>

	* po/uk.po, po/nl.po, po/vi.po: Updated from Translation Project.

2007-07-04  James Youngman  <jay@gnu.org>

	* NEWS: Fixed typos in description of bugfix for bug #20310.

2007-07-03  James Youngman  <jay@gnu.org>

	Fix Savannah bug #20310.
	* m4/nullsort.m4: If we are cross compiling, assume "sort -z" does
	not work on the target.

	Manpage improvements.
	* find/find.1: More consistent use of quotation marks.
	*  locate/locate.1 (HISTORY): New section.

2007-07-02  James Youngman  <jay@gnu.org>

	* import-gnulib.sh: (run_gnulib_tool): Don't pass --gpl3 to
	gnulib-tool, since the program does not have that option (that was
	a local change which proved not to be necessary).

	GPL3 migration.
	* COPYING: Migrate to version 3 of the GNU General Public license.
	* Makefile.am: ditto
	* build-aux/check-testfiles.sh: ditto
	* build-aux/src-sniff.py: ditto
	* debian/copyright: ditto
	* doc/find-maint.texi: ditto
	* find/defs.h: ditto
	* find/find.c: ditto
	* find/finddata.c: ditto
	* find/fstype.c: ditto
	* find/ftsfind.c: ditto
	* find/parser.c: ditto
	* find/pred.c: ditto
	* find/testsuite/config/unix.exp: ditto
	* find/tree.c: ditto
	* find/util.c: ditto
	* import-gnulib.config: ditto
	* import-gnulib.sh: ditto
	* lib/buildcmd.c: ditto
	* lib/buildcmd.h: ditto
	* lib/dircallback.c: ditto
	* lib/dircallback.h: ditto
	* lib/extendbuf.c: ditto
	* lib/extendbuf.h: ditto
	* lib/forcefindlib.c: ditto
	* lib/gnulib-version.h: ditto
	* lib/listfile.c: ditto
	* lib/listfile.h: ditto
	* lib/modetype.h: ditto
	* lib/nextelem.c: ditto
	* lib/nextelem.h: ditto
	* lib/printquoted.c: ditto
	* lib/printquoted.h: ditto
	* lib/qmark.c: ditto
	* lib/regexprops.c: ditto
	* lib/regextype.c: ditto
	* lib/regextype.h: ditto
	* lib/savedirinfo.c: ditto
	* lib/savedirinfo.h: ditto
	* lib/strspn.c: ditto
	* lib/wait.h: ditto
	* lib/waitpid.c: ditto
	* locate/bigram.c: ditto
	* locate/code.c: ditto
	* locate/frcode.c: ditto
	* locate/locate.c: ditto
	* locate/locatedb.h: ditto
	* locate/testsuite/config/unix.exp: ditto
	* locate/updatedb.sh: ditto
	* locate/word_io.c: ditto
	* po/fetch-po-files: ditto
	* xargs/testsuite/config/unix.exp: ditto
	* xargs/xargs.c: ditto

	Typo fixes.
	* doc/find.texi (Deleting Files): Fixed a typo.
	(Deleting Files): Likewise.

	New worked example for find.
	* doc/find.texi (Copying A Subset of Files): Added a new worked
	example.

	* doc/find.texi (Updating A Timestamp File): Indicate that %A@ now
	includes a sub-second part on many systems.

	Include <fcntl.h> unconditionally.
	* import-gnulib.config (modules): Also use the fcntl module.
	* find/find.c: #include <fcntl.h> unconditionally, since
	gnulib provides it if it is absent.
	* find/fstype.c: Likewise.
	* find/ftsfind.c: Likewise.
	* find/parser.c: Likewise.
	* find/util.c: Likewise.
	* locate/locate.c: Likewise.

2007-06-30  Eric Blake  <ebb9@byu.net>

	* find/pred.c (pred_timewindow): Avoid gcc warnings.
	(format_date): Likewise.
	* find/tree.c (calculate_derived_rates): Likewise.
	* locate/word_io.c (getword): Likewise.

2007-06-30  James Youngman  <jay@gnu.org>

	* find/find.1 (EXAMPLES): Added an example of using find and cpio -p
	to copy a directory tree, with pruning and omitted files.

	* find/pred.c (format_date): Use verify_true for constant
	conditions rather than assert.
	* xargs/xargs.c (main): Ditto.

	Enhancements to the code smell detector.
	* Makefile.am (findutils-check-smells): Automate the calling of
	build-aux/src-sniff.py.
	* build-aux/src-sniff.py: Rework to use a list of regex-based
	sniffers, to allow checking types of file other than C.  Allow
	file-based regex sniffers to give an indication of the line number
	where they think the problem (or part of the problem) exists.
	Added code smell detectors for a sample Bourne shell problem and
	for out-of-date FSF addresses.

	* find/tree.c (get_pred_cost): Eliminate unused variable.

	Fix Savannah bug #20263 in a more portable way.
	* find/tree.c (cost_table_comparison): Avoid casting function
	pointers to poiter-to-object, since this is not portable (or
	of course conforming).  Instead, use memcmp().

2007-06-28  Eric Blake  <ebb9@byu.net>

	* import-gnulib.sh (run_gnulib_tool): Speed operation when
	updating an existing tree.

	Allow 'make check' to work without prior 'make all'.
	* find/Makefile.am (SUBDIRS): Build in . before testsuite.
	* locate/Makefile.am (SUBDIRS): Likewise.
	* xargs/Makefile.am (SUBDIRS): Likewise.

	Fix Savannah bug #20273, xargs -E with seekable stdin.
	* import-gnulib.config (modules): Sort, add closein.
	* xargs/testsuite/Makefile.am (EXTRA_DIST_EXP, EXTRA_DIST_XO)
	(EXTRA_DIST_XI): Add new test.
	* xargs/testsuite/config/unix.exp (xargs_start): Support optional
	argument to allow test to run a subshell.
	* xargs/testsuite/inputs/sv-bug-20273.xi: New file.
	* xargs/testsuite/xargs.posix/sv-bug-20273.xo: Likewise.
	* xargs/testsuite/xargs.posix/sv-but-20273.exp: Likewise.
	* xargs/xargs.c (main): Use close_stdin, not close_stdout.
	* NEWS: Document the fix.

2007-06-27  James Youngman  <jay@gnu.org>

	Added a maintenance manual.
	* doc/find-maint.texi: New file.
	* doc/Makefile.am (info_TEXINFOS): Added doc/find-main.texi.
	* doc/find.texi (Introduction): Fixed typo.

2007-06-26  Eric Blake  <ebb9@byu.net>

	* import-gnulib.config (modules): Allow ./configure
	--disable-assert.

2007-06-26  James Youngman  <jay@gnu.org>

	* build-aux/src-sniff.py: Detect uses of struct stat where the
	header file was not included.
	* find/find.c: Fix this, and uses of assert without a following
	space (the coding standard requires a space, but there are still
	a number of cases where other functions are called with no
	following space).
	* find/fstype.c: Ditto.
	* find/ftsfind.c: Ditto.
	* find/parser.c: Ditto.
	* find/pred.c: Ditto.
	* find/tree.c: Ditto.
	* find/util.c: Ditto.
	* lib/buildcmd.c: Ditto.
	* lib/buildcmd.h: Ditto.
	* lib/extendbuf.c: Ditto.
	* locate/frcode.c: Ditto.
	* locate/locate.c: Ditto.
	* locate/word_io.c: Ditto.
	* xargs/xargs.c: Ditto.

	* find/tree.c (cost_table_comparison): Avoid < comparison between
	function pointer types.  Instead cast the function pointers to
	(const void*).  Both alternatives are undefined C, but the former
	actually fails to compile on some systems.   This fixes Savannah
	bug #20263.
	* NEWS: mention the fix

	* find/tree.c (calculate_derived_rates): Removed assignment to
	rate variable following an assert(0) call, which had been added to
	silence a "used before initialised" warning, and replace it with a
	call to abort, which (a) correctly halts execution if _NDEBUG is
	defined and (b) more accurately documents what's happening.

	* find/parser.c (get_stat_Ytime): Removed redundant call to abort.

	* find/util.c (debug_stat): For consistency, use assert (0) rather
	than assert (false).

2007-06-26  James Youngman  <jay@gnu.org>

	* README-alpha: Mention the findutils-patches mailng list and the
	archives for findutils-patches and bug-findutils.

	* po/bg.po: Updated from Translation Project.

2007-06-25  James Youngman  <jay@gnu.org>

	* po/sv.po: Updated Swedish translation.

2007-06-24  James Youngman  <jay@gnu.org>

	* build-aux/.gitignore, debian/.gitignore, doc/.gitignore,
	find/.gitignore, find/testsuite/.gitignore, .gitignore,
	lib/.gitignore, locate/.gitignore, locate/testsuite/.gitignore,
	m4/.gitignore, po/.gitignore, xargs/.gitignore,
	xargs/testsuite/.gitignore: New files to make it more painless to
	track findutils sources with git.

	* NEWS: Mention the previous change to doc/find.texi.

2007-06-23  James Youngman  <jay@gnu.org>

	* doc/find.texi (Introduction): Recommend that people check they
	are using the latest version before reporting a bug.

2007-06-22  James Youngman  <jay@gnu.org>

	Better documentation for the fractional part of seconds fields for
	-printf and similar actions.
	* doc/find.texi (Time Components): Point out that the seconds
	field of the timestamp is often printed out with a fractional part
	of unspecified length and precision.  The '%Tc' field has no
	seconds part.
	(Combined Time Formats): Point out the same thing for '%T@'.
	* find/find.1 (%A): Point out the same thing.
	* NEWS: Mention these changes.

	Fix various lint-type complaints taken from the rules in the
	coreutils Makefile.maint file (see build-aux/src-sniff.py).
	* xargs/xargs.c: Removed unnecessary parentheses in "#if defined"
	checks.
	(main): Don't cast the return value of xmalloc.
	(add_proc): Don't cast the return value of xmalloc.
	* lib/regextype.c: Don't include quotearg.h, we don't need it.
	* lib/dircallback.c, lib/nextelem.c, lib/prontquoted.c,
	lib/qmark.c, lib/strspn.c, lib/waitpid.c: Assume config.h is available.
	* lib/extendbuf.c: Ditto
	* lib/listfile.c: Ditto.  Also removed unnecessary parentheses in
	"#if defined" checks.
	(get_link_name): Don't cast the result of xmalloc.
	* lib/bigram.c: Removed unnecessary parentheses in "#if defined"
	checks.
	* lib/savedirinfo.c: Assume config.h is available.  Also removed
	unnecessary parentheses in "#if defined" checks.
	* lib/buildcmd.c (bc_do_insert): Don'tcast the result of xmalloc().
	* find/tree.c (build_expression_tree): Don't cast the argument to free().
	* find/ftsfind.c (set_close_on_exec): Removed unnecessary
	parentheses in "#if defined" checks.  Also changed "filesystem" ->
	"file system"
	* find/util.c (check_nofollow): Removed unnecessary parentheses in
	"#if defined" checks.
	* find/parser.c (estimate_fstype_success_rate): ditto.
	(insert_regex): Do not cast the result of xmaloc().  Removed unnecessary
	parentheses in "#if defined" checks.  Also changed "filesystem" ->
	"file system"
	* find/pred.c: ditto
	* find/find.c: "the the" -> "the", "filesystem" -> "file system"
	* find/fstype.c: "filesystem" -> "file system" (in comments and
	static functions)
	* locate/frcode.c: Removed unnecessary parentheses in "#if
	defined" checks.
	* locate/locate.c (search_one_database): Don't cast the return
	value of xmalloc.
	(dolocate): Mark error message for translation.

2007-06-21  Eric Blake  <ebb9@byu.net>

	* locate/.cvsignore: Ignore dblocation.texi.
	* build-aux/.cvsignore: Ignore Makefile.
	* locate/locate.c (set_max_db_age): Fix typo in error message.

2007-06-19  Eric Blake  <ebb9@byu.net>

	Fix compilation on cygwin, Savannah bug #20210.
	* import-gnulib.config (gnulib_version): Import strcasestr and
	updated canonicalize-lgpl-tests.
	* lib/dircallback.c (includes): Track gnulib changes.

2007-06-14  James Youngman  <jay@gnu.org>

	* find/parser.c (parse_time): Use the variable comp, which holds
	the planned comparison type, rather than the structure tval, which
	has not been initialised yet and contains a random value.  This
	fixes Savannah bug #20139.
	* NEWS: Mention the bugfix.

2007-06-13  James Youngman  <jay@gnu.org>

	* po/pl.po: Updated Polish translation.

2007-06-12  James Youngman  <jay@gnu.org>

	Release 4.3.8.

	* find/find.1 (HISTORY): Document when the find tests -readable,
	-writable, -executable and the option -regextype were introduced.

2007-06-12  Nix  <nix@esperi.org.uk> (tiny change)

	* locate/locate.c (drop_privs): Use groups[0] rather than
	groups[1], since groups[] is a one-element array.  This is a
	buffer overrun affecting root only.  In theory it could affect
	setuid installations, but I (James Youngman) cannot find an explot
	mechanism for it.  This fixes Savannah bug#20157.
	* NEWS: Mention this fix.

2007-06-12  James Youngman  <jay@gnu.org>

	Make the test suite work when run as root.
	* find/testsuite/config/unix.exp (fs_superuser): Abstract out the
	check which discovers if we have superuser privileges on the
	filesystem (taken from access.exp).
	* find/testsuite/find.gnu/access.exp: Call fs_superuser.
	* find/testsuite/find.gnu/fprint-unwritable.exp: Use fs_superuser.

	* po/vi.po, ga.po, nl.po: Updated translations
	* po/findutils.pot: Updated template file

2007-06-09  James Youngman  <jay@gnu.org>

	Release 4.3.7.

	Check that we can correctly read old-format databases which are
	big-endian or little endian.
	* locate/testsuite/config/unix.exp (locate_from_db): New function;
	supports testing locate against a provided database.
	* locate/testsuite/locate.gnu/bigendian.exp: New test; make sure
	we can read an old-format big-endian database.
	* locate/testsuite/locate.gnu/bigendian.xo: Expected output from
	bigendian.exp test.
	* locate/testsuite/locate.gnu/littleendian.exp: New test; make sure
	we can read an old-format little-endian database.
	* locate/testsuite/locate.gnu/locateddb.old.powerpc.xi: Old format
	big endian database file, for supporting bigendian.exp.
	* locate/testsuite/locate.gnu/littleendian.xo: Expected output from
	littleendian.exp test.
	* locate/testsuite/locate.gnu/locateddb.old.x86.xi: Old format
	little endian database file, for supporting littleendian.exp.
	* locate/testsuite/Makefile.am: Distribute littleendian.exp,
	bigendian.exp and related .xi and .xo files.


	* doc/find.texi (Size Directives): Compare %b with %s/512, not
	%s/1024.  This fixes (again) Savannah bug #19596.
	* NEWS: mention the fix.

	Avoid using the non-portable function putw().
	* locate/locatedb.h: Declare putword().
	* locate/frcode.c: Include <stdbool.h> as locatedb.h now requires
	it.
	* locate/code.c (main): Use putword() rather than putw(), because
	the latter was removed from SUSv3. This fixes Savannah bug #19980.
	Also include <stdbool.h> as locatedb.h now requires this.
	* locate/word_io.c (putword): Define the new function putword.

	Ensure that <config.h> is included before any system header
	* find/defs.h: Do not include <config.h> from "defs.h".  Instead
	just complain if it was not already included, since it needs  to
	be included first of all, even before system headers (in case
	gnulib had replaced a system header).  Check
	ALREADY_INCLUDED_CONFIG_H to determine this.
	* configure.in: Always define ALREADY_INCLUDED_CONFIG_H in
	config.h.
	* find/find.c: Include config.h before defs.h.
	* find/finddata.c: ditto.
	* find/fstfind.c: ditto.
	* find/parser.c: ditto.
	* find/pred.c: ditto.
	* find/util.c: ditto
	* find/tree.c: ditto (fixing Savannah bug #20128).

	* m4/noreturn.m4 (jy_AC_ATTRIBUTE_NORETURN): Use AC_LANG_PROGRAM
	inside AC_COMPILE_IFELSE.

	* doc/find.texi (Security Considerations for locate): Discuss in
	detail the buffer overrun when reading old-format locate
	databases.  This is CVE reference CVE-2007-2452.

2007-06-05  James Youngman  <jay@gnu.org>

	Guess the byte-order of old-format locate databases.
	* locate/word_io.c (getword): Make the endian_state_flag parameter
	an enum rather than an int.  If we are in the initial ("don't
	know") byte-order guessing state and the swapped value is out of
	range, use this as evidence that the byte order is native.
	* locate/locatedb.h: Declare getword accordingly.
	* locate/locate.c (struct process_data): Added endian_state
	member, which remembers for us what the big/little endian order
	guessing state is when we read an old-format database.
	(visit_old_format): Use the procdata.endian_state rather than a
	local variable, so that the information can persist across calls.
	(i_am_little_endian): Locate figures out if we needed to byteswap
	the words in an old-format database, but that is an implementation
	detail.  Therefore we figure out our own byte order so that we can
	produce a more relevant message for --statistics.  The
	i_am_little_endian() returns nonzero if the current host has
	little-endian byte order.
	(search_one_database): Report the byte-order of old-format
	databases.

2007-06-04  James Youngman  <jay@gnu.org>

	* locate/testsuite/Makefile.am (EXTRA_DIST_XO, EXTRA_DIST_EXP):
	Added old_prefix.exp and old_prefix.xo, a new test case for long
	shared rpefixes with the old database format.

	* locate/locate.c (visit_old_format): Use getword() from word_io.c
	instead of getw(), because getw() is not in POSIX.
	* locate/word_io.c: New file, providing replacement for getw().
	* locate/locatedb.h: Declare getword()
	* locate/Makefile.am (locate_SOURCES): Added word_io.c

	* locate/testsuite/config/unix.exp (locate_start): Make the
	failure messages slightly more explicit; indicate what went wrong
	when a test fails.

2007-06-03  James Youngman  <jay@gnu.org>

	* locate/locate.c (visit_old_format, extend, toolong): Extend the
	buffer used to build the current pathname when reading an
	old-format database.  The new function extend is called to do
	this.  The new function toolong is called to report a fatal error
	when the buffer size would otherwise exceed SIZE_MAX.  This fixes
	Savannah bug #20014, which is a security-related problem with the
	CVE identifier CVE-2007-2452.

	* configure.in: Determine if the setgroups function is available,
	and set HAVE_SETGROUPS if so.
	* locate/locate.c (drop_privs): Call setgroups() only if
	HAVE_SETGROUPS indicates that it is available.  This fixes
	Savannah bug #19981.

	* po/vi.po: Updated Vietnamese translation

2007-05-31  James Youngman  <jay@gnu.org>

	* find/parser.c (parse_time): Once we have determined the
	comparison type, restore the original time argument since
	get_relative_timestamp() also wants to see it.  This fixes
	Savannah bug #20005.

	* po/findutils.pot, ga.po, pt.po, tr.po, pl.po: updated from the TP
	website.

2007-05-31  Jakub Bogusz <qboosh@pld-linux.org>  (tiny change)

	* find/parser.c (parse_group): Correct typo in error message.
	(check_path_safety): same

2007-05-27  James Youngman  <jay@gnu.org>

	* import-gnulib.config (modules): Import sys_stat.
	(gnulib_version): Update to 2007-05-26.  This fixes a compilation
	error in stdlib.h with the DEC C compiler.  This fixes Savannah
	bug# 19983.

	* find/parser.c (safe_atoi): New function, like atoi, but which
	calls error(1, ...) when the argument is invalid or out of range.
	(parse_group): Use safe_atoi.
	(insert_depthspec): Use safe_atoi
	(parse_user): Use safe_atoi

	* configure.in: Check for fabs in libm (fixing a compilation error
	on Solaris).

	* import-gnulib.config (modules): Import the wcwidth module to
	provide it on those systems (such as BeOS) which lack it.

	* find/pred.c (file_sparseness): If st_blocks is not present in
	struct stat, the file has a sparseness of 1.0.

	* doc/find.texi (Size Directives): Document the %S format
	directive for -printf.

	* find/pred.c (mode_to_filetype): Don't use S_IFSOCK on systems
	which lack that macro.  POSIX systems are allowed to lack
	sockets (it's an XSI extension).
	(file_sparseness): If struct stat lacks st_blocks, assume all
	files have a spearseness of 1.0.

	* import-gnulib.config (modules): Import fchdir inorder to fix an
	undefined-symbol error for fchdir on BeOS.

2007-05-26  James Youngman  <jay@gnu.org>

	Code refactoring in locate.
	* locate/locate.c (visit): New function, into which we factor out
	the traversal of the inspector list.
	(process_simple): Use visit().
	(process_or): Use visit().
	(process_and): Use visit().

	Speed improvements in locate for unibyte locales.
	* locate/locate.c (visit_substring_match_nocasefold_wide): Renamed
	from visit_substring_match_nocasefold.
	(visit_substring_match_casefold_wide): Renamed from
	visit_substring_match_casefold.
	(visit_substring_match_casefold_narrow): Special case of
	visit_substring_match_casefold_wide which we use for unibyte
	locales; we use strcasestr() rather than mbscasestr().
	(visit_substring_match_nocasefold_narrow): Ditto, using strstr()
	instead of mbsstr().

	* find/parser.c (parse_gid): Return an explicit boolean constant
	rather than automatically converting from a pointer, because the
	gnulib substitute for bool (or _Bool) in c89 environments lacking
	bool does not support that conversion.  One affected system is Sun
	WorkShop Compilers 5.0 98/12/15 C 5.0 on Solaris 7.  This is
	Savannah bug #19970, reported by Nelson Beebe.
	(parse_inum): Ditto.
	(parse_links): Ditto.
	(parse_uid): Ditto.
	(check_path_safety): declarations need to go before code, not
	interspersed.  Move declaration of char* s.

	* xargs/testsuite/xargs.posix/rc-125.exp: Explain Savannah bug
	#19969.   This bug is not yet fixed.

	* find/defs.h: #include <stdint_.h>, for uintmax_t.  This should
	fix a compilation error on DEC C V5.9-005 on Digital UNIX V4.0F
	(Rev. 1229).  This is Savannah bug #19965, reported by Nelson
	Beebe.

	* find/defs.h: Don't include <errno.h>, since it is not needed in
	the header file itself.  The "extern int errno;" declaration is
	now obsolete.
	* find/parser.c: Include <errno.h>
	* find/pred.c: Dito
	* find/util.c: Ditto

2007-05-24  James Youngman  <jay@gnu.org>

	* find/util.c (check_nofollow): If O_NOFOLLOW is defined but 0,
	act as if it is undefined.  This should prevent a runtime
	assertion failure on IRIX 6.5.  This fixes Savannah bug #19948,
	reported by Nelson Beebe.

	* m4/noreturn.m4: New file, testing for support of __attribute__
	((__noreturn__)).  Defines jy_AC_ATTRIBUTE_NORETURN and sets
	HAVE_ATTRIBUTE_NORETURN.
	* configure.in: Call jy_AC_ATTRIBUTE_NORETURN.
	* find/defs.h (ATTRIBUTE_NORETURN): Define to nothing if
	HAVE_ATTRIBUTE_NORETURN is not set in config.h.  This should fix a
	compilation error with non-GCC compilers.   This is Savannah bug
	#19967, reported by Nelson Beebe.

	* configure.in (FINDLIBS): Update FINDLIBS to link against -lm for
	modf.   This fixed a link error on HP-UX.   This fixes Savannah
	bug #19966, reported by Nelson Beebe.
	* find/Makefile.am (LDADD): Use @FINDLIBS@

2007-05-21  James Youngman  <jay@gnu.org>

	Release 4.3.6.

	* build-aux/Makefile.am (EXTRA_DIST): Added man-lint.sh.

	* locate/locate.c (drop_privs): pass the correct list of groups to
	setgroups().  Previously, if root invoked locate, their group ID
	would have been set to a random value.  The same bug also caused
	an array overrun past the end of the local array groups[].  The
	variable which gets overwritten by the buffer overrun on x86 is
	'what'.  The value of that variable is always changed before it is
	used, and so I believe that this buffer overrun will not cause a
	crash.  The only effect of the bug therefore would be for locate
	to change group to a random group ID since groups[0] is
	uninitialised.  On my test system this random group ID is 0
	anyway.  The effect does not depend on any externally-controllable
	information, so it is unlikely this is exploitable.   This bug is
	detailed as bug# 19923.

2007-05-19  James Youngman  <jay@gnu.org>

	* find/find.1: Spurious .R directives (.R is not a directive)
	should be .B.   This fixes Savannah bug #19871.
	* build-aux/man-lint.sh: New file; verifies that the specified
	manual pages do not provoke error messages from troff.  This is
	used to detect further occurrences of Savannah bug #19871.
	* find/Makefile.am (dist-hook): Run findutils-check-manpages,
	which invokes man-lint.sh.
	* locate/Makefile.am (dist-hook): ditto
	* xargs/Makefile.am (dist-hook): ditto

	* .cvsignore: Ignore ylwrap, which automake-1.10 wants us to have
	a copy of for some reason

	* import-gnulib.sh (main): New option -a which just runs the
	autotools without reimporting gnulib.

	* Makefile.am (jy-regex-fix): The previous explanatory comment
	refers to the jy-regex-fix target, not to dist-hook, so it has
	been moved.

2007-05-08  James Youngman  <jay@gnu.org>

	* find/defs.h (struct predicate.args): str is now const.

	* find/parser.c (get_comp_type): get_comp_type now takes a const
	char* parameter.
	(get_num): ditto
	(get_relative_timestamp): ditto.  Also use collect_arg().
	(collect_arg_stat_info): New function; collects a command-line
	argument and returns its xstat information, in one go.
	error(1,...)  is called if the stat fails.
	(parse_anewer): Use collect_arg().
	(parse_cnewer): ditto
	(parse_fprint): ditto
	(parse_fstype): ditto
	(parse_group): ditto
	(parse_ilname): ditto
	(parse_iname): ditto
	(parse_iwholename): ditto
	(parse_lname): ditto
	(insert_depthspec): ditto
	(parse_name): ditto
	(parse_newer): ditto
	(parse_wholename): ditto
	(parse_perm): ditto
	(parse_regextype): ditto
	(insert_regex): ditto
	(parse_samefile): ditto
	(parse_used): ditto
	(parse_user): ditto
	(insert_type): ditto
	(parse_time): ditto
	(parse_size): When the size argument is invalid but consists only
	of a valid suffix char, avoid issuing an error message about a
	blank argument.  Append the suffix letter again.
	(parse_xdev, parse_ignore_race, parse_noignore_race, parse_warn,
	parse_xtype): Remove casts to void for some function parameters
	that were, in fact, used.

	* find/testsuite/find.gnu/fprint-unwritable.exp: new test
	* find/testsuite/find.gnu/fprint0_stdout.exp: new test
	* find/testsuite/find.gnu/fprint0_stdout.xo: new test
	* find/testsuite/find.gnu/mindepth-arg.exp: new test
	* find/testsuite/find.gnu/mindepth-arg.xo: new test
	* find/testsuite/find.gnu/mindepth-badarg.exp: new test
	* find/testsuite/find.gnu/print_stdout.exp: new test
	* find/testsuite/find.gnu/print_stdout.xo: new test
	* find/testsuite/find.gnu/samefile-missing.exp: new test
	* find/testsuite/find.gnu/samefile-p-brokenlink.exp: new test
	* find/testsuite/find.gnu/samefile-p-brokenlink.xo: new test
	* find/testsuite/find.gnu/used-invarg.exp: new test
	* find/testsuite/find.gnu/used-missing.exp: new test
	* find/testsuite/find.gnu/user-invalid.exp: new test
	* find/testsuite/find.posix/group-empty.exp: new test
	* find/testsuite/find.posix/group-missing.exp: new test
	* find/testsuite/find.posix/name-missing.exp: new test
	* find/testsuite/find.posix/size-invalid.exp: new test
	* find/testsuite/find.posix/size-missing.exp: new test
	* find/testsuite/find.posix/typearg.exp: new test
	* find/testsuite/find.posix/user-empty.exp: new test
	* find/testsuite/find.posix/user-missing.exp: new test

2007-05-06  James Youngman  <jay@gnu.org>

	* find/tree.c: (costlookup): Added pred_fls to the optimiser's
	predicate cost lookup table.

	* lib/printquoted.c (print_quoted): Change return value from void
	to int, to allow the caller to detect failures.
	* lib/printquoted.h (print_quoted): Change declaration
	accordingly.

	* find/defs.h (struct format_val): Incldue a 'filename' member so
	that we can provide more useful error messages (e.g. when we fail
	to flush or close an output file).
	(nonfatal_file_error): declare new function.

	* find/util.c (traverse_tree): Utility function which calls a
	callback on every node of the parse tree.
	(flush_and_close_output_files): Flush all output streams.  Close
	all output files.  Report any errors.
	(cleanup): Use traverse_tree() to invoke
	complete_pending_execdirs().
	(report_file_err): refactored error reporting function, extracted
	from fatal_file_error.
	(nonfatal_file_error): New function.

	* find/pred.c (checked_fprintf): New function, which performa an
	fprinf(), and checkes the result.  If the operation resulted in an
	error, a nonfatal error message is issued.
	(checked_print_quoted): Ditto, for print_quoted rather than
	fprintf.
	(checked_fwrite): Ditto for fwrite instead of fprintf.
	(checked_fflush): Ditto for fflush
	(do_fprintf): Use the checked_*() functions rather than their
	direct counterparts, to ensure that I/O errors are detected.  This
	fixes Savannah bug #19416.
	(pred_fls): Use args.printf_vec instead of args.stream, which has
	now been removed.
	(pred_ls): just call pred_fls.
	(pred_fprint0): use args.printf_vec, instead of the now removed
	args.stream.
	(pred_print0): just call pred_fprint0

	* find/parser.c: (insert_fprintf): Make the caller collect the
	format argument from the argument list.
	(open_output_file): Enhance to set up defaults in
	our_pred->args.printf_vec as well as opening the output file.
	Also record the filename for possible later use in an error
	message.
	(collect_arg): Convenience function for collecting an argument
	from the argument list.
	(insert_fls): Refactored the body of parse_fls out so that
	parse_ls can use it.
	(parse_fls): call insert_fls.
	(parse_ls): ditto
	(parse_fprint): Instead of setting up our_pred->args.printf_vec
	manually, call open_output_file() to do it.
	(parse_print): Same, but by calling open_stdout().
	(insert_fprint): Make the caller collect the filename argument,
	and delegate the setup of our_pred->args.printf_vec to either
	open_output_file() (for parse_fprint and parse_fprint0) or
	open_stdout (parse_print0).
	(parse_fprint0): Use collect_arg().
	(parse_print0): Use insert_fprint(), just like parse_fprint0.
	(parse_printf): Use collect_arg().
	(parse_fprintf): Use collect_arg().

2007-05-05  James Youngman  <jay@gnu.org>

	Release 4.3.5.

	* find/parser.c (parse_samefile): Hold a file descriptor open on
	the reference file in order to prevent pred_samefile getting
	fooled by inode reuse.  Pay attention to race conditions on
	systems lacking O_NOFOLLOW when the -P option is in force.  This
	fixes Savannah bug #19806.

	* find/defs.h (struct samefile_file_id): New struct, like dir_id
	but including a file descriptor on the reference file.

	* find/pred.c (pred_type): -type should return false if the file
	has mode 00000, as opposed to having an assertion failure.   This
	fixes Savannah bug #16378.

	* find/ftsfind.c (consider_visiting): Issue a warning message if
	none of the mode bits are set for a file (i.e. st_mode==00000).
	* find/util.c (get_statinfo): ditto
	* find/util.c (hook_fstatat): Introduced debug code (normally
	disabled) for testing Savannah bug #16378.

2007-05-01  James Youngman  <jay@gnu.org>

	* find/find.c (wd_sanity_check): corrected the type of %ld fprintf
	arguments in error messages.
	* find/fstype.c: include "error.h" for the declaratio of error().
	* find/ftsfind.c: include "error.h" for the declaratio of
	error().  Include dircallback.h for the correct declararion of
	run_in_dir().
	* find/parser.c: include getdate.h (for declaration of getdate)
	and error.h (for the declaration of error).
	(find_parser): Removed unused variable p.
	* find/pred.c (pred_timewindow): Removed unused variable delta.
	(do_fprintf): Removed unused variable cc.
	* find/tree.c: Include error.h (for the declaration of error()).
	(build_expression_tree): removed sourious extra arguments in call
	to error().
	* find/util.c: include error.h.
	* lib/buildcmd.h (get_line_max): Comment out unused function.
	* lib/listfile.c: Include dircallback.h.
	* locate/code.c: Include errno.h, erorr.h, progname.h and
	xlloc.h.
	(inerr): New function for reporting read errors.
	(outerr): New function for reporting output errors.
	(main): Call inerror when fgets fails.  Call outerr when fwrite
	or putc or putw fails.
	* locate/frcode.c (put_short): Return boolean value indicating
	success.
	(outerr): New function for reporting write errors.
	(main): Call outerr if call to putc() or puts() or put_short()
	fails.
	* locate/locate.c (search_one_database): diagnose corruption if a
	traditional-style database is too short to include a complete
	bigram table.

2007-04-30  James Youngman  <jay@gnu.org>

	* find/defs.h: Change all predicate functions to take a const
	char* argument as the pathname, not a char*.  Modify the parser
	table definition accordingly.
	* find/parser.c: Ditto
	* find/pred.c: Ditto
	* find/pred.c (do_fprintf): copy the pathname string for the %H
	and %h cases, since we can no longer modify the string in place.
	* lib/listfile.c (print_name, list_file,
	print_name_without_quoting, print_name_with_quoting): Use const
	char * param for pathname.
	* lib/listfile.h (list_file): Use const char * param for
	pathname.

2007-04-29  James Youngman  <jay@gnu.org>

	* find/defs.h: Declare fatal_file_error(), a function for
	reporting immediately-fatal file errors, which appropriately
	quotes the file name.  The function does not return.  Also define
	ATTRIBUTE_NORETURN.  Record the currently-required quoting style
	in struct options.

	* find/find.c, find/ftsfind.c, find/parser.c, find/pred.c,
	find/util.c: Call fatal_file_error() for fatal file errors.  Use
	quotearg_n_style() to quote filenames which are used in error
	message that aren't fatal.  Use options.err_quoting_style as the
	quoting style.  This fixes Savannah bug #18203.
	* locate/locate.c: ditto
	* xargs/xargs.c: ditto

	* lib/listfile.c: To use alloca, just #include <alloca.h>.  Gnulib
	handles the rest.  Also these days, <stdlib.h> and <string.h> can
	just be included unconditionally.
	* lib/qmark.c: Fixed comment on first line describing the module.

2007-04-29  Michael Haubenwallner <michael.haubenwallner@salomon.at> (tiny change)

	* find/defs.h (pred_open) Rename to pred_openparen to avoid
	problems with the macrtos which build the parser tabnles on
	platforms where 'open' is in fact a macro whcih expands to
	open64.   The problem was that token pasting put pred_open64 into
	the parser table, but the function was still defined as
	parse_open.   This fixes Savannah bug #19371.
	(pred_close): ditto
	* find/parser.c (parse_open, parse_close): ditto.  Also change
	repferences to pred_open and pred_close similarly.
	* find/parser.c (parse_openparen, parse_closeparen): ditto

2007-04-28  James Youngman  <jay@gnu.org>

	* find/testsuite/find.gnu/deletedir.exp,
	find/testsuite/find.gnu/deletedir.xo: New test.
	* find/testsuite/find.gnu/deletefile.exp,
	find/testsuite/find.gnu/deletefile.xo: New test.
	* find/testsuite/Makefile.am: Distribute the new tests
	deletefile.exp and deletedir,exp, with their expected-output (.xo)
	files too.
	* find/testsuite/config/unix.exp (find_start): Add a new "setup"
	parameter called just before each time find is invoked.  This
	allows last-minute tasks to be performed.  This feature is
	essential for find commands that modify the filesystem, since
	otherwise we cannot use our strategy of invoking both binaries at
	each optimisation level.

	* find/util.c (optionh_stat, optionp_stat, optionl_stat): Assert
	that state.cwd_dir_fd is valid.

	* find/parser.c (parse_delete): Set need_stat to false, since we
	don't need the stat information in pred_delete.
	* find/pred.c (pred_delete): If unlinkat() with a zero flags
	parameter fails with errno==EISDIR, just try again with
	flags=AT_REMOVEDIR.  That way we normally avoid the cost of a
	stat.  If we happen to have the stat information to hand anyway,
	we make sure we get it right the first time.

	* lib/buildcmd.c (bc_init_controlinfo): Eliminate confusing extra
	variable arg_max.  Add return value
	BC_INIT_CANNOT_ACCOMODATE_HEADROOM for the case where the
	environment itself is not too large, but the required headroom
	cannot also be accomodated.  The caller now passes in the amount
	of headroom required.
	(bc_use_sensible_arg_max): Use the environment size consistently;
	this is accounted for already in posix_arg_size_max, so there is
	no need to re-measure the size of the environment.
	* lib/buildcmd.h: Define BC_INIT_CANNOT_ACCOMODATE_HEADROOM and
	add the headroom parameter to the prototype of bc_init_controlinfo().
	* xargs/xargs.c (main): Define XARGS_POSIX_HEADROOM as 2048 and
	use that symbolic value.  Pass XARGS_POSIX_HEADROOM to
	bc_init_controlinfo().  Handle the case where
	BC_INIT_CANNOT_ACCOMODATE_HEADROOM is returned by
	bc_init_controlinfo().
	* find/parser.c (new_insert_exec_ok): Pass the required headroom to
	bc_init_controlinfo() and handle the error return
	BC_INIT_CANNOT_ACCOMODATE_HEADROOM.

	* xargs/xargs.1: Correct the description of the default value and
	maximum value for the -s option of xargs.

	* xargs/xargs.c (main): Modify the assertions not to assume that
	bc_ctl.arg_max is 2KiB less than ARG_MAX, since sysconfig() may
	have returned a value for _SC_ARG_MAX which is greater.  For
	example, AIX 5.3 can do this.  This should fix Savannah bug
	#19391.

2007-04-25  James Youngman  <jay@gnu.org>

	* find/tree.c (predlist_dump, predlist_merge_nosort): These
	functions were unused and commented out.  Removed.
	(mark_stat) No longer used.  Removed.
	(mark_type) No longer used.  Removed.

	* find/parser.c (new_insert_exec_ok): When checking for {} in the
	arguments to -exec..., use mbsstr() rather than strstr() in order
	to cope bettwe with multibyte locales.

	* lib/buildcmd.c: Don't define mbsstr() locally.  Instead, call
	gnulib's mbsstr().

2007-04-24  James Youngman  <jay@gnu.org>

	* lib/buildcmd.c: Added some comments outlining how we might
	change the implementation to support figuring out the real ARG_MAX
	limit.

2007-04-23  James Youngman  <jay@gnu.org>

	* find/defs.h (struct predicate_performance_info): New data
	structure for holding perofmance statistics.
	(struct predicate: include predicate_performance_info
	(apply_predicate): change from macro to function
	(pred_is): new macro, for predicate identity testing
	(enum DebugOption): Added DebugSuccessRates
	* find/find.1: Document option "-D rates" which turns on
	DebugSuccessRates.
	* doc/find.texi: ditto
	* find.c (main): Call show_success_rates() before exiting.
	(apply_predicate): remove the macro defintion, declare equivalent
	function in defs.h.
	* find/ftsfind.c (main): Call show_success_rates() before
	exiting.  Use apply_predicate().
	(show_outstanding_execdirs): use pred_is().



2007-04-22  Eric Blake  <ebb9@byu.net>

	* xargs/xargs.c (main): Don't assume LINE_MAX exists (i.e. is
	#defined).

	* locate/updatedb.sh (PRUNEPATHS): Exclude /proc by default.

2007-04-22  James Youngman  <jay@gnu.org>

	* doc/Makefile.am: When cross-compiling, 'make clean' should not
	delete doc/regexprops.texi, becaue we can't regenerate it.  Fixes
	Savannah bug #19658.

	* locate/Makefile.am (BUILT_SOURCES): Automatically generate
	dblocation.texi, which records the default database location.
	* doc/find.texi: Collect the default database location from
	../locate/dblocation.texi, and use LOCATE_DB in various places.
	Document the fact that updatedb can generate slocate-compatible
	databases.  Document the --dbformat option of updatedb.
	* locate/frcode.c (main): Implemented the -S option which allows the
	generation of an slocate secure database.
	* locate/updatedb.sh: New option --dbformat which selects which
	database format to use.
	* locate/updatedb.1 (--dbformat): Document the new option.


	* find/testsuite/find.gnu/access.exp: fixed a typo which prevented
	the test correctly being skipped when run as root.   This re-fixes
	Savannah bug# 18414, I hope.

2007-04-21  James Youngman  <jay@gnu.org>

	Release 4.3.4.

	* find/locate/locatedb.5: Clarifications to the description of the
	LOCATE02 format.  Organised the material under a number of
	headings.  Documented the slocate database format.

2007-04-21  James Youngman  <jay@gnu.org>

	* find/testuite/Makefile.am (EXTRA_DIST_EXP): added
	find/testsuite/find.posix/sv-bug-19617.exp

2007-04-20  Maxim V. Dziumanenko <dziumanenko@gmail.com>

	* po/uk.po: New Ukranian translation.
	* configure.in: Added "uk" for Ukranian.

2007-04-19  Peter Breitenlohner <peb@mppmu.mpg.de> (tiny change)

	* locate/bigram.c (main): Set the initial pathname to the empty
	string, to avoid decompression problems if the initial pathname
	begins with a space.  This fixes Savannah bug #19484.
	* locate/code.c (main): ditto

2007-04-19  James Youngman  <jay@gnu.org>

	* locate/updatedb.1 (--help): Option name should be bold, not
	italic.

	* find/testsuite/find.gnu/execdir-hier.exp: Avoid running
	-execdir based tests if "." is on $PATH.  Fixes Savannah bug
	#19634.
	* find/testsuite/find.gnu/execdir-in-unreadable.exp: ditto

	* find/testsuite/config/unix.exp (touch): New procedure touch,
	replacing "exec touch" for greater efficiency.
	* find/testsuite/find.posix/depth1.exp: Change "exec touch" to
	"touch".
	* find/testsuite/find.posix/files-not-expressions1.exp: ditto
	* find/testsuite/find.posix/files-not-expressions2.exp: ditto
	* find/testsuite/find.posix/files-not-expressions3.exp: ditto
	* find/testsuite/find.posix/links.exp: ditto
	* find/testsuite/find.posix/perm-vanilla.exp: ditto
	* find/testsuite/find.posix/sv-bug-15235.exp: ditto
	* /find/testsuite/find.posix/sv-bug-19613.exp: ditto

	* find/testsuite/find.gnu/access.exp: Fix savannah bug #18414 by
	skipping the test if the user can read any file (e.g. is root or
	is an Admin user under Cygwin).

2007-04-17  James Youngman  <jay@gnu.org>

	* import-gnulib.config (gnulib_version): Use the 2007-04-17
	version of gnulib to fix a compilation error on Cygwin.  This
	fixes Savannah bug #19619.

	* find/testsuite/find.posix/sv-bug-19605.exp: New test, for
	Savannah bug #19605.
	* find/testsuite/find.posix/sv-bug-19617.exp: New test, for
	Savannah bug #19617.
	* find/ftsfind.c (consider_visiting): if fts_read() returns
	enf->fts_info==FTS_NS, check for and diagnose a symbolic link
	loop.  This fixes Savannah bugs #19605 and #19617.

	* find/find.c (process_path): collect the stat information for
	directories even if we already have the mode information, because
	we need to use the members st_nlink and st_rdev in for the leaf
	optimisation and loop detection, respectively.  This fixes
	Savannah bug #19616.

	* find/ftsfind.c (is_fts_enabled): Return a copy of ftsoptions,
	not a copy of the (uninitialised) input argument.  This fixes
	Savannah bug #19615.

	* find/ftsfind.c (consider_visiting): If fts_read() returned
	FTS_NS, then remember that the stat information is not valid, and
	therefore don't set state.have_type or state.have_stat.  This
	fixes Savannah bug #19613.

	* find/testsuite/find.posix/sv-bug-91613.exp,
	* find/testsuite/find.posix/sv-bug-91613.xo: New test for Savannah
	bug 19613 (assertion failure on symbolic link loop).

	* find/testsuite/config/unix.exp: Correctly diagnose a test case
	which fails because find was expected to fail and instead
	succeeded.
	* find/testsuite/find.gnu/exec-many-rtn-failure.exp: The child
	process in this test should return non-zero, not zero.  Therefore
	run "false" instead of "true".

2007-04-15  James Youngman  <jay@gnu.org>

	Release 4.3.3.

	* find/find.1: "-printf %b": blocks are 512 bytes.   Fixes
	Savannah bug #19596.

	* doc/Makefile.am (regexprops.texi): Do not use $(RM) because many
	versions od make do not set it, and so it expands to nothing.
	This avoids suprious emission of the regexprops.texi file to stdout.

	* find/find.c (main, safely_chdir_lstat, safely_chdir_nofollow):
	Only use O_LARGEFILE if it is #defined (NetBSD-3.1 does not define
	it).
	* find/ftsfind.c (main): ditto
	* find/pred.c (pred_empty, prep_child_for_exec): ditto


	* import-gnulib.config: Update to gnuliv 2007-04-14.

	* lib/Makefile.am, import-gnulib.sh: Create lib/gnulib-version.c
	in import-gnulib.sh, not in lib/Makefile.

	* build-aux/Makefile.am: New file; distribute check-tstfiles.sh.

	* locate/Makefile.am: mkinstalldirs is now in build-aux.

	* doc/Makefile.am: We also need getdate.texi.

2007-04-14  James Youngman  <jay@gnu.org>

	* doc/.cvsignore: Ignore getdate.texi

	* find/defs.h: #include "buildcmd.h" near the top of the file, not
	in the middle.

	* all: Pass O_LARGEFILE when opening directories.

	* all: Changes to allow us to use the FTS_CWDFD mode of fts().
	These are quite extensive changes, and are detailed below.

	* find/defs.h (struct exec_val): New member dirfd, the directory
	in which the exec should take place.
	(is_fts_enabled): Tell the caller which flags are passed to
	fts_open().
	(get_start_dirfd): New function.  Returns value of start_desc.
	(get_current_dirfd): New function.  Returns the fd of the
	directory fts is currently traversing.  If this is the current
	directory, AT_FDCWD is returned.
	(complete_pending_execdirs): takes a new argument, indicating
	where the exec is to take place.  Ugh.
	(get_info): the file name is taken from state.rel_pathname, so
	we don't need it as a function argument.
	(enum DebugOption): Added DebugExec ("-D exec").
	(struct state): Added cwd_dir_fd, the directory we are examining
	with fts().  If fts() is not in use, this is AT_FDCWD.  Also added
	execdirs_outstanding, which is a boolean which tells us if there
	are any not-yet-execed -execdir or -okdir actions (with +).  This
	is not really used yet.
	* find/ftsfind.c (set_close_on_exec): New function.
	(get_current_dirfd): Return an fd open on the directory that fts()
	is currently examining.
	(left_dir): Signal that our previous ides of which dirctory fts is
	searching is now out of date.
	(inside_dir): Indicate which directory fts is now searching.
	(complete_execdirs_cb): Callback for run_in_dir() to complete
	pending execdirs in this directory.
	(show_outstanding_execdirs): Supports "-D exec"
	consider_visiting(): Do not allow building-up of pending execdirs,
	as a workaround to Savannah bug #18466.
	(ftsoptions): Make this a static module variable.
	* find/parser.c (insert_exec_ok): New parameter describing which
	directory the exec should occur in.
	(parse_version): for FTS, add a list of options being used.
	* find/pred.c (pred_and, pred_comma): No need to pass the relative
	path name to get_info(), it can pull it from state.rel_pathname.
	(pred_delete): use unlinkat().
	(pred_empty): use openat().
	(new_impl_pred_exec): Accept an fd parameter describing where the
	exec is to take place.
	(pred_executable, pred_writable, pred_readable): Use run_in_dir()
	to ensure that access() is called in a working directory which is
	suitable for the pathname we pass in.
	(prep_child_for_exec): In the child process, change to the
	appropriate directory becore the exec().
	* find/util.c (debugassoc): Support "-D exec".
	(get_info): No longer need to pass the relative path to
	get_statinfo().
	(do_complete_pending_execdirs): Refactored body of what used to be
	complete_pending_execdirs().
	(complete_pending_execdirs): Pull body out into
	do_complete_pending_execdirs() and call that only if there is work
	to do.
	(fallback_stat, optionh_stat, optionp_stat, optionl_stat): Use fstatat().
	(get_start_dirfd): New access function for starting_desc.
	* find/testsuite/find.gnu/execdir-hier.exp: New test
	* find/testsuite/find.gnu/execdir-hier.xo: Expected outut for new test
	* lib/dircallback.c, lib/dircallback.h: New function,
	run_in_dir(), which runs a callback function in a specified
	directory.
	* lib/listfile.c: Use run_in_dir() to call readlink() in the right
	directory.
	(get_link_name_at): Call get_link_name_cb via run_in_dir.
	(get_link_name_cb): New callback function, wrappting
	get_link_name().

	* find/testsuite/find.gnu/execdir-pwd.exp: Since we have disabled
	thebuilding-up of command lines for -execdir, Savannah bug #18466
	has been neutralised (but not fixed - we just don't allow the
	problem circumstance to occur).

2007-04-09  James Youngman  <jay@gnu.org>

	* doc/find.texi: Change fully-specified @node directives to
	single-argument @node directives in order to accomodate the
	inclusion of getdate.texi.

	* doc/find.texi: Document -newerXY.

	* doc/find.texi (Security Considerations): updated to describe
	differences in the fts-based implementation.

	* find/find.1: Indicate that testing the birth time where this is
	not supported produces a negative result for files where the birth
	time is not known (or a fatal error if the file of interest is a
	reference file).

2007-04-08  James Youngman  <jay@gnu.org>

	* configure.in: Set @AUXDIR@ (to the location of the build-aux
	directory).
	* build-aux/check-testfiles.sh: New script, which checks that all
	the DejaGnu test files have been included in the distribution and
	(more helpfully) lists any that are missing.
	* Makefile.am (findutils-check-testfiles): Use
	build-aux/check-testfiles.sh.
	* locate/testsuite/Makefile.am (EXTRA_DIST_EXP): distribute
	locate/testsuite/locate.gnu/sv-bug-14535.exp.

	* config.rpath, depcomp, missing: Moved into build-aux/.
	* configure.in(AC_CONFIG_AUX_DIR): Find aux files in $SRCDIR/build-aux,
	not in $SRCDIR.

2007-03-31  James Youngman  <jay@gnu.org>

	* find/tree.c (build_expression_tree): Issue more specific error
	messages; distinguish the case where the predicate is invalid from
	the cases where a required argument is missing, and a supplied
	argument is invalid.

	* import-gnulib.config (gnulib_version): Update to 2007-03-30
	version of gnulib.

2007-03-28  James Youngman  <jay@gnu.org>

	* find/defs.h (set_stat_placeholders): utility function for
	initialising the sturct stat fields that NetBSD doesn't always set
	(like st_birthtime where the file is on a filesystem not
	supporting birthtime).
	* find/util.c: set_stat_placeholders(): new function
	(get_statinfo): Call set_stat_placeholders().
	(optionh_stat, optionl_stat, optionp_stat): ditto
	* find/find.c (main, wd_sanity_check, safely_chdir_lstat,
	process_dir): use set_stat_placeholders().
	* find/parser.c (parse_anewer, parse_cnewer, parse_newer,
	parse_newerXY): ditto.
	(get_stat_Ytime): Support birth time ('B').
	(parse_newerXY): Support st_birthtime.
	* find/fstype.c (set_fstype_devno): Use set_stat_placeholders().
	* find/pred.c (pred_xtype): Use set_stat_placeholders().
	(pred_newerXY): Support birth time.
	(pred_fprintf, format_date): ditto ("%Bx").

2007-03-25  James Youngman  <jay@gnu.org>

	* xargs/xargs.c (main): For "xargs --show-limits" where stdin is a
	terminal, warn the user that the program specified (or /bin/echo)
	will be run at least once, if that is what will happen.

2007-03-24  James Youngman  <jay@gnu.org>

	* import-gnulib.sh: Added option -d, allowing the user to use a
	local version of gnulib, perhaps because they have local changes.

2007-03-13  James Youngman  <jay@gnu.org>

	* find/parser.c (parse_quit): Estimated success rate of -quit is
	100%.

2007-03-08  James Youngman  <jay@gnu.org>

	* find/find.1 (TESTS): Document -newerXY, indicate that reference
	files are only examined once.
	(HISTORY): Indicate when various features were added
	(BUGS): Indicate that -ok ignores LC_COLLATE.

2007-03-07  James Youngman  <jay@gnu.org>

	* import-gnulib.config: (gnulib_version): Use gnulib version
	2007-03-05
	(modules): Added getdate

	* find/Makefile.am (LDADD): Added @LIB_CLOCK_GETTIME@ for
	clock_gettime(), if it is available.

	* find/defs.h: (enum xval): New enumeration, representing the
	value of X used in the -newerXY test.  It is stored in the reftime
	member of 'union args'.
	(struct predicate): reftime is also used by -newerXY.
	(enum arg_type): Added ARG_SPECIAL_PARSE for -newerXY, because the
	parsing function needs to look at the name of the test.
	(struct options): start_time is now a struct timespec, not a
	time_t.

	* find/parser.c: (parse_newerXY): New parsing function for
	-newerXY, a feature copied from FreeBSD (also present other BSD
	implementations too)
	(get_stat_Ytime): New function; returns st_atime, st_mtime or
	st_ctime from struct stat, as a timespec, as required according to
	the value of Y in -newerXY.
	(found_parser): Factored the tail out of find_parser.
	(find_parser): Moved tail into found_parser.  Add special handling
	for -newerXY.
	(do_parse_xmin): New argument xv, indicating the value to which
	predicate->reftime.xval should be set.
	(parse_amin): Pass XVAL_ATIME to do_parse_xmin.
	(parse_cmin): Pass XVAL_CTIME to do_parse_xmin.
	(parse_mmin): Pass XVAL_MTIME to do_parse_xmin.
	(parse_newer): Set args.reftime.xval to XVAL_MTIME.

	* find/pred.c (pred_table): added pred_XY.
	(pred_fls): options.start_time is now a struct timespec, so just
	pass the tv_sec member to list_file.
	(pred_ls): ditto
	(pred_newerXY): New function, implementing -newerXY.

	* find/tree.c (costlookup): pred_newerXY needs stat information.
	(build_expression_tree): For predicates of type ARG_SPECIAL_PARSE,
	pass them in the name of the predicate (that is, don't advance
	argc).

	* find/util.c (now): New function for setting options.start_time.
	Use nanoseconds where it is available.
	(set_option_defaults): Use now() rather than time().

2007-03-03  James Youngman  <jay@gnu.org>

	* import-gnulib.sh: Pass --with-tests to gnulib-tool so that relevant
	gnulib unit tests are built and are run for "make check".

	* configure.in (AC_CONFIG_FILES): Add tests/Makefile (the makefile
	for the gnulib unit tests).

	* Makefile.am: Add 'tests' to SUBDIRS.

	* .cvsignore: Add 'tests'.

	* import-gnulib.config (modules): Also use Gnulib modules
	mbscasestr and mbsstr in order to perform correct string searching
	in multibyte strings, in order to fix Savannah bug #14535.

	* locate/testsuite/locate.gnu/sv-bug-14535.exp: new test case for
	Savannah bug #14535.

	* locale/locate.c (visit_substring_match_nocasefold): Use mbsstr
	rather than strstr, in order to correctly support multibyte
	strings.
	(visit_substring_match_casefold): Use mbscasestr rather than
	strstr in order to correctly support case-folding in a multibyte
	environment (e.g. with UTF-8 characters outside the normal ASCII
	range).  This fixes Savannah bug #14535.
	(struct casefolder): No longer needed, removed
	(visit_casefold): No longer needed, removed.
	(lc_strcpy): No longer needed, removed.
	(search_one_database): Removed redundant variable need_fold and
	the code which used to set it.  It had controlled the adding of
	the visitor function visit_casefold, but that function itself is
	no longer required.  Also there is now no need to pass in a
	lower-case argument to visit_substring_match_casefold, so don't
	pass that in the context argument.

	* locate/locate.c (usage): Fixed typo.

2007-03-01  James Youngman  <jay@gnu.org>

	* doc/find.texi (Multiple Files): Document the construct
	-exec sh -c 'cmd "$@" final-args' {} + - fixing Savannah bug
	#18554.

2007-02-28  James Youngman  <jay@gnu.org>

	* import-gnulib.config: New file.  Specifies which version of
	Gnulib we need to check out and build from.

	* import-gnulib.sh: Use import-gnulib.config.

	* README-CVS: Describe the new method of building from CVS.

	* lib/gnulib-version.h, lib/gnulib-version.sh: New files; code for
	reporting which version of Gnulib we built findutils from.

	* lib/Makefile.am: Build gnulib-version.c out of
	./gnulib-version.config by using lib/gnulib-version.sh.

	* Makefile.am: Ship import-gnulib.config and import-gnulib.sh.

	* .cvsignore: Ignore gnulib-cvs

	* lib/.cvsignore: Ignore gnulib-version.c

	* find/parser.c, locate/code.c, locate/locate.c, xargs/xargs.c:
	Report which version of Gnulib we were built from.

2007-02-25  James Youngman  <jay@gnu.org>

	* find/find.c (process_dir): Removed duplicated (shadow)
	declaration of did_stat.  Assert that we did not use subdirs_left
	if subdirs_unreliable is true.

	* find/parser.c (parse_size): Removed unused variable rate.
	(parse_time): Removed unused variable num_days_approx.
	(get_num): Removed unused variables ok and suffixes.

	* find/pred.c (do_fprintf): Indicate that the function needs a
	return value (referring to Savannah bug #19146).

	* find/tree.c (predlist_dump): Commented out unused function
	(predlist_merge_nosort): Commented out unused function
	(getrate): Returns type is float, so return 1.0f not 1.0.
	(calculate_derived_rates): Removed unused variable rate.  Use a
	switch statement rater than ifs.

	* find/util.c (usage): Removed unused variable i.

	* lib/buildcmd.c (bc_do_insert): Removed unused variable
	need_prefix.
	(bc_init_controlinfo): annotate a line (with #warning) which is
	probably a bug.

	* locate/locate.c: #include <grp.h> for the benefit of the
	setgroups() call in drop_privs.
	(slocate_db_pathname): Commented out unused variable.
	(set_max_db_age): error command has no format directive, so
	remove the unused extra argument.
	(looking_at_slocate_db): Removed unused variables magic and
	lenwanted.  Fix bug where result is indeterminate (due to falling
	off the end of the function) if the first character is a nondigit.
	(search_one_database): Eliminate (spurious) compiler warning
	rlating to possible use before initialisation of slocate_seclevel.

	* xargs/xargs.c (get_char_oct_or_hex_escape): Eliminate spurious
	compiler warning on variable p.
	(main): Removed unused varible env_too_big


2007-02-24  James Youngman  <jay@gnu.org>

	* find/parser.c (pred_sanity_check): define this function even for
	_NDEBUG, but do nothing in that case.
	(estimate_timestamp_success_rate): correct (invert) the sense of
	the subtraction used to find the file's age.

	* import-gnulib.sh (findutils_modules): Import Gnulib modules
	xstrtod and timespec.

	* find/parser.c (get_comp_type): Refactored out of get_num.
	(get_num): call get_comp_type to find the comparison type.
	(get_relative_timestamp): new function replacing get_num_days.
	(get_num_days): Remove.
	(do_parse_xmin): Support fractional arguments and
	nanosecond timestamps.
	(parse_used): ditto
	(parse_time): ditto

	* xargs/xargs.c (read_line): Give a warning message if a NUL is
	found in the input (this function is called only when -0 is not in
	effect).

	* xargs/xargs.c (nullwarning_given): New variable indicating if
	the NULL character warning had already been issued.

	* doc/find.texi (Multiple Files): Describe how trailing blanks are
	handled when -L is in effect.

	* xargs/xargs.c (read_line): Use an enum rather than
	preprocessor macro values for the lexer state.

	* lib/savedirinfo.c (free_dirinfo): Fixed memory leak (trivial
	patch from Supriya Kannery)

2007-01-22  James Youngman  <jay@gnu.org>

	* .cvsignore (install-sh): Ignore, since the install-sh file is no
	longer held in the findutils CVS repository.

	* find/testsuite/config/unix.exp (find_start): allow a test to be
	skipped for either the old or the new find executable.
	* find/testsuite/find.gnu/execdir-pwd.exp,
	find/testsuite/Makefile.am:
	New test, covering Savannah bug #18466.  This test currently fails
	for the ftsfind binary and passes for the oldfind binary.  Due to
	a limitation in  the way that we perform the test, we can't tell
	the test suite to expect a failure in the new binary but not the
	old.  Therefore we skip the test for the old binary.

	* lib/regeprops.c (describe_regex_syntax): fixed a typo in the text
	* doc/find.texi (Multiple Files): fixed a typo

2007-01-16  James Youngman  <jay@gnu.org>

	(ctime_format): format the time manually (rather than using ctime)
	in order to include the sub-second part of the time.
	(weekdays, months): new static variables used by ctime_format.
	(format_date): append a the sub-second part of the timestamp to
	the seconds part of date/time output.

2007-01-15  James Youngman  <jay@gnu.org>

	* find/defs.h (time_val): define struct; use timespec to hold time
	in the 'reftime' member.
	(args): use struct timespec instead of time_t for predicates
	-newer, -anewer, -cnewer.  * find/parser.c (includes): include
	stat-time.h.
	(parse_anewer, parse_cnewer, parse_newer): use struct timespec to
	hold timestamps.  * find/pred.c (compare_ts): new function for
	comparing timestamps in struct timespec.
	(pred_anewer, pred_cnewer, pred_newer): use compare_ts() to
	compare timestamps (hence takinng acoung of sub-second
	granularity).
	* find/ftsfind.c: Various improvements to comments.
	(is_fts_enabled): Newline before function name to comply with GNU
	coding standard.

2007-01-13  James Youngman  <jay@gnu.org>

	* lib/regexprops.c (describe_regex_syntax): fixed typo

	* xargs/xargs.c (read_line): Fixed Savannah bug# 18714; VT and FF
	are not separators, according to POSIX (in the POSIX locale).

	* xargs/testsuite/Makefile.am,
	  xargs/testsuite/input/formfeeds.xi,
	  xargs/testsuite/input/verticaltabs.xi,
	  xargs/testsuite/xargs.posix/sv-bug-18714.exp,
	  xargs/testsuite/xargs.posix/sv-bug-18714.xo,
	  xargs/testsuite/xargs.posix/sv-bug-18714b.exp,
	  xargs/testsuite/xargs.posix/sv-bug-18714b.xo: Tests for Savannah
	  bug #18714.

	* xargs/xargs.c (usage): Removed suprious "[" in --help output
	(fixes Savannah bug #18384).

	* locate/locate.c: Implement the option --max-database-age.
	(main) Accept the option.
	(set_max_db_age): Parse the argument.

	* locate/locate.c (dolocate): If the database is more than N days
	old, indicate its actual age in the warning message we produce.

	* locate/locate.1, docs/find.texi: Document --max-database-age

	* THANKS: Thank Dean Gaudet for the idea of -sparse.

	* po/findutils.pot: Updated from Translation Project

	* po/ga.po, po/pl.po, po/nl.po, po/tr.po, po/hu.po: Updated from
	the Translation Project

2007-01-09  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* doc/find.texi: Fix some typos. (tiny change)

2007-01-07  James Youngman  <jay@gnu.org>

	* find/parser.c (parse_perm), find/testsuite/find.gnu/perm000.exp,
	  find/testsuite/find.gnu/perm000.xo: -perm /000 is now quivalent
	  to -perm -000, as dscussed in Savannah bug #14748.  The warning
	  message we issue when the user does this now explains that the
	  defintion changed as we promised it would in 2005.

	* xargs/xargs.c (read_line): Correctly handle quoted empty
	arguments occurring first or last on a line (by adding an empty
	argument to the output).  Fixes Savannah bug #18713.

	* xargs/testsuite/xargs.sysv/sv-bug-18713.exp,
	xargs/testsuite/xargs.sysv/sv-bug-18713.xo,
	xargs/testsuite/input/empty.xi: Test case for Savannah bug #18713.


2006-12-29  James Youngman  <jay@gnu.org>

	* find/testsuite/config/unix.exp:
	Verify that find_start is invoked with wither a p (pass) or an f
	(fail) argument.

	* lib/listfile.c, lib/listfile.h:
	define find_blocksize() and provide a declaration for get_link_name()

	* find/testsuite/config/unix.exp: Updated copyright years.

	* find/testsuite/find.gnu/execdir-one.exp, find/testsuite/find.gnu/execdir-root-only.exp, find/testsuite/find.gnu/sv-bug-12230.exp, find/testsuite/find.gnu/sv-bug-17782.exp, find/testsuite/config/unix.exp:
	Avoid tests using -execdir if $PATH contains a relative directory

	* find/parser.c:
	Also flag $PATH values containing relative directories as being dangerous.

	* find/parser.c, find/defs.h, find/util.c:
	Instead of selecting the old or new exec handling code with the NEW_EXEC macro, just use the new code all the time

	* locate/testsuite/config/unix.exp:
	Fixed Savannah bug #13252, test suite failure caused by the fact that 'file normalize' is not available in Tcl 8.3

	* NEWS, find/pred.c:
	Fixed Savannah bug #18433, compilation failure with configure --enable-debug

2006-12-28  James Youngman  <jay@gnu.org>

	* NEWS: Document addition of %S.

	* find/defs.h, find/find.1, find/parser.c, find/pred.c:
	Implemented %S (sparseness) printf format, and general refactoring and cleanup of printf predicate

2006-12-01  James Youngman  <jay@gnu.org>

	* NEWS, configure.in: Begin work on findutils 4.2.30

	* find/find.c:
	Fix compilation error for oldfind if --enable-debug was passed to configure

	* NEWS, configure.in: Prepare for work on findutils-4.3.3

2006-11-25  James Youngman  <jay@gnu.org>

	Release 4.3.2.

	* find/testsuite/Makefile.am: Added test case for Savannah bug #17782

	* doc/textinfo.tex: Removed; we now use the version supplied
	by automake.

	* m4/mkinstalldirs.m4: Added this file.  It's an excerpt from an
	old version of gnulib's m4/nls.po file.  The current version of
	gnulib does not expand MKINSTALLDIRS, but gettext-0.14.6's version
	of po/Makefile.in.in expects it to be expanded.  This m4 file
	fills the gap.

2006-11-20  James Youngman  <jay@gnu.org>

	* po/et.po, po/bg.po, po/pl.po, po/nl.po, po/tr.po: Updated
	translations for Bulgarian, Estonian, Dutch, Polish and Turkish.

2006-11-08  James Youngman <jay@gnu.org>

	* find/testsuite/Makefile.am:
	Oops, indicate the right directory for the new test files

	* ChangeLog, depcomp, doc/texinfo.tex, find/ftsfind.c, find/testsuite/Makefile.am, find/testsuite/find.gnu/sv-bug-18222.exp, find/testsuite/find.gnu/sv-bug-18222.xo, install-sh:
	Savannah bug#18222 - test case

	* ChangeLog, lib/buildcmd.c:
	Fixed Svannah bug #17782 ('./' prefix added at start of arg while it should be added at the start of the expansion of {})

	* find/ftsfind.c (process_all_startpoints): Set
	state.starting_path_length for every pathname argument.
	This fixes Savannah bug #18222.

	* find/pred.c (pred_prune): -prune should have an effect only if we are
	 currently considering a directory (Savannah bug #15531).

2006-10-15  James Youngman <jay@gnu.org>

	* lib/buildcmd.c: Fixed Savannah bug #17782, in which "find
	-execdir echo "foo {}" runs 'echo ./foo filename' instead of the
	correct command 'echo foo ./filename'.

	* po/hu.po, po/sl.po: Updated Hungarian and Slovenian po files

2006-08-21  James Youngman <jay@gnu.org>

	* find/parser.c, find/testsuite/Makefile.am, find/testsuite/find.gnu/sv-bug-17490.exp:
	Fixed Savannah bug #17490, which was a coiredump when -regex ZZZ was the final test on the command line

2006-08-20  James Youngman <jay@gnu.org>

	* find/parser.c: Merged the fix for the trailing % in "find -printf".

2006-08-20  Paul Eggert  <eggert@cs.ucla.edu>

	Port recent fixes for symbolic modes involving X from gnulib,
	and clarify the documentation in this area.
	* doc/find.texi: Use "file mode bits" when talking about
	all the file mode bits (including setuid, setgid, and sticky),
	and "permissions" when talking only about permissions bits
	(read, write, execute/search).  Use "execute/search" to
	talk about the x bit, since it means both.  You do not need
	permission to the linked-to file to follow a symlink for
	syscalls like "stat", but you do need search permission for
	the directories you traverse.  Clarify the explanation of
	-perm.  Use "that" instead of "which" when "which" isn't
	quite correct English.
	(Mode Bits): Renamed from Permissions.  All uses changed.
	* doc/perm.texi: Sync from coreutils 6.0.
	* find/defs.h (struct perm_val.val): Now an array of two items,
	one for non-directories, and one for directories.  This is
	to handle symbolic modes like +X correctly.
	* find/parser.c (parse_perm): Likewise.  Also, adjust to
	latest gnulib interface for mode_adjust.
	* find/pred.c (pred_perm): Likewise.
	* find/testsuite/Makefile.am (EXTRA_DIST_XO): Add find.posix/perm-X.xo.
	(EXTRA_DIST_EXP): Add find.posix/perm-X.exp.
	* find/testsuite/find.posix/perm-X.exp: New file.
	* find/testsuite/find.posix/perm-X.so: New file.

2006-08-19  Paul Eggert  <eggert@cs.ucla.edu>

	Port to latest gnulib, and simplify the bootstrapping procedure.
	* intl: Remove this directory and everything in it.
	* depcomp, install-sh, missing, mkinstalldirs, doc/texinfo.tex:
	Remove these files from CVS, as they are now gotten from gnulib.
	* README-CVS: Don't recommend "autoreconf -i", as it doesn't work
	for us.
	* import-gnulib.sh (findutils_files): New var.  Grab this stuff
	from gnulib.
	(findutils_modules): Add fopen-safer; remove stdio-safer.  This
	adjusts to latest gnulib.
	(modules): Remove obsolete reference to intl_modules.
	* .cvsignore: Remove stamp-h; add stamp-h1.
	* doc/.cvsignore: Add regexprops.texi.
	* find/.cvsignore: Add oldfind.
	* lib/.cvsignore: Add .deps, regexprops.
	* m4/.cvsignore: Add Makefile.
	* po/.cvsignore: Add stamp-po.

2006-08-19  James Youngman <jay@gnu.org>

	* locate/testsuite/config/unix.exp, locate/testsuite/locate.gnu/bigprefix1.exp:
	Explicit checks for parefixes which are within range of a short, but outside the one-byte range

	* locate/testsuite/locate.gnu/bigprefix1.exp, locate/testsuite/locate.gnu/exceedshort.exp, locate/testsuite/locate.gnu/space1st.exp:
	New file.

	* locate/testsuite/Makefile.am, locate/testsuite/locate.gnu/exceedshort.exp, locate/testsuite/locate.gnu/space1st.exp:
	Patch from Tavis Ormandy; check frcode handles initial space end encodes paths with more than 2^16 characters in the common prefix (tiny change)

	* locate/frcode.c: Changes to avoid overflows

2006-08-11  James Youngman <jay@gnu.org>

	* locate/frcode.c:
	Avoid producing an invalid database if the first item begins with a space

2006-08-10  James Youngman <jay@gnu.org>

	* find/pred.c, import-gnulib.sh, lib/listfile.c:
	Updated callers of the gnnulib filemode module so that they work with the 2006-07-09 version of gnulib

	* config.rpath: Updated config.rpath from autotools

2006-08-08  James Youngman <jay@gnu.org>

	* locate/locatedb.h:
	Automatically verify (at compile time) that the frcode datastream
	cannot get desynchronised.

	* find/ftsfind.c:
	Fixed Savannah bug #10494 (-maxdepth does not yield the same stat savinf in ftsfind as oldfind)

	* find/ftsfind.c: display fts_level for find -D search

	* find/util.c: Support find -D search

	* locate/locate.c:
	If the user specified -E but the database is an slocate database, do
	not produce a list of files they cannot stat.  Issue an error message
	explaining the problem.

	* locate/locate.c:
	Issue states messages in a way which indicates more clearly what's
	happening when the numbers are reduced because not every filename
	matched the pattern.

	* locate/locate.c: Better error checking in drop_privs().

2006-08-07  James Youngman <jay@gnu.org>

	* NEWS, locate/locate.c, locate/locatedb.h:
	Added support for slocate database format

	* xargs/xargs.c:
	Removed unused code (tivial patch from Miloslav Trmac).

	* xargs/xargs.c: Removed unused code.

	* doc/find.texi:
	Clarify that the output format for locate -S differs from BSD's.

	* NEWS, find/find.1:
	Savannah bug #15360: explain global vs. positional options more clearly in the manual page

	* NEWS: Typo in subsection header (* should be **).

	* NEWS, find/find.1:
	Savannah bug #15360: explain global vs. positional options more clearly in the manual page

	* doc/find.texi: Fixed some clumsy phrasing

	* NEWS, configure.in:
	Now diverging again from the released tarball, so change once more to -CVS version number suffixes

2006-08-06  James Youngman <jay@gnu.org>

	* locate/locate.c: Fixed a typo in a comment.

	* NEWS, configure.in: Moving on towards 4.3.2...

	Release 4.3.1.

	* find/testsuite/config/unix.exp:
	Check that we can see the find.o file in the right position relative
	to $base_dir to ensure that we are indeed testing the program we just built.

	* find/testsuite/config/unix.exp:
	Be more paranoid about whether we're really checking the right version
	of find.

	* NEWS, configure.in: Prepare for release of 4.3.1

	* doc/find.texi: Document the -O and -D options

	* find/defs.h, find/find.1, find/util.c:
	'find -D help' now explains the available debugging options

	* po/be.po, po/bg.po, po/ca.po, po/da.po, po/de.po, po/el.po, po/eo.po, po/es.po, po/et.po, po/fi.po, po/findutils.pot, po/fr.po, po/ga.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po, po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po, po/pt.po, po/pt_BR.po, po/ro.po, po/ru.po, po/rw.po, po/sk.po, po/sl.po, po/sr.po, po/sv.po, po/tr.po, po/vi.po, po/zh_CN.po, po/zh_TW.po:
	Make dist changed all the po files again

2006-08-05  James Youngman <jay@gnu.org>

	* NEWS: Described more changes in 4.3.1.

	* locate/testsuite/config/unix.exp:
	Set the  environment variable so that updatedb knows where to find it; it's not in BINDIR yet during 'make check'

	* po/be.po, po/bg.po, po/ca.po, po/da.po, po/de.po, po/el.po, po/eo.po, po/es.po, po/et.po, po/fi.po, po/findutils.pot, po/fr.po, po/ga.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po, po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po, po/pt.po, po/pt_BR.po, po/ro.po, po/ru.po, po/rw.po, po/sk.po, po/sl.po, po/sr.po, po/sv.po, po/tr.po, po/vi.po, po/zh_CN.po, po/zh_TW.po:
	Make dist changed all the po files again :)

	* po/et.po, po/vi.po: UPdated the Estonian and Vietnamese translations

	* NEWS, configure.in: Prepare for release of findutils-4.2.28

	* po/sv.po, po/tr.po, po/vi.po, po/zh_CN.po, po/zh_TW.po, po/be.po, po/bg.po, po/ca.po, po/da.po, po/de.po, po/el.po, po/eo.po, po/es.po, po/et.po, po/fi.po, po/findutils.pot, po/fr.po, po/ga.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po, po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po, po/pt.po, po/pt_BR.po, po/ro.po, po/ru.po, po/rw.po, po/sk.po, po/sl.po, po/sr.po:
	Make dist changed all the po files again :)

	* configure.in: Added Bulgarian translation.

	* po/bg.po: Include Bulgarian translation

	* configure.in: Added Bulgarian translation.

	* po/et.po, po/vi.po: Updated Estonian and Vietnamese translations

	* NEWS: Removed spurious comma.

	* NEWS: Listed the updated translations.

	* find/parser.c, lib/buildcmd.c, lib/buildcmd.h, xargs/xargs.c:
	Fixed Savannah bug#16738, find does not subtract environment size in find .. -exec {} +

	* NEWS: Updated the list of bugfixes etc.

2006-06-15  James Youngman <jay@gnu.org>

	* NEWS: Described recent changes

	* configure.in: fix to how we invoke the gnulib regex module

	* find/find.1:
	Savannah bug #16269: avoid confusion over what type of quotes to use
	in an example.

	* find/parser.c: Option -nowarn should not itself produce a warning

	* find/defs.h: Remoevd useless declaration of last_pred

2006-06-14  James Youngman <jay@gnu.org>

	* po/be.po, po/ca.po, po/da.po, po/de.po, po/el.po, po/eo.po, po/es.po, po/et.po, po/fi.po, po/findutils.pot, po/fr.po, po/ga.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po, po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po, po/pt.po, po/pt_BR.po, po/ro.po, po/ru.po, po/rw.po, po/sk.po, po/sl.po, po/sr.po, po/sv.po, po/tr.po, po/vi.po, po/zh_CN.po, po/zh_TW.po:
	Updated translation files ga pl sv tr nl ca vi bg fr

	* locate/updatedb.sh:
	Fixed Savannah bug #16579 (su false should be su -c false)

2006-04-01  James Youngman <jay@gnu.org>

	* find/find.c:
	Fixed Savannah bug #15800: "Hard link count is wrong" reports wrong
	directory name.

2006-03-31  James Youngman <jay@gnu.org>

	* po/hu.po: Updated Hungarian translation

2006-01-04  James Youngman <jay@gnu.org>

	* find/testsuite/find.posix/sizetype.exp, find/testsuite/find.posix/sizetype.xo, find/testsuite/find.posix/typesize.exp, find/testsuite/find.posix/typesize.xo:
	Additional tests for -type -size and -size -type

	* NEWS, doc/find.texi, find/defs.h, find/find.1, find/find.c, find/ftsfind.c, find/parser.c, find/pred.c, find/testsuite/Makefile.am, find/testsuite/config/unix.exp, find/testsuite/find.gnu/depth-d.exp, find/tree.c, find/util.c, po/be.po, po/ca.po, po/da.po, po/de.po, po/el.po, po/eo.po, po/es.po, po/et.po, po/fi.po, po/findutils.pot, po/fr.po, po/ga.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po, po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po, po/pt.po, po/pt_BR.po, po/ro.po, po/ru.po, po/rw.po, po/sk.po, po/sl.po, po/sr.po, po/sv.po, po/tr.po, po/vi.po, po/zh_CN.po, po/zh_TW.po:
	Initial implementation of a cost-based optimiser

2005-12-23  James Youngman <jay@gnu.org>

	* find/parser.c: Refactor of parse_[acm]time

	* find/defs.h, find/find.c, find/finddata.c, find/ftsfind.c, find/tree.c, find/util.c:
	last_pred can be a static in tree.c rather than a global variable

	* find/tree.c, find/finddata.c:
	Moved some global data out of finddata.o and into static variables in tree.c

	* NEWS, find/find.c, find/fstype.c, find/ftsfind.c, find/parser.c, find/pred.c, lib/buildcmd.c, lib/buildcmd.h, lib/regexprops.c, lib/regextype.c, lib/regextype.h, lib/savedirinfo.c, locate/locate.c, xargs/xargs.c:
	Fixed many compilation warnings

	* find/find.c, find/ftsfind.c, find/util.c:
	Evaluating the predicates can change the contents of the data structure (for example to add another exec item)

	* find/defs.h, find/find.c, find/ftsfind.c, find/tree.c, find/util.c:
	Re-factored a lot of common expression-handling code out of find.c and ftsfind.c, mainly into tree.c

	* find/find.c, find/ftsfind.c, find/tree.c:
	Savannah bug #15271: more helpful error messages for cases where there is a missing expression

2005-12-20  James Youngman <jay@gnu.org>

	* NEWS, doc/find.texi, find/defs.h, find/find.1, find/find.c, find/ftsfind.c, find/testsuite/Makefile.am, find/testsuite/find.posix/sv-bug-15235.exp, find/testsuite/find.posix/sv-bug-15235.xo, find/tree.c, find/util.c:
	Savannah bug #15195: more helpful error messages for 'find . ( )' or 'find . \!'

	* ChangeLog: Added entries for recent changes.

	* find/defs.h, find/find.c, find/ftsfind.c, find/testsuite/find.posix/bracket-depth.exp, find/util.c:
	Further fix to bug# 15235: a leading comma is a filename not an expression

	* find/defs.h, find/parser.c, find/testsuite/Makefile.am, find/testsuite/find.posix/empty-parens.exp, find/tree.c:
	Accept 'find ( -depth )' but reject 'find ( )'

	* po/be.po, po/ca.po, po/da.po, po/de.po, po/el.po, po/eo.po, po/es.po, po/et.po, po/fi.po, po/findutils.pot, po/fr.po, po/ga.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po, po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po, po/pt.po, po/pt_BR.po, po/ro.po, po/ru.po, po/rw.po, po/sk.po, po/sl.po, po/sr.po, po/sv.po, po/tr.po, po/vi.po, po/zh_CN.po, po/zh_TW.po:
	did make dist

	* find/testsuite/find.gnu/delete.exp:
	Use the new find program, and the new way of locating it (/ instead of )

	* find/testsuite/Makefile.am: Added bracket-depth.exp.

	* NEWS, configure.in: We have moved on from 4.3.0

	* find/defs.h, find/find.c, find/ftsfind.c, find/testsuite/Makefile.am, find/testsuite/find.gnu/delete.exp, find/testsuite/find.posix/files-not-expressions1.exp, find/testsuite/find.posix/files-not-expressions1.xo, find/testsuite/find.posix/files-not-expressions2.exp, find/testsuite/find.posix/files-not-expressions2.xo, find/testsuite/find.posix/files-not-expressions3.exp, find/testsuite/find.posix/files-not-expressions3.xo, find/util.c:
	Avoid getting confused by filename arguments of which the first
	character looks like a predicate, for example ',x' or '!x' or
	'(x' (Savannah bug #15235).

2005-12-20  James Youngman <jay@gnu.org>

	* find/defs.h, find/find.c, find/ftsfind.c,
	find/testsuite/find.posix/bracket-depth.exp, find/util.c: Further
	fix to bug# 15235: a leading comma is a filename not an expression

	* find/defs.h, find/parser.c, find/testsuite/Makefile.am,
	find/testsuite/find.posix/empty-parens.exp, find/tree.c: Accept
	'find ( -depth )' but reject 'find ( )'

	* find/testsuite/find.gnu/delete.exp: Use the new find program,
	and the new way of locating it ($OLDFIND/$FTSFIND instead of $FIND)

	* find/testsuite/Makefile.am: Added bracket-depth.exp.

	* NEWS, configure.in: We have moved on from 4.3.0

	* find/defs.h, find/find.c, find/ftsfind.c,
	find/testsuite/Makefile.am, find/testsuite/find.gnu/delete.exp,
	find/testsuite/find.posix/files-not-expressions1.exp,
	find/testsuite/find.posix/files-not-expressions1.xo,
	find/testsuite/find.posix/files-not-expressions2.exp,
	find/testsuite/find.posix/files-not-expressions2.xo,
	find/testsuite/find.posix/files-not-expressions3.exp,
	find/testsuite/find.posix/files-not-expressions3.xo, find/util.c:
	Avoid getting confused by filename arguments of which the first
	character looks like a predicate, for example ',x' or '!x' or '(x'
	(Savannah bug #15235).

2005-12-19  James Youngman <jay@gnu.org>

	* find/testsuite/config/unix.exp:
	Run every test twice, once with the old (non-fts) binary and once with
	the new (fts-enabled) binary.

2005-12-19  Eric Blake <ebb9@byu.net>

	* find/testsuite/Makefile.am,
	find/testsuite/find.posix/sv-bug-15235.xo,
	find/testsuite/find.posix/sv-bug-15235.exp: New tests for Savannah
	bug 15235.

	* NEWS, find/find.1, doc/find.texi (Invoking find): Document bug
	fix for Savannah bug 15235.

2005-12-16  James Youngman <jay@gnu.org>

	* xargs/xargs.1, xargs/xargs.c: Fixed bug# 15211, that xargs
	--show-limits is not documented in the manpage or in the usage
	message

2005-12-12  James Youngman <jay@gnu.org>

	Release 4.3.0.

	* find/testsuite/find.gnu/access.exp:
	Don't leave junk files lying around the place

	* README-CVS: Update the the instructions for getting gnulib; the
	CVS arrangements at Savannah have changed.

	* ChangeLog, NEWS, doc/find.texi, doc/perm.texi, find/defs.h, find/parser.c:
	Merged changes from 4.2.x branch again

	* NEWS, doc/find.texi, find/defs.h, find/find.c, find/ftsfind.c,
	find/parser.c, find/pred.c, find/util.c, lib/listfile.c,
	lib/listfile.h: Initial code to allow control over how -ls quote
	(or does not quote) control characters; not enabled yet

2005-12-11  James Youngman <jay@gnu.org>

	* ChangeLog, THANKS, xargs/xargs.c:
	Fixed spelling errors in Bob Proulx's name.  Sorry, Bob.

2005-12-10  James Youngman <jay@gnu.org>

	* doc/perm.texi:
	Aaron Hawley: Updated perm.texi from the coreutils distribution

	* find/parser.c:
	Avoid using entries which have the same name as POSIX library
	functions (fprintf, printf, exec) as the implementation is allowed to
	#define these.  That generates hard-to-grok compilation errors.

2005-12-10  Andreas Metzler <gnu@downhill.at.eu.org>

	* ChangeLog, NEWS, configure.in, find/defs.h, find/parser.c:
	Applied patch from Andreas Metzler fixing Savannah bug #15181:
	implicit declaration of parse_openparen

2005-12-08  James Youngman  <jay@gnu.org>

	* doc/find.texi: Typo and spelling corrections from Aaron Hawley

2005-12-05  James Youngman  <jay@gnu.org>

	* Released findutils-4.2.27

2005-12-05  James Youngman  <jay@gnu.org>

	* doc/find.texi, find/find.1, locate/locate.1, xargs/xargs.1:
	Savannah patch #3775 from Aaron Hawley: reconciling man pages
	differences; did not apply the patch, but resolved all the
	remaining issues manually by updating the documentation (mostly
	the Texinfo documentation, which was missing a number of specific
	technical statements about the behaviour of various options)

2005-12-04  James Youngman  <jay@gnu.org>

	* doc/find.texi: Document --show-limits

	* xargs/xargs.c:
	Correctly display the size of the argument buffer we really allocated.

	* doc/find.texi, find/find.1, find/parser.c, find/pred.c, NEWS:
	Savannah bug #14748 (which this change does NOT fix): issue
	warning of future changes in the behaviour of -perm /000

2005-11-30  James Youngman  <jay@gnu.org>

	* xargs/xargs.c:
	Typo correction from Benno Schulenberg <benno@nietvergeten.nl>
	(tiny change)

2005-11-29  James Youngman  <jay@gnu.org>

	* xargs/xargs.c:
	Typo "Ilegal"; change to "Invalid" since this is not really illegal!
	Bug report by Primoz Peterlin.

	* lib/regexprops.c, xargs/xargs.c:
	Prefer the word 'Invalid' or the phrase 'not allowed' over
	'Illegal', as per the GNU coding standards, and as per the
	suggestion from Benno Schulenberg

2005-11-24  James Youngman  <jay@gnu.org>

	* NEWS, lib/buildcmd.c, lib/buildcmd.h: Merge to trunk from 4.2.x fixes

	* lib/buildcmd.h:
	Deleted inaccurate comment about the default value of ctl->args_per_exec.

	* NEWS, lib/buildcmd.c, lib/buildcmd.h:
	Be more conservative about the total number of arguments we will
	allow (to avoid exec limits on Linux/PPC)

2005-11-23  James Youngman  <jay@gnu.org>

	* NEWS: Bug #14921 has been fixed.

	* find/fstype.c:
	Savannah bug #14921: when a Linux bind filesystem is in use, find
	would expand '-printf %F' to 'none' if a bind mount targetted the same
	filesystem as the one containing the file to be described.

	* NEWS: Updated to describe recent changes

	* doc/find.texi, find/find.1: Documented find -printf %M

	* lib/buildcmd.c, xargs/testsuite/Makefile.am,
	xargs/testsuite/xargs.posix/arg_max_32bit_linux_bug.exp,
	xargs/testsuite/xargs.posix/arg_max_32bit_linux_bug.xo,
	xargs/testsuite/xargs.posix/arg_max_64bit_linux_bug.exp,
	xargs/testsuite/xargs.posix/arg_max_64bit_linux_bug.xo:
	Ensure that the test suite still passes even if the current
	system's value of ARG_MAX is different from the development/test
	system

	* lib/buildcmd.c: reindent and untabify

	* configure.in: The CVS code is moving on from the previous release.

2005-11-22  James Youngman  <jay@gnu.org>

	* ChangeLog: Updated with recent changes.

2005-11-21  James Youngman  <jay@gnu.org>

	* locate/testsuite/config/unix.exp:
	Even if we expect locate to return a nonzero status, the test should
	still fail if updatedb fails!

	* locate/testsuite/locate.gnu/ignore_case2.exp:
	Set the current directory for updatedb.  This test case is supposed to
	fail because the filename is not matched, not because updatedb fails!

	* locate/updatedb.sh:
	Check the binaries actually exist in the place we expect.

2005-11-20  James Youngman  <jay@gnu.org>

	* locate/locate.1, xargs/xargs.1: Escape '-' as '\-' where appropriate.

	* find/find.1:
	Escape '-' as '\-' where appropriate.   Fixes last part of bug #14556.

2005-11-19  James Youngman  <jay@gnu.org>

	* doc/find.texi, find/find.1:
	Applied edited form of Andreas Metzler's -perm /mode documentation
	patch resolving Savannah bug #14619.

	* lib/extendbuf.c:
	In the success case, extendbuf() should preserve the previous value of
	errno.  Fixes Savannah bug #14842.

	* xargs/testsuite/Makefile.am: Added new test files

	* find/find.1:
	Correctly indicate the default regular expression syntax (fixes
	Savannah bug #14836).

	* NEWS, configure.in: Released findutils-4.2.26

	* ChangeLog, NEWS, lib/buildcmd.c,
	xargs/testsuite/inputs/16383-ys.xi,
	xargs/testsuite/inputs/32767-ys.xi,
	xargs/testsuite/xargs.posix/arg_max_32bit_linux_bug.exp,
	xargs/testsuite/xargs.posix/arg_max_32bit_linux_bug.xo,
	xargs/testsuite/xargs.posix/arg_max_64bit_linux_bug.exp,
	xargs/testsuite/xargs.posix/arg_max_64bit_linux_bug.xo: Applied
	bugfix from Jim Meyering (tiny change), where many short arguments
	would cause xargs (and probably find -exec .. {} +) to fail
	because execve() returns E2BIG, which we should avoid

	* xargs/testsuite/inputs/16383-ys.xi,
	xargs/testsuite/inputs/32767-ys.xi,
	xargs/testsuite/xargs.posix/arg_max_32bit_linux_bug.exp,
	xargs/testsuite/xargs.posix/arg_max_32bit_linux_bug.xo,
	xargs/testsuite/xargs.posix/arg_max_64bit_linux_bug.exp,
	xargs/testsuite/xargs.posix/arg_max_64bit_linux_bug.xo: New file.

	* po/be.po, ca.po, da.po, de.po, el.po, eo.po, es.po, et.po, fi.po,
	findutils.pot, fr.po, ga.po, gl.po, hr.po, hu.po, id.po, it.po,
	ja.po, ko.po, lg.po, ms.po, nl.po, pl.po, pt.po, pt_BR.po, ro.po,
	ru.po, rw.po, sk.po, sl.po, sr.po, sv.po, tr.po, vi.po, zh_CN.po,
	zh_TW.po: Updated Portuguese .po file and did update-po

2005-11-18  Jim Meyering  <jim@meyering.net> (tiny change)

	* lib/buildcmd.c (bc_push_arg): When exec'ing, don't exceed
	Linux's limit on the maximum number of command line arguments.

2005-11-11  James Youngman  <jay@gnu.org>

	* NEWS, find/find.c, find/fstype.c: Savannah bug #14922: if we need the
	list of mounted filesystems but it is not available, exit fatally
	with a message.  If it is not available but we don't need it,
	there is no need for an error.

	* po/ro.po, ru.po, rw.po, sk.po, sl.po, sr.po, sv.po, tr.po, vi.po,
	zh_CN.po, zh_TW.po, ko.po, lg.po, ms.po, nl.po, pl.po, pt.po,
	pt_BR.po, be.po, ca.po, da.po, de.po, el.po, eo.po, es.po, et.po,
	fi.po, findutils.pot, fr.po, ga.po, gl.po, hr.po, hu.po, id.po,
	it.po, ja.po: Updated Polish translation

2005-10-31  James Youngman  <jay@gnu.org>

	* doc/find.texi:
	Removed redundant additional description of "--regextype".

2005-10-08  James Youngman  <jay@gnu.org>

	* find/find.c, lib/regextype.c: Fixed Savannah bug #14616, which
	was that c99 code had crept in and it didn't compile on c89
	compilers

	* doc/find.texi: Savannah patch #4371 from Andreas Metzler; the
	argument of -I is mandatory

2005-09-21  James Youngman  <jay@gnu.org>

	* xargs/xargs.1, xargs/xargs.c: Clarified the -E option

2005-09-20  James Youngman  <jay@gnu.org>

	* NEWS, configure.in, doc/find.texi, xargs/xargs.1, xargs/xargs.c:
	Documentation clarification: -L and -I take a mandatory argument;
	-l and -i do not

2005-09-17  James Youngman  <jay@gnu.org>

	* xargs/xargs.c:
	Fixed Savannah bug #14550 - if environment is too large to allow
	exec() to work, we cannot even use "xargs --help".

	* find/find.1:
	Avoid the use of -perm +mode, using -perm /mode instead.  From comment
	by Andreas Metzler (though I didn't read the patch).

	* ChangeLog, doc/find.texi, find/find.1, xargs/xargs.1:
	Typo fix from A Costa (tiny change)

	* NEWS: Corrections for find manual page - symbolic permissions.

	* find/find.1:
	Corrected an inaccuracy in the EXAMPLES section - in symbolic modes,
	'o' stands for 'others' and 'u' stands for 'user' (i.e. the owner).

2005-09-17  A Costa <agcosta@gis.net>  (tiny change)

	docs/find.texi: Fixed typo
	find/find.1: Fixed typo
	xargs/xargs.1: Fixed typo

2005-09-17  James Youngman  <jay@gnu.org>

	* NEWS: Corrections for find manual page - symbolic permissions.

	* find/find.1:
	Corrected an inaccuracy in the EXAMPLES section - in symbolic modes,
	'o' stands for 'others' and 'u' stands for 'user' (i.e. the owner).

2005-09-06  James Youngman  <jay@gnu.org>

	* xargs/xargs.c: Typo in "IEEE" in a comment.

2005-09-04  James Youngman  <jay@gnu.org>

	* find/defs.h, find/find.c, find/parser.c, find/pred.c,
	Work around compilation failure with GCC 4 and AIX 5.1, in which
	open is #defined to open64

	* po/be.po, ca.po, da.po, de.po, el.po, eo.po, es.po, et.po, fi.po,
	findutils.pot, fr.po, ga.po, gl.po, hr.po, hu.po, id.po, it.po,
	ja.po, ko.po, lg.po, ms.po, nl.po, pl.po, pt.po, pt_BR.po, ro.po,
	ru.po, rw.po, sk.po, sl.po, sr.po, sv.po, tr.po, vi.po, zh_CN.po,
	zh_TW.po: Work around compilation failure with GCC 4 and AIX 5.1,
	in which open is #defined to open64

2005-09-03  James Youngman  <jay@gnu.org>

	* find/testsuite/find.gnu/quit.exp: Fixed Savannah bug#14390, by
	avoiding an accidental assumption in quit.exp that directory
	entries are returned by readir() in any particular order

	* NEWS, configure.in, doc/find.texi, xargs/testsuite/Makefile.am,
	xargs/testsuite/inputs/helloworld.xi,
	xargs/testsuite/xargs.gnu/delim-o.exp,
	xargs/testsuite/xargs.gnu/delim-o.xo, xargs/xargs.1,
	xargs/xargs.c: Added the --delimiter option to xargs, resolving
	Savannah support request sr #102914

	* ChangeLog, NEWS, configure.in: Released findutils-4.2.25

	* po/sr.po, sv.po, tr.po, vi.po, zh_CN.po, zh_TW.po, sl.po, be.po,
	ca.po, da.po, de.po, el.po, eo.po, es.po, et.po, fi.po,
	findutils.pot, fr.po, ga.po, gl.po, hr.po, hu.po, id.po, it.po,
	ja.po, ko.po, lg.po, ms.po, nl.po, pl.po, pt.po, pt_BR.po, ro.po,
	ru.po, rw.po, sk.po: Did update-po

2005-09-02  James Youngman  <jay@gnu.org>

	* doc/find.texi, find/find.1:
	Improved documentation in response to Savannah bug #14376

2005-09-01  James Youngman  <jay@gnu.org>

	* po/ChangeLog, ChangeLog: Updated with recent changes.

	* locate/locate.c: Removed unused struct stringbuf.soffs.

	* doc/find.texi: Typo fix from Jim Meyering (tiny change)

2005-09-01  Jim Meyering  <jim@meyering.net>

	* locate/locate.c (struct stringbuf) [soffs]: Remove unused member.
	(locate): Remove initialization, too.

2005-09-01  James Youngman  <jay@gnu.org>

	* doc/find.texi: Typo fix from Jim Meyering (tiny change)

2005-08-30  James Youngman  <jay@gnu.org>

	* find/defs.h, find/find.c, find/fstype.c, find/pred.c:
	Attempted fix for compilation when AFS is #defined

2005-08-24  James Youngman  <jay@gnu.org>

	* po/sl.po: Updated from Translation Project

2005-08-13  James Youngman  <jay@gnu.org>

	* find/find.1: Remind the user to quote the pattern argument to -iname.

2005-08-12  James Youngman  <jay@gnu.org>

	* NEWS: Corrected typo.

2005-08-11  James Youngman  <jay@gnu.org>

	* po/fr.po: Updated French translation and added new PO file zh_TW.po
	for Chinese (traditional)

2005-08-09  James Youngman  <jay@gnu.org>

	* NEWS: Indicate that regexprops.texi is built on Cygin now that
	Savannah bug #14025 has been fixed.

	* lib/Makefile.am, lib/regexprops.c: Fixed compilation failure on
	Cygwin - Savannah Bug #14025 (tiny change, three lines), reported
	and fixed by Eric Blake

	* find/testsuite/Makefile.am,
	find/testsuite/find.posix/sv-bug-14070.exp,
	find/testsuite/find.posix/sv-bug-14070.xo: Added new test case for
	SourceForge bug #14070

	* find/testsuite/find.posix/sv-bug-14070.exp,
	find/testsuite/find.posix/sv-bug-14070.xo: New file.

	* find/defs.h, find/ftsfind.c, find/pred.c, find/util.c:
	Ensure we can still build with --enable-debug

	* find/testsuite/config/unix.exp,
	find/testsuite/find.gnu/execdir-one.exp,
	find/testsuite/find.gnu/execdir-root-only.exp,
	find/testsuite/find.gnu/sv-bug-12230.exp: If . is on $PATH,
	indicate that the -execdir tests cannot be carried out, as opposed
	to indicating that those tests fail

2005-08-07  James Youngman  <jay@gnu.org>

	* NEWS: Indicated that some test suite files have been renamed.

	* xargs/testsuite/Makefile.am, xargs/testsuite/inputs/eof.xi,
	xargs/testsuite/inputs/eof1.xi,
	xargs/testsuite/xargs.sysv/eof.exp,
	xargs/testsuite/xargs.sysv/eof.xo,
	xargs/testsuite/xargs.sysv/eof1.exp,
	xargs/testsuite/xargs.sysv/eof1.xo,
	xargs/testsuite/xargs.posix/lc_l2.exp,
	xargs/testsuite/xargs.posix/lc_l2.xo,
	xargs/testsuite/xargs.sysv/l2.exp,
	xargs/testsuite/xargs.sysv/l2.xo,
	xargs/testsuite/xargs.sysv/lc_l2.exp,
	xargs/testsuite/xargs.sysv/lc_l2.xo,
	xargs/testsuite/xargs.posix/L2.exp,
	xargs/testsuite/xargs.posix/l2.exp,
	xargs/testsuite/xargs.posix/L2.xo,
	xargs/testsuite/xargs.posix/l2.xo,
	xargs/testsuite/xargs.posix/uc_L2.exp,
	xargs/testsuite/xargs.posix/uc_L2.xo: Work around problems with
	CVS clients on case-insentitive operating systems

	* debian/Changelog: Removed Changelog file since changelog is the
	one we should be using and having both files upsets Cygwin
	systems which cannot tell the dirrerence between changelog and
	Changelog

	* find/ftsfind.c:
	If DEBUG is defined, show the symbolic names fro fts_info values.

	* find/ftsfind.c: Added additional diagnostics.

2005-08-02  James Youngman  <jay@gnu.org>

	* po/tr.po, vi.po:
	Updated Vietnamese and Turkish translations from Translation Project

	* po/sl.po, sr.po, sv.po, tr.po, vi.po, zh_CN.po, be.po, ca.po, da.po, de.po, el.po, eo.po, es.po, fi.po, findutils.pot, fr.po, ga.po, gl.po, hr.po, hu.po, id.po, it.po, ja.po, ko.po, lg.po, ms.po, pl.po, pt.po, pt_BR.po, ru.po, rw.po:
	Did update-po

	* po/et.po, sk.po, ro.po:
	Updated Romanian, Slovak and Estonian translations from Translation Project

2005-08-01  James Youngman  <jay@gnu.org>

	* ABOUT-NLS, INSTALL, Makefile.am, configure.in, depcomp,
	doc/texinfo.tex, install-sh, missing, mkinstalldirs: By adding the
	missing AM_GNU_GETTEXT_VERSION call, allowed autopoint to update
	those files of which it has updated copies.

	* po/Makevars.template, po/Makefile.in.in, po/findutils.pot:
	Using AM_GNU_GETTEXT_VERSION, allowed gettext to update the infrastructure

	* po/Rules-quot, po/boldquot.sed, po/en@boldquot.header, po/en@quot.header, po/insert-header.sin, po/quot.sed:
	Files added by autopoint now that we are using AM_GNU_GETTEXT_VERSION

	* find/testsuite/Makefile.am: Added find.gnu./perm-slash.{exp,xo}.

	* po/nl.po: Updated Dutch translation from Translation Project

	* po/ga.po: Updated Irish translation from the Translation Project

	* po/da.po: Updated Danish translation from the Translation Project

	* po/ca.po: Updated Catalan translation from Translation Project

2005-07-31  James Youngman  <jay@gnu.org>

	* find/testsuite/excuses.txt: We now have tests for -perm.

	* NEWS, configure.in, find/parser.c,
	find/testsuite/find.gnu/perm-slash.exp,
	find/testsuite/find.gnu/perm-slash.xo: Fixed bug which caused find
	-perm /440 to be treated the same as find -perm 440

	* find/testsuite/Makefile.am:
	Generic tests for -perm -NNN and -perm NNN

	* find/testsuite/excuses.txt: New file - list of test cases that
	still need to be written, along with excuses why they haven't been
	done yet

	* find/testsuite/find.posix/perm-vanilla.exp,
	find/testsuite/find.posix/perm-vanilla.xo: Generic tests for -perm
	-NNN and -perm NNN

	* find/testsuite/find.gnu/inum.exp:
	Ensure that the test would fail if -inum just always returned true

	* find/testsuite/Makefile.am, find/testsuite/find.gnu/ilname.exp,
	find/testsuite/find.gnu/ilname.xo,
	find/testsuite/find.gnu/inum.exp, find/testsuite/find.gnu/inum.xo,
	find/testsuite/find.gnu/lname.exp,
	find/testsuite/find.gnu/lname.xo,
	find/testsuite/find.gnu/xtype.exp,
	find/testsuite/find.gnu/xtype.xo,
	find/testsuite/find.posix/links.exp,
	find/testsuite/find.posix/links.xo: New test cases for -ilname,
	-inum, -lname, -xtype

	* find/testsuite/Makefile.am, find/testsuite/find.gnu/delete.exp,
	find/testsuite/find.gnu/delete.xo,
	find/testsuite/find.gnu/iregex1.exp,
	find/testsuite/find.gnu/iregex1.xo,
	find/testsuite/find.gnu/regex1.exp,
	find/testsuite/find.gnu/regex1.xo,
	find/testsuite/find.gnu/regex2.exp,
	find/testsuite/find.gnu/regex2.xo,
	find/testsuite/find.gnu/samefile-copy.exp,
	find/testsuite/find.gnu/samefile-copy.xo,
	find/testsuite/find.gnu/samefile-link.exp,
	find/testsuite/find.gnu/samefile-link.xo,
	find/testsuite/find.gnu/samefile-same.exp,
	find/testsuite/find.gnu/samefile-same.xo,
	find/testsuite/find.gnu/samefile-symlink.exp,
	find/testsuite/find.gnu/samefile-symlink.xo: Further test cases

	* find/find.1: Indicate that -delete implies -depth (find.texi
	already mentioned this).

	* find/testsuite/Makefile.am:
	Brought the list of .exp and .xo files in Makefile.am into sync with
	the actual contents of the CVS repository.

	* find/testsuite/Makefile.am, find/testsuite/find.gnu/depth-d.exp,
	find/testsuite/find.gnu/depth-d.xo,
	find/testsuite/find.gnu/empty.exp,
	find/testsuite/find.gnu/empty.xo,
	find/testsuite/find.gnu/execdir-one.exp,
	find/testsuite/find.gnu/execdir-one.xo,
	find/testsuite/find.gnu/false.exp,
	find/testsuite/find.gnu/false.xo,
	find/testsuite/find.gnu/follow-basic.exp,
	find/testsuite/find.gnu/follow-basic.xo,
	find/testsuite/find.gnu/gnu-or.exp,
	find/testsuite/find.gnu/gnu-or.xo,
	find/testsuite/find.gnu/gnuand.exp,
	find/testsuite/find.gnu/gnuand.xo,
	find/testsuite/find.gnu/gnunot.exp,
	find/testsuite/find.gnu/gnunot.xo,
	find/testsuite/find.gnu/iname.exp,
	find/testsuite/find.gnu/iname.xo,
	find/testsuite/find.gnu/ipath.exp,
	find/testsuite/find.gnu/ipath.xo,
	find/testsuite/find.gnu/iwholename.exp,
	find/testsuite/find.gnu/iwholename.xo,
	find/testsuite/find.gnu/path.exp, find/testsuite/find.gnu/path.xo,
	find/testsuite/find.gnu/print0.exp,
	find/testsuite/find.gnu/print0.xo,
	find/testsuite/find.gnu/quit.exp, find/testsuite/find.gnu/quit.xo,
	find/testsuite/find.gnu/true.exp, find/testsuite/find.gnu/true.xo,
	find/testsuite/find.gnu/wholename.exp,
	find/testsuite/find.gnu/wholename.xo,
	find/testsuite/find.posix/and.exp,
	find/testsuite/find.posix/and.xo,
	find/testsuite/find.posix/exec-one.exp,
	find/testsuite/find.posix/exec-one.xo,
	find/testsuite/find.posix/grouping.exp,
	find/testsuite/find.posix/grouping.xo,
	find/testsuite/find.posix/name.exp,
	find/testsuite/find.posix/name.xo,
	find/testsuite/find.posix/posixnot.exp,
	find/testsuite/find.posix/posixnot.xo,
	find/testsuite/find.posix/prune.exp,
	find/testsuite/find.posix/prune.xo: Added new test cases for many
	of the actions and tests of find

	* find/find.c (default_prints):
	not a static function, so do not declare it as one.

	* m4/withfts.m4: Fixed underquoted definition of FIND_WITH_FTS.
	[this change is currently on a branch only]

2005-07-30  James Youngman  <jay@gnu.org>

	* find/finddata.c, find/ftsfind.c, find/parser.c, find/pred.c,
	find/util.c, m4/Makefile.am, m4/withfts.m4: Initial attempt to
	convert find to use gnulib's fts()
	[this change is currently on a branch only]

	* find/finddata.c, find/ftsfind.c, m4/withfts.m4: New file.
	[this change is currently on a branch only]

	* NEWS, configure.in, find/Makefile.am, find/defs.h, find/find.c,
	import-gnulib.sh: Initial attempt to convert find to use gnulib's
	fts() [this change is currently on a branch only]

2005-07-29  James Youngman  <jay@gnu.org>

	* NEWS, configure.in
	Prepared for the release of findutils-4.2.24

	* ChangeLog: Updated with recent changes.

	* NEWS, find/find.1, doc/find.texi:
	Indicate that -ok and -okdir redirect stdin from /dev/null.

	* NEWS: Explain the directory link count change more throroughly.

	* NEWS: Fixed bug #13973.

	* find/pred.c (pred_fprintf): Fix Savannah bug #13973: Modify the
	handling of -printf %Y so that it no longer modifies stat_buf

	* find/testsuite/find.gnu/printf-symlink.exp,
	find/testsuite/find.gnu/printf-symlink.xo: Detect Savannah bug
	#13973: pollution of stat_buf by the %Y directive (trivial change
	from Andreas Metzler)

	* INSTALL, depcomp, doc/texinfo.tex, install-sh, missing, mkinstalldirs:
	Updated auxilliary files from the automake-1.9 distribution

	* configure.in:
	Introduce new Automake conditional, CROSS_COMPILING, true when we are corss compiling

	* find/find.c:
	If we decline to follow a symbolic link due to the safety check, issue a more self-explanatory warning message

	* lib/Makefile.am: Don't build regexprops if we are cross compiling

	* doc/Makefile.am:
	Depend on the regex.h file rather than the 'regexprops' binary,
	because the header file will always exist even if we are doing "make
	dist".  Otherwise "make distcheck" fails because it tries to rebuild
	find.info while the source-directory is read-only.

2005-07-28  James Youngman  <jay@gnu.org>

	* find/find.1:
	Say "other users" rather than "rest of the world" when talking about
	Unix permissions.  Fixes Savannah bug #4246.

2005-07-27  James Youngman  <jay@gnu.org>

	* xargs/testsuite/Makefile.am: Added new test case 'childfail.exp'.

	* doc/find.texi:
	Updated the description of the safe-dir-change operation to reflect
	what find now does on systems that lack O_NOFOLLOW.

	* NEWS, find/parser.c: Indicate in the output of find --version if
	the leaf optimisation is enabled or not

	* find/find.c: Fixed typo.

	* find/find.c: If the link count of a directory starts off less
	than two, disable the leaf optimisation for this directory.

2005-07-26  James Youngman  <jay@gnu.org>

	* lib/regexprops.c: Further small corrections from Karl.

	* doc/find.texi:
	Reordered the sections in the manual to put the "Common Tasks" and
	"Worked Examples" chapters together.

	* configure.in, find/find.c: Allow the leaf optimisation to be
	disabled by default with the configure option
	--disable-leaf-optimisation

	* find/find.c: Removed old code for antuqie version of savedir().

	* lib/regextype.c: Put the syntaxes in alphabetical order.

	* lib/regexprops.c: Karl made some more readability suggestions.

2005-07-24  James Youngman  <jay@gnu.org>

	* doc/Makefile.am: If the regexprops program has changed we should
	re-run it, since it will probably now produce different output

	* lib/regextype.h:
	Allow the caller to detect if one regex type is identical to another.

	* configure.in:
	Define the preprocessor macro FINDUTILS for that code int he lib/
	directory can be slightly more reusable.

	* lib/regextype.c:
	Allow the caller to detect if one regex type is identical to another.

	* lib/regexprops.c:
	Made Texinfo style corrections suggested by Karl Berry.

2005-07-22  James Youngman  <jay@gnu.org>

	* xargs/testsuite/xargs.posix/childfail.exp, xargs/xargs.c: Fix
	Savannah bug #13878, in which xargs deals incorrectly with child
	failure, returning 0 when it should return 123

2005-07-17  James Youngman  <jay@gnu.org>

	* find/find.1: (tiny change) Corrections by Greg Wooledge

2005-07-16  James Youngman  <jay@gnu.org>

	* doc/find.texi: Updates following comments by Dave Gilbert.

	* NEWS: Corrected a typo.

	* doc/find.texi:
	Added in the example about updating an aggregate timestamp file.

2005-07-15  James Youngman  <jay@gnu.org>

	* po/da.po: Updated Danish translation from translation project

2005-07-14  James Youngman  <jay@gnu.org>

	* NEWS, doc/Makefile.am, doc/find.texi, lib/Makefile.am,
	lib/regexprops.c, lib/regextype.c, lib/regextype.h: Added
	--regextype and -regextype options to locate and find
	respectively, and documented these

	* doc/find.texi: We use GNU Emacs regexps by default now.

	* doc/find.texi:
	We require GNU sort in order for locate to handle newlines correctly,
	not just GNU find.

2005-07-10  James Youngman  <jay@gnu.org>

	* doc/find.texi:
	Applied several documentation improvement patches from Aaron Hawley

	* ChangeLog, NEWS: Updated with recent changes.

	* NEWS: Recent gnulib changed have fixed -iregex

	* doc/find.texi, xargs/xargs.1:
	Tiny patch from Andreas Metzler: xargs -I is like xargs -i, but the latter is deprecated

2005-07-06  James Youngman  <jay@gnu.org>

	* find/defs.h, find/find.c, find/parser.c, find/pred.c:
	Fixed Savannah bug #13650; programs run by -exec cannot read stdin

2005-07-04  James Youngman  <jay@gnu.org>

	* NEWS: *** empty log message ***

	* doc/find.texi:
	Added a "Worked Examples" section.   It currently only contains a
	(long) example about deleting files.

	* .cvsignore: Some extra stuff to ignore.

2005-07-03  James Youngman  <jay@gnu.org>

	* find/Makefile.am: Don't need regexprops.c really...

	* lib/regextype.c, lib/regextype.h:
	New files for selecting regex type based on a keyword

	* locate/locate.1: Documented the fact that we now use Emacs-style
	regexps, not POSIX EREs, for compatibility with find -regex.

	* lib/Makefile.am, locate/locate.c, doc/find.texi,
	find/Makefile.am, find/defs.h, find/find.1, find/find.c,
	find/parser.c: Fixed Savannah bug #13495: find now uses
	Emacs-style regexps by default

2005-07-02  James Youngman  <jay@gnu.org>

	* configure.in, find/defs.h, find/fstype.c, find/parser.c,
	intl/dcigettext.c, lib/buildcmd.c, lib/listfile.c,
	lib/savedirinfo.c, locate/locate.c, xargs/xargs.c: Assume unistd.h
	is present - avoid using HAVE_UNISTD_H

2005-07-01  Jim Meyering  <jim@meyering.net>

	With `-fprint F' or `-fprintf F', don't write diagnostics
	to F when stderr is closed.

	* find/parser.c: Include "stdio-safer.h".
	(open_output_file): Use fopen_safer, not fopen.
	* import-gnulib.sh (findutils_modules): Add stdio-safer.

2005-07-01  James Youngman  <jay@gnu.org>

	* doc/find.texi:
	Aaron pointed out a potentially-confusing sentence.  I fixed it.

	* find/defs.h, find/find.1, find/find.c, find/parser.c,
	find/pred.c, find/util.c: Allow consistency-checking of the
	predicates, checking for example that actions all have side
	effects

2005-06-29  James Youngman  <jay@gnu.org>

	* doc/find.texi: Applied patch from Aaron Hawley (Savannah patch
	#3751: Typos and small suggestions to find.texi)

2005-06-27  James Youngman  <jay@gnu.org>

	* ChangeLog, locate/locate.c: Applied patch from Bas Van Gompel to
	move match counting into a (new) visitor function

	* NEWS, configure.in: No longer 4.2.23, as we're moving on now

2005-06-24  Bas van Gompel  <patch-findutils.buzz@bavag.tmfweb.nl>

	* locate/locate.c (visit_count, visit_limit): New functions.
	(locate): Use visit_limit or visit_count. Simplify main loop.
	(main) Bail out early when limit is reached.

2005-06-20  James Youngman  <jay@gnu.org>

	* xargs/xargs.c:
	Removed some code which had already been disabled via the preprocessor.

2005-06-19  Dmitry V. Levin <ldv@altlinux.org>

	* lib/savedirinfo.c: Fix two compilation warnings (which would
	prevent compilation if "-Wall -Werror" is in effect).

2005-06-19  James Youngman  <jay@gnu.org>

	* ChangeLog: Indicate that we made (are making) a release.

	* ChangeLog, NEWS, configure.in: Preparing to release 4.2.23

	* doc/find.texi: Fixed Texinfo syntax error in previous change

	* doc/find.texi, xargs/xargs.1:
	Document the fact that the -i and -L options are currently
	incompatible (Savannah bug 13041).

	* locate/updatedb.1, locate/updatedb.sh: Fix Savannah bug 13411 -
	reject trailing slashes in updatedb's --prunepaths, bacsue these
	will never be matched

	* NEWS: Released findutils-4.2.23.

	* doc/find.texi, xargs/xargs.1:
	Document the fact that the -i and -L options are currently
	incompatible (Savannah bug 13041).

	* locate/updatedb.1, locate/updatedb.sh: Fix Savannah bug 13411 -
	reject trailing slashes in updatedb's --prunepaths, because these
	will never be matched.

2005-06-18  James Youngman  <jay@gnu.org>

	* po/ga.po, tr.po: Updated Irish and Turkish translations.

	* po/pl.po: Did update-po

	* po/pl.po:
	Updated Polish translation file from the Translation Project

	* po/ca.po, da.po, de.po, el.po, eo.po, es.po, et.po, fi.po, findutils.pot, fr.po, ga.po, gl.po, hr.po, hu.po, id.po, it.po, ja.po, ko.po, lg.po, ms.po, nl.po, pl.po, pt.po, pt_BR.po, ro.po, ru.po, rw.po, sk.po, sl.po, sr.po, sv.po, tr.po, vi.po, zh_CN.po, be.po:
	Did update-po

2005-06-18  Martin Buchholz (tiny change)

	* find/defs.h, find/find.c, find/parser.c, doc/find.texi: Fix
	typos/spelling errors (mostly in source code comments).

2005-06-18  Dmitry V. Levin  <ldv@altlinux.org>

	Additional documentation tweaks for -execdir/-okdir actions.
	* find/parser.c (parse_help): Mention -execdir and -ordir options.
	* doc/find.texi, find/find.1: Additionally document new options.

2005-06-12  Bas van Gompel  <patch-findutils.buzz@bavag.tmfweb.nl>

	* locate/locate.c: Implement --all (-A).

	* NEWS, doc/find.texi, locate/locate.1: Document locate --all (-A)

2005-06-12  James Youngman  <jay@gnu.org>

	* find/find.c, NEWS:
	Savannah bug #13381 (Debian bug 313081): if we have O_NOFOLLOW,
	safely_chdir() does not need to call stat().  However, process_dir()
	used to rely on using that stat information.  To work around this
	problem, there is now an output parameter in safely_chdir() which
	indicates if the stat buffer is valid.
	This bug has possible security implications.

	* find/find.1, doc/find.texi:
	Applied patch from Andreas Metzler, improving the wording for the
	documentation of the %k and %b format directives.  This patch does
	not require a copyright assignment as it consists of several
	copies of the same small wording change.

2005-06-11  James Youngman  <jay@gnu.org>

	* find/find.1: Corrected spelling error 'writeable' to 'writable'.

	* find/find.1, locate/locate.1:
	Fixed Savannah bug #13363, typos in manpages (tiny change)

2005-06-10  James Youngman  <jay@gnu.org>

	* find/find.c, lib/savedirinfo.c, lib/savedirinfo.h: Switch to a
	new scheme for saving directory entry data which is extensible to
	allow additional data to be saved.

2005-06-09  James Youngman  <jay@gnu.org>

	* locate/testsuite/config/unix.exp:
	Use the new normalize_dir procedure throughout.

	* locate/testsuite/config/unix.exp: Move the normalisation into a
	procedure.  Don't rely on the "file normalize" command being
	available (it's new in Tcl 8.4).

2005-06-08  James Youngman  <jay@gnu.org>

	* ChangeLog, NEWS, configure.in: Updated for recent changes

	* doc/find.texi:
	Explain that you should put the argument of -name in quotes.

	* find/find.1:
	Added a new "NON-BUGS" section pointing out things that look like bugs
	but are caused by mistakes or misunderstandings.

	* doc/find.texi, locate/locate.1: Applied Bas van Gompel's patch
	which allows the database to be read from stdin.

	* locate/locate.c:
	Read the database in by using the "visitor" pattern.  Modified file
	header comment to indicate that we no longer use the efficient
	algorith described in ;login:.  Emit an error message if the
	LOCATE_PATH variable implies that we should read stdin twice.
	Most of this code is from Bas van Gompel.

	* AUTHORS: Credit Bas van Gompel for his work on locate.

	* lib/printquoted.h: Appled patch from Bas - fixing compiler warning.

2005-06-07  James Youngman  <jay@gnu.org>

	* ChangeLog, NEWS, configure.in: Updates prior to release

	* config.rpath: Added file required for 'make dist'

	* po/be.po, po/ca.po, po/da.po, po/de.po, po/el.po, po/eo.po,
	po/es.po, po/et.po, po/fi.po, po/findutils.pot, po/fr.po,
	po/ga.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po,
	po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po,
	po/pt.po, po/pt_BR.po, po/ro.po, po/ru.po, po/rw.po, po/sk.po,
	po/sl.po, po/sr.po, po/sv.po, po/tr.po, po/vi.po, po/zh_CN.po:
	updated the po files for release

	* xargs/testsuite/Makefile.am:
	Added in all the test files from Dmitry V. Levin.

2005-06-08  Bas van Gompel  <patch-findutils.buzz@bavag.tmfweb.nl>

	* NEWS, locate/locate.1, doc/find.texi: Document usage of `-'
	to refer to stdin in database-path for locate.
	* locate/locate.c: Change prototype for visitors and processors
	throughout. Move reading the database and generating base_name
	into visitors. Allow `-' to refer to stdin in database-path.

	* lib/printquoted.h: Include stdio.h.

2005-06-07  James Youngman  <jay@gnu.org>

	* COPYING, debian/copyright, depcomp, doc/texinfo.tex,
	find/defs.h, find/find.c, find/fstype.c, find/parser.c,
	find/pred.c, find/testsuite/config/unix.exp, find/tree.c,
	find/util.c, import-gnulib.sh, intl/Makefile.in,
	intl/bindtextdom.c, intl/config.charset, intl/dcgettext.c,
	intl/dcigettext.c, intl/dcngettext.c, intl/dgettext.c,
	intl/dngettext.c, intl/explodename.c, intl/finddomain.c,
	intl/gettext.c, intl/gettext.h, intl/gettextP.h,
	intl/hash-string.h, intl/intl-compat.c, intl/l10nflist.c,
	intl/libgettext.h, intl/libgnuintl.h, intl/loadinfo.h,
	intl/loadmsgcat.c, intl/localcharset.c, intl/locale.alias,
	intl/localealias.c, intl/ngettext.c, intl/plural.c, intl/plural.y,
	intl/ref-add.sin, intl/ref-del.sin, intl/textdomain.c,
	lib/buildcmd.c, lib/buildcmd.h, lib/extendbuf.c, lib/extendbuf.h,
	lib/forcefindlib.c, lib/listfile.c, lib/listfile.h,
	lib/modetype.h, lib/nextelem.c, lib/nextelem.h, lib/printquoted.c,
	lib/printquoted.h, lib/qmark.c, lib/savedirinfo.c,
	lib/savedirinfo.h, lib/strspn.c, lib/wait.h, lib/waitpid.c,
	locate/bigram.c, locate/code.c, locate/frcode.c, locate/locate.c,
	locate/locatedb.h, locate/testsuite/config/unix.exp,
	locate/updatedb.sh, missing, po/fetch-po-files,
	xargs/testsuite/config/unix.exp, xargs/xargs.c:
	Updated the FSF's postal address

	* ChangeLog: Corrected Bas's email address.

	* locate/locate.c: Updated copyright years.

2005-06-07  Bas van Gompel  <patch-findutils.buzz@bavag.tmfweb.nl>

	 * locate/locate.c: Fold case once, only when needed.

2005-06-07  James Youngman  <jay@gnu.org>

	* NEWS: Updated with recent changes.

	* mdate-sh: Use the mdate-sh from automake

	* find/parser.c, find/pred.c, find/tree.c, find/util.c,
	lib/Makefile.am, lib/forcefindlib.c, lib/listfile.c,
	lib/listfile.h, locate/code.c, locate/locate.c, find/defs.h,
	find/find.c: Fix Savannah bug #13324: Fix compiler warnings for
	GCC-3.4

	* locate/locate.c:
	Fixed Savannah bug #13325: Quoting of output filenames in locate
	should match find.

	* find/parser.c:
	Fixed Savannah bug #13319: C9X-ism in parser.c (declaration after
	statements).

	* find/pred.c, lib/Makefile.am, lib/listfile.c, lib/nextelem.c,
	lib/printquoted.c, lib/printquoted.h, lib/qmark.c, NEWS,
	doc/find.texi, find/defs.h, find/find.1, find/parser.c: Fixed
	Savannah bug #13303, find should filter out non-printable
	characters if outputting to tty

2005-05-30  James Youngman  <jay@gnu.org>

	* locate/locate.c: rename new_locate() to locate() since
	  old_locate() has gone the way of the dodo.

2005-05-29  Bas van Gompel  <patch-findutils.buzz@bavag.tmfweb.nl>

	Add a ``--print'' (``-p'') option. (to cancel side-effects of -c/-S)
	Allow ``--statistics'' in combination with non-options.
	* doc/find.texi: Add documentation for locate --print (-p), and the
	use of non-options with --statistics.
	* locate/locate.1: ditto.
	* locate/locate.c: Read each database only once.

2005-05-23  Paul Eggert  <eggert@cs.ucla.edu>

	Adjust to recent gnulib changes.
	* import-gnulib.sh: Get config.rpath from gnulib/build-aux,
	not gnulib/config.
	* find/parser.c (parse_perm): Ignore umask when parsing
	symbolic permissions.  Adjust to new modechange API.

2005-05-16  James Youngman  <jay@gnu.org>

	* find/find.c, find/parser.c, find/pred.c, find/tree.c:
	Trivial change: don't use i18n support for debug-only messages

	* ChangeLog: Added ChangeLog entry crediting Dmitry

2005-05-09  James Youngman  <jay@gnu.org>

	* find/parser.c:
	The previous change fixed Savannah bug #12999.  This change doesn't do
	anything, it's only intended to be a place to record the Savannah bug
	ID we've just fixed.

	* find/parser.c:
	Oops.  Initialise the variable which indicates which regex syntax to
	use.  We use POSIX basic regular expressions.

	* find/parser.c:
	Suggestion by Ed Avis: point out that "-name foo/bar" will almost
	always evaluate to false.   Suggest to the user what alternatives they
	might find useful.

2005-05-02  James Youngman  <jay@gnu.org>

	* AUTHORS:
	Added Dimitry (his new test suite contribution required a copyright
	assignment).

2005-05-03  Dmitry V. Levin

	* Added xargs test suite tests by Dmitry V. Levin, together with
	  bugfixes which ensure that the tests pass.

2005-04-18  James Youngman  <jay@gnu.org>

	* Added test suite tests for Bas van Gompel's changes.

2005-04-18  Bas van Gompel  <patch-findutils.buzz@bavag.tmfweb.nl>

	* doc/find.texi: Document locate --non-existing (-E).
	* locate/locate.1: Ditto.
	* locate/locate.c: Implement --non-existing (-E).

2005-04-04  James Youngman  <jay@gnu.org>

	* configure.in, import-gnulib.sh:
	We no longer need gnulib/m4/Makefile.am

	* po/vi.po: Updated Vietnamese translation

	* locate/updatedb.sh:
	Savannah bug #12491: Only use the "-s" option to "su" if it is
	supported.

2005-04-01  James Youngman  <jay@gnu.org>

	* locate/locate.1, locate/updatedb.1, xargs/xargs.1: Trivial
	change from A Costa <agcosta@gis.net>, fixing typos in manual
	pages for xargs, locate and updatedb; fixes Savannah bug #12500,
	Debian bug #301934

2005-03-22  James Youngman  <jay@gnu.org>

	* import-gnulib.sh: Include the new gnulib module stat-macros

	* configure.in:
	CVS code is (will shortly be) no longer identical to the 4.2.20 release

2005-03-17  James Youngman  <jay@gnu.org>

	* configure.in: Preprare for release of 4.2.20.

	* NEWS: Updated prior to release of 4.2.20.

	* ChangeLog: Updated with recent changes.

	* THANKS: Thank Bas van Gompel, but only once.

	* THANKS: Thank Bas van Gompel and Aaron S. Hawley.

	* po/vi.po: Updated Vietnamese PO file

2005-03-10  James Youngman  <jay@gnu.org>

	* po/nl.po: Updated Dutch PO file

2005-03-08  Bas van Gompel  <patch-findutils.buzz@bavag.tmfweb.nl>

	* import-gnulib.sh: Re-enable creation of gnulib/m4/Makefile.am.

2005-03-07  James Youngman  <jay@gnu.org>

	* Released findutils-4.2.19.

	* find/testsuite/find.posix/sizes.exp:
	Use 2>/dev/null instead of 2>&1, because Tcl understands the former
	but not the latter.

	* find/testsuite/Makefile.am: Also distribute sv-bug-12181.xo.

	* find/testsuite/Makefile.am: Distribute sv-bug-12181.

	* find/testsuite/Makefile.am: Distribute sv-bug-12230.

	* NEWS: Updated with new news.

	* ChangeLog: Brought up to date.

	* lib/buildcmd.c, find/testsuite/find.gnu/sv-bug-12230.exp: Fixed
	Savannah bug #12230, in which '-exec echo == {} +' is always run,
	even if there were no matched files.

2005-03-06  James Youngman  <jay@gnu.org>

	* ChangeLog: Added latest changes.

	* po/pt.po, configure.in: Added Portuguese translation

2005-03-04  James Youngman  <jay@gnu.org>

	* configure.in: Modernized the way we call AC_INIT and
	AM_INIT_AUTOMAKE

	* locate/locate.c, find/pred.c, find/find.c:
	Eliminated some compiler warnings

	* find/pred.c: Clarified the meaning of a comment.

	* find/testsuite/Makefile.am: Added sizes.exp, sizes.xo.

	* find/testsuite/find.posix/sizes.xo,
	find/testsuite/find.posix/sizes.exp: Added tests for -size
	predicate

2005-03-03  James Youngman  <jay@gnu.org>

	* find/find.c:
	safely_chdir_lstat(): if we didn't end up in the right place, and then
	fchdir() fails, we can't return to the directory we started in.
	Therefore, issue a fatal error message and exit.

2005-03-01  James Youngman  <jay@gnu.org>

	* find/find.c, find/testsuite/find.posix/sv-bug-12181.exp,
	find/testsuite/find.posix/sv-bug-12181.xo: Fixed SourceForge bug
	12181 (find -H symlink-to-dir reports 'Too many Symbolic links')
	and bug 12044 (find still hangs on dead NFS filesystems on
	Solaris)

2005-02-28  James Youngman  <jay@gnu.org>

	* doc/find.texi: Typo: O_NOFOLLOW, not O_FOLLOW

	* import-gnulib.sh:
	Suggestion from Martin Buchholz; unset CDPATH to prevent "cd" echoing
	the new directory.

2005-02-27  James Youngman  <jay@gnu.org>

	* README: Indicate how the reader can verify the release.

2005-02-26  James Youngman  <jay@gnu.org>

	* po/sk.po, po/sl.po, po/sr.po, po/sv.po, po/tr.po, po/vi.po,
	po/zh_CN.po, po/be.po, po/ca.po, po/da.po, po/de.po, po/el.po,
	po/eo.po, po/es.po, po/et.po, po/fi.po, po/findutils.pot,
	po/fr.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po,
	po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po,
	po/pt_BR.po, po/ro.po, po/ru.po: Added new Vietnamese translation

	* configure.in: Added new Vietnamese translation.

2005-02-25  James Youngman  <jay@gnu.org>

	* po/ga.po: Updated Irish po file

2005-02-23  James Youngman  <jay@gnu.org>

	* Makefile.am: Fix Savannah bug #12064 - 'make distclean' deletes
	regex.c but should not.

	* find/testsuite/Makefile.am,
	find/testsuite/find.gnu/printf-h.exp,
	find/testsuite/find.gnu/printf-h.xo: Added test case for Savannah
	bug #12085 (-printf %h).

	* NEWS, doc/find.texi, find/find.1, find/pred.c:
	%h now expands to '.' instead of nothing.

2005-02-22  James Youngman  <jay@gnu.org>

	* find/find.c:
	Fixed Savannah bug #12099 (misinterpretation of system versions
	leading to possible incorrect disabling of O_NOFOLLOW).  Reported by
	Dmitry V. Levin.

	* find/pred.c:
	For the %h format, don't bail out early as the format might contain
	something else too.

2005-02-21  James Youngman  <jay@gnu.org>

	* find/find.c: Fixed accidental C99 dependency.

2005-02-20  James Youngman  <jay@gnu.org>

	* po/be.po, po/ca.po, po/da.po, po/de.po, po/el.po, po/eo.po,
	po/es.po, po/et.po, po/fi.po, po/findutils.pot, po/fr.po,
	po/ga.po, po/gl.po, po/hr.po, po/hu.po, po/id.po, po/it.po,
	po/ja.po, po/ko.po, po/lg.po, po/ms.po, po/nl.po, po/pl.po,
	po/pt_BR.po, po/ro.po, po/ru.po, po/sk.po, po/sl.po, po/sr.po,
	po/sv.po, po/tr.po, po/zh_CN.po: Updated italian translation

	* doc/find.texi: Corrected a typo.

	* find/find.c:
	Read the mounted device list afer parsing the command line, so that
	for example "find --version" still works (in response to Savannah bug
	#12044).

	* configure.in: We've moved on from findutils-4.2.18.

2005-02-19  James Youngman  <jay@gnu.org>

	* NEWS: Corrected the summary of the "find -depth" bug.

2005-02-16  James Youngman  <jay@gnu.org>

	* NEWS, configure.in: Prepared for release of 4.2.18.

	* ChangeLog: Updated prior to release of 4.2.18.

	* find/testsuite/Makefile.am:
	Distribute the test cases for the recent "find -depth" bug.

	* find/testsuite/find.posix/depth1.exp, find/testsuite/find.posix/depth1.xo:
	Added test case for find -depth bug reported by Joseph S. Myers

	* find/find.c:
	If -depth is in effect, processing of the subdirectories invalidates
	the information in 'state'.  Therefore once we get around to
	processing the predicates, restore the information that we keep in
	'state' and in 'stat_buf'.

2005-02-15  James Youngman  <jay@gnu.org>

	* ChangeLog: Updated with recent changes

	* find/find.1:
	Emphasise that -L causes find to recurse into subdirectories pointed
	to by symbolic links.

	* find/find.1:
	Patch to find.1 from Aaron Hawley <Aaron.Hawley@uvm.edu>:

	* Notes about -H actually apply to -L.
	* Said paragraph is duplicated two paragraphs later.
	* Typos: nno, ibmue, surrpounding

2005-02-15  Aaron Hawley  <Aaron.Hawley@uvm.edu>

	* find/find.1: Notes about -H actually apply to -L.  Said
	paragraph is duplicated two paragraphs later.  Also typos: nno,
	ibmue, surrpounding

2005-02-13  James Youngman  <jay@gnu.org>

	* find/find.1: Miscellaneous small clarifications and improvements.

	* doc/find.texi: Added Info nodes and menus under "Changing the
	Current Working Directory" so that it doesn't generate such a huge
	Info page.

	* find/find.c: Parenthesise #if defined(...).

2005-02-13  Dmitry V. Levin  <ldv@altlinux.org>

	* find/find.c: remove test code snippet (time(NULL) was used to
	place a marker for spotting with strace(), but was not actually
	needed).

	* find/find.c (safely_chdir_nofollow): must not fall back on
	safely_chdir_lstat() because that will expose it to race condition
	exploits, making it pointless.

	* find/find.c (safely_chdir_lstat): Move
	complete_pending_execdirs() up into safely_chdir(), because we
	need to do that in either case.

2005-02-12  James Youngman  <jay@gnu.org>

	* configure.in, doc/find.texi, find/defs.h, find/find.c,
	find/parser.c: Fix for Savannah bug #11879, that
	init_mounted_dev_list() causes find to hang on systems which are
	clients to dead NFS servers

2005-02-10  James Youngman  <jay@gnu.org>

	* doc/find.texi: Talk about the problem where find will not work
	if you have a filesystem mounted from an unresponsive NFS server.

2005-02-09  James Youngman  <jay@gnu.org>

	* find/find.1: Indicate that $TZ affects from printf-format
	results, and add extra cross-references in the SEE ALSO section.

2005-02-08  James Youngman  <jay@gnu.org>

	* xargs/testsuite/Makefile.am: Distribute the .xe files also.

	* Makefile.am: Check that we have the right number of .xe files in
	the distribution also.

	* ChangeLog, NEWS, configure.in
	Preparing to release findutils-4.2.17

2005-02-07  James Youngman  <jay@gnu.org>

	* find/testsuite/config/unix.exp: Re-sort the .xo file using the
	calling user's locale, because our 'pre-sorted' .so output file
	may not be sorted with the same collating order as 'sort' used to
	order the output of "find.  Bug spotted by Vin Shelton and Dimitry
	V. Levin.

	* find/testsuite/Makefile.am:
	New test, find/testsuite/find.gnu/follow-arg-parent-symlink.exp.

	* find/testsuite/find.gnu/follow-arg-parent-symlink.exp,
	find/testsuite/find.gnu/follow-arg-parent-symlink.xo, find/find.c:
	Fix for starting point /foo/bar/baz where bar is a symlink but baz
	is not - we should chdir into bar there even if it is a symbolic
	link

2005-02-07  James Youngman  <jay@gnu.org>

	* find/testsuite/Makefile.am:
	New test, find/testsuite/find.gnu/follow-arg-parent-symlink.exp.

	* find/testsuite/find.gnu/follow-arg-parent-symlink.exp,
	find/testsuite/find.gnu/follow-arg-parent-symlink.xo, find/find.c:
	Fix for starting point /foo/bar/baz where bar is a symlink but baz
	is not - we should chdir into bar there even if it is a symbolic
	link

2005-02-06  James Youngman  <jay@gnu.org>

	* doc/find.texi:
	-size: Clarification - -size gives a result consistent with 'wc -c'
	 for example.

	* Makefile.am, find/testsuite/Makefile.am,
	find/testsuite/find.gnu/execdir-root-only.exp,
	find/testsuite/find.gnu/execdir-root-only.xo,
	locate/testsuite/Makefile.am, xargs/testsuite/Makefile.am:
	dist-hook: Ensure that we distribute all the .po files and all the
	testsuite files

	* po/pl.po: Updated Polish translation from TP website

2005-02-05  Dmitry V. Levin  <ldv@altlinux.org>

	* find/parser.c, find/pred.c: Additional tweaks for
	-execdir/-okdir actions.

	* find/parser.c (new_insert_exec_ok): Disable ignore_readdir_race
	for -execdir/-okdir.

	* find/pred.c (pred_execdir, pred_okdir): Use state.rel_pathname
	instead of basename(pathname).  Do not add "./" prefix for
	absolute pathnames.

	* find/find.c (process_top_path): Treat "/" similarly to ".".

	* xargs/testsuite/xargs.posix/savannah-11865.exp,
	xargs/testsuite/xargs.posix/savannah-11865.xo, xargs/xargs.c:
	Fixed Savannah bug #11866 (not resetting number of used chars in
	the command buffer) - reported by Dimitry V. Levin

2005-02-05  James Youngman  <jay@gnu.org>

	* THANKS:
	Added thanks for Dimitry - has produced many patches, bugfixes and
	suggestions.

	* find/pred.c:
	Fixed Savannah bug #11866: typo in pred_okdir() renders it useless

	* find/pred.c:
	Savannah bug #11861: undefined symbol 'basename' on IRIX 5.3

	* NEWS, configure.in, po/be.po, po/ca.po, po/el.po, po/eo.po,
	po/fi.po, po/ga.po, po/hr.po, po/hu.po, po/ja.po, po/lg.po,
	po/ms.po, po/ro.po, po/sl.po, po/sr.po, po/zh_CN.po: Added new
	translations

	* ChangeLog: Updated from CVS prior to release of 4.2.16.

	* po/ChangeLog: Updated from CVS.

	* NEWS, configure.in: Preparing to release 4.2.16

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot,
	po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po,
	po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sl.po, po/sv.po,
	po/tr.po: make update-po prior to 'make distcheck'

	* po/fetch-po-files: This is the first version we actually used.

	* find/find.c: process_top_path() fixed compilation warning.

	* find/find.c: process_top_path(): avoid processing this item if
	we can't chdir to the basename of the named file.

	* lib/Makefile.am: Always build forcefindlib.c

	* locate/locate.c: Say 'base name' rather than 'basename' in comments

	* find/pred.c, find/find.c: process_top_path(): Proper bugfix for
	correct handling of items at depth 0 (i.e. specified on the
	command line) - do an extra chdir to ensure that we're in the
	directory containing the item before calling process_path().
	Hnece also undo the previous 'quick fix' for the same problem

	* doc/find.texi:
	-execdir no longer has to treat anything as special, even at depth 0.

2005-02-03  James Youngman  <jay@gnu.org>

	* doc/find.texi, find/pred.c: When state.curdepth is 0, our
	working directory is not the directory containing the file we are
	processing.

2005-02-02  James Youngman  <jay@gnu.org>

	* find/pred.c:
	To allow compilation on cygwin, use base_name(), not basename().

	* po/tr.po: Updated Turkish translation from TP

	* po/ro.po: Updated Romanian translation from TP

	* po/da.po, po/et.po: Updated translations from MT project website

2005-02-01  James Youngman  <jay@gnu.org>

	* ChangeLog: Updated from CVS log.

2005-01-31  James Youngman  <jay@gnu.org>

	* find/find.c, lib/nextelem.c, lib/nextelem.h, locate/code.c,
	locate/frcode.c, locate/testsuite/config/unix.exp,
	xargs/testsuite/config/unix.exp, xargs/xargs.c: Updated/corrected
	the email address for David MacKenzie, one of the original authors
	of findutils

	* doc/Makefile.am: The HTML version of the manual generated for
	the GNU project website has each node in a separate file, not each
	chapter in a separate file; adjust filenames accordingly

	* find/parser.c, find/pred.c, lib/savedirinfo.c:
	Removed some unused variables (patch from Dmitry V. Levin)

	* find/find.c:
	Patch from Dmitry V. Levin <ldv@altlinux.org>: Add subfs to the list
	of filesystems which are likely to be automounted.

	* m4/findlib.m4: Corrected typo (pointed out by Dmitry V. Levin).

	* find/testsuite/config/unix.exp,
	find/testsuite/find.gnu/name-period.xo,
	find/testsuite/find.gnu/posix-dflt.xo,
	find/testsuite/find.gnu/posix-h.xo,
	find/testsuite/find.gnu/posix-l.xo,
	find/testsuite/find.gnu/printf.exp,
	find/testsuite/find.gnu/printf.xo: Systems differ in the order in
	which filenames are returned by readdir.  Hence sort the output of
	'find' before comparing against the expected-output file.  We
	therefore also have the lines in the .xo files ready-sorted.

	* po/ca.po: Updated from Translation Project

	* po/ChangeLog: Updated from CVS logs.

	* po/de.po, es.po, et.po, fr.po, gl.po, id.po, it.po, ko.po, nl.po,
	pl.po, pt_BR.po, ru.po, sk.po, sv.po, tr.po, da.po: Ran update-po

	* po/be.po, ca.po, el.po, eo.po, fi.po, hr.po, hu.po, ja.po, lg.po,
	ms.po, ro.po, sl.po, sr.po, zh_CN.po: Added new translation files
	from the Translation Project web site

	* po/da.po, de.po, es.po, et.po, fr.po, ga.po, gl.po, id.po, it.po,
	ko.po, nl.po, pl.po, pt_BR.po, ru.po, sk.po, sv.po, tr.po: Updated
	.po files from the Translation Project site

2005-01-30  James Youngman  <jay@gnu.org>

	* doc/Makefile.am:
	Added rules for extra targets that we buld to update the web site.

2005-01-29  James Youngman  <jay@gnu.org>

	* configure.in: No longer version 4.2.15 - we've changed the manual.

	* doc/find.texi:
	Clarified the txt about adding extra tests with post-processing via
	xargs, and recommend -execdir instead for security reasons.

	* doc/find.texi: Patch from Karl Berry:
	- more entries for the dir file
	- use @copying so the copyright ends up in the HTML etc. output.
	  (This is the only really important change.)
	- put @contents after the title page, for conventional toc location.
	- use @ifnottex to wrap the Top node instead of @ifinfo, for the sake of
	  HTML output, etc.

	* NEWS, configure.in, po/da.po, po/de.po, po/es.po, po/et.po,
	po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po,
	po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po,
	po/sv.po, po/tr.po: Prepared to release findutils-4.2.15

	* ChangeLog: Updated from CVS log.

2005-01-28  James Youngman  <jay@gnu.org>

	* configure.in:
	Make --enable-d_type-optimization and --enable-d_type-optimisation
	both work.

	* configure.in: Assume --enable-d_type-optimisation by default

	* find/parser.c: Indicate which features are enabled/disabled

	* locate/testsuite/config/unix.exp:
	Clean up the files left behind by the locate_textonly test

2005-01-27  James Youngman  <jay@gnu.org>

	* doc/find.texi: Documented --regex.

	* NEWS, locate/locate.1, locate/locate.c, locate/testsuite/Makefile.am, locate/testsuite/config/unix.exp, locate/testsuite/locate.gnu/regex1.exp:
	Implemented locate --regex - but needs documenting in Texinfo manual.

2005-01-25  James Youngman  <jay@gnu.org>

	* configure.in: Bumped version no.

	* doc/find.texi:
	Document --mmap and --stdio as being synonyms of -m and -s.

	* locate/locate.1:
	Document --mmap and --stdio as synonyms of -m and -s.

	* locate/locate.c:
	Document -m and -s (both no-ops) in the usage message.

	* doc/find.texi, locate/locate.1: Document -m and -s as no-ops.

	* ChangeLog: Updated for release of findutils-4.2.14.

	* NEWS, configure.in, po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	Preparing to release findutils-4.2.14

2005-01-25  James Youngman  <jay@gnu.org>

	* NEWS, configure.in, po/da.po, po/de.po, po/es.po, po/et.po,
	po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po,
	po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po,
	po/sv.po, po/tr.po: Preparing to release findutils-4.2.14

2005-01-24  James Youngman  <jay@gnu.org>

	* Makefile.am: Work around the fact that automake-1.7 actually
	works, and correctly distributes regex.c; hence dist-hook should
	only copy gnulib/lib/regex.c if this has not already been done.

	* find/defs.h, find/find.c, find/pred.c,
	find/testsuite/Makefile.am,
	find/testsuite/find.gnu/printf-symlink.exp,
	find/testsuite/find.gnu/printf-symlink.xo,
	find/testsuite/find.gnu/xtype-symlink.exp,
	find/testsuite/find.gnu/xtype-symlink.xo: Fixes for -xtype and
	-printf %Y, which had been the wrong way around.

	* NEWS: Avoid including the find.gnu subdirectory in the
	distributed file more than once

	* locate/locate.c:
	Move the printing of the statistics into a new function, print_stats()

	* find/testsuite/Makefile.am: Avoid including the find.gnu
	subdirectory in the distributed file more than once

	* import-gnulib.sh:
	We need the regex module anyway, to allow compilation on Solaris

2005-01-23  James Youngman  <jay@gnu.org>

	* configure.in:
	Invoke gl_INCLUDED_REGEX directly to ensure successful compilation on
	systems like Solaris, which lacks those functions in libc (fixes GNU
	Savannah bug #11710).

	* locate/locate.1: -S is a synonym for --statistics

	* doc/find.texi: Documented the new -H, -L and -P options.

	* locate/locate.1, locate/locate.c: Implement options -L
	(default), -H and -P, which mean the same things as for find,
	except for the fact that the default is -L rather than -P

	* find/find.1: Corrected definition of the exit status for -quit.

	* find/find.c, find/pred.c: If DEBUG_STAT is set, issue a debug
	message when we call chdir() so that we can figure out what is
	actually being stat()ed

	* locate/updatedb.sh:
	Removed spurious newline from help message (bug report from Karl
	Berry).

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot,
	po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po,
	po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po,
	Makefile.am, NEWS, configure.in, find/defs.h, find/find.c,
	find/parser.c, find/pred.c, find/tree.c, find/util.c,
	import-gnulib.sh, lib/savedirinfo.c: Merged the d_type
	optimisation code; this is disabled by default, and can be enabled
	with 'configure --enable-d_type-optimisation'

	* NEWS:
	Updated optimisation NEWS item to indicate the effect on runtime.

2005-01-22  James Youngman  <jay@gnu.org>

	* NEWS, configure.in: Prepare for release of findutils-4.2.12

	* ChangeLog: Brought up to date with recent changes.

	* Makefile.am, import-gnulib.sh, po/Makefile.in.in, po/Makevars,
	po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot,
	po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po,
	po/pl.po, po/pt_BR.po, po/remove-potcdate.sin, po/ru.po, po/sk.po,
	po/sv.po, po/tr.po: Switch to using the gnulib gettext module, to
	ensure that 'make distcheck' works with current xgettext,
	autoconf, etc.

	* find/testsuite/config/unix.exp:
	Oops, we do need to clean up after all.

2005-01-21  James Youngman  <jay@gnu.org>

	* xargs/testsuite/Makefile.am: Added name of missing input file.

	* find/testsuite/Makefile.am:
	Distribute a few files that we had forgotten about

	* xargs/testsuite/Makefile.am: Added some missing files.

	* lib/Makefile.am: Also need buildcmd.h.

	* xargs/testsuite/Makefile.am: Fixed a typo.

	* NEWS: Indicate the d_type performance improvement

2005-01-18  James Youngman  <jay@gnu.org>

	* lib/savedirinfo.h: Added on d_type_optimisation also

	* lib/savedirinfo.c: Added on branch d_type_optimisation also.

	* find/pred.c: Added assert that we actually know the file type by
	the time pred_type() is called

	* find/find.c: Always initialise state.have_stat = false when
	starting to work with a new file

2005-01-17  James Youngman  <jay@gnu.org>

	* ChangeLog: Brought up to date with recent changes.

	* NEWS: Documented the changes so far.

	* find/testsuite/find.gnu/exec-many-rtn-success.xo:
	Expected output for exec-many-rtn-success.exp

	* find/find.1:
	Indicate that -quit still ensures that pending commands are invoked

	* doc/find.texi:
	Indicate that -quit still causes partial command lines to be invoked,
	but there are some types of fatal error which leave such commands
	uninvoked.

	* find/defs.h, find/find.c, find/pred.c, find/testsuite/Makefile.am, find/testsuite/config/unix.exp:
	Fixed savannah bug  #11625 Wrong return status for -exec ... \; when command fails; also execute any pending commands when doing -quit

	* find/testsuite/find.gnu/exec-many-rtn-failure.exp, find/testsuite/find.gnu/exec-many-rtn-failure.xo, find/testsuite/find.gnu/exec-many-rtn-success.exp, find/testsuite/find.gnu/exec-one-rtn-fail.exp, find/testsuite/find.gnu/exec-one-rtn-fail.xo, find/testsuite/find.gnu/exec-one-rtn-success.exp, find/testsuite/find.gnu/exec-one-rtn-success.xo:
	Various test cases for succeeding and failing forms of -exec \; and -exec {} +

	* find/pred.c: "-exec ... {} +" always returns "true".

	* configure.in, find/defs.h, find/find.c, find/parser.c, find/pred.c, find/tree.c, find/util.c:
	Implemented d_type optimisation but not working correctly, so currently disabled

	* lib/savedirinfo.h, lib/savedirinfo.c:
	Initial implementation (temporarily disabled).

	* lib/Makefile.am: Resolved merge conflict.

	* lib/Makefile.am:
	Make sure nextelem.h is included in the list of sources.

	* find/parser.c, lib/nextelem.c, lib/nextelem.h, locate/locate.c:
	Use prototypes for next_element() to make sure it is called correctly.

2005-01-16  James Youngman  <jay@gnu.org>

	* find/find.c, find/pred.c:
	When completing incomplete multiple execs, use 'eval_tree' not 'predicates'

	* lib/buildcmd.c:
	Oops, initialise state->cmd_initial_argv_chars to zero.

	* find/find.1:
	Document the way that -execdir and -okdir will refuse to wqork if ">"
	is on $PATH.  Also document -okdir in the manpage.

	* find/parser.c:
	-execdir and -okdir are insecure if $PATH includes the current
	 directory, and so they refuse to work if the user has done that.

	* find/pred.c:
	Oops; for -exec ... {} +, pass arguments to bc_push_arg() in the right
	order.   Problem spotted by Geoff Clare.

	* TODO: Removed items which have now been done.

	* lib/buildcmd.c: Tidied up formatting of arg list for bc_do_insert

2005-01-15  James Youngman  <jay@gnu.org>

	* find/testsuite/find.gnu/printf.exp, find/testsuite/find.gnu/printf.xo:
	Added extra tests for more printf formats; patch by Andreas Metzler

	* locate/locate.c:
	Ensure that the new long options have a relevang short option too.
	Also bring usage message into line with the options actually
	supported.  Thanks to Bas van Gompel for noticing this defect.

	* locate/locate.1:
	Escape "-" in SYNOPSIS.  Thanks to Bas van Gompel for noticing this
	defect.

	* ChangeLog: Fixed typos.

	* doc/find.texi:
	Documented -execdir, and the "+" variants of -exec and -execdir.

	* find/find.1: Documented -execdir.

	* xargs/xargs.c:
	Updated to bring into line with bc_*() interface changes

	* ChangeLog: Updated with recent changes.

	* find/defs.h, find/parser.c, find/pred.c, lib/buildcmd.c, lib/buildcmd.h:
	Implemented -execdir and -okdir

	* find/defs.h, find/find.c, find/fstype.c, find/parser.c, find/pred.c, lib/buildcmd.c, lib/buildcmd.h, xargs/xargs.c:
	First working version of -exec ...+

2005-01-09  James Youngman  <jay@gnu.org>

	* find/defs.h, find/find.c, find/parser.c, find/pred.c, lib/buildcmd.c, lib/buildcmd.h, xargs/xargs.c:
	Initial implementation of -exec ..{} +, but currently disabled since not yet working

2005-01-08  James Youngman  <jay@gnu.org>

	* find/find.c: Fixed typo in comment.

	* find/defs.h, find/find.c, find/parser.c, find/pred.c:
	We now understand but do not implement -execdir (a *BSD invention, and a very useful security enhancement) and -okdir (the obvious companion to it)

	* locate/bigram.c, locate/code.c, locate/frcode.c, locate/locate.c, xargs/xargs.c:
	The GNU coding standard requires a space between the function name and
	its parenthesised argument list.

	* find/defs.h:
	Understand the -exec ... {} \+ construction (for multiple
	replacement).  No support yet.

	* locate/locate.1:
	Indicate that empty elements in the dbpath are treated as synonyms for
	the default database.

	* locate/locate.c:
	Support empty elements in the dbpath as synonyms for the default
	database.  These colons can be leading, trailing or in the middle of
	the string.  We no longer com,plain if the user does this.

	* lib/nextelem.c:
	If curdir_ok is 0 and an element is empty, return "" instead of NULL
	so that the caller knows to keep calling us.

	* find/find.c, find/pred.c, import-gnulib.sh, locate/bigram.c, locate/code.c, locate/frcode.c, locate/locate.c, xargs/xargs.c:
	Savannah bug 11517: find, xargs, locate, etc. should not hide write failures; patch from Jim Meyering

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	changed .pot creation date

	* THANKS, AUTHORS: Take into account the FSF copyright-assignments list

	* doc/find.texi:
	If -quit is used, the exit value can be nonzero if errors have occurred.

	* find/find.1:
	Removed incorrect comment about -H, -P and -follow in HISTORY.

2005-01-07  James Youngman  <jay@gnu.org>

	* lib/Makefile.am, lib/buildcmd.c, lib/buildcmd.h, xargs/xargs.c:
	Refactored xargs to use an external library function from the new file buildcmd.c

	* configure.in: no longer the same as the released 4.2.11 version

2005-01-06  James Youngman  <jay@gnu.org>

	* xargs/testsuite/inputs/lines.xi, xargs/testsuite/xargs.posix/l2.exp, xargs/testsuite/Makefile.am:
	Tests for the -L option

	* xargs/testsuite/config/unix.exp: When a test fails, show the diffs

	* xargs/testsuite/xargs.posix/l2.exp, xargs/testsuite/xargs.posix/l2.xo:
	tests for the -l option

	* xargs/testsuite/Makefile.am: Added extra test files

	* xargs/testsuite/xargs.sysv/trace.exp, xargs/testsuite/xargs.sysv/trace.xe, xargs/testsuite/xargs.sysv/trace.xo:
	Added tests for the -t option

	* xargs/testsuite/config/unix.exp, xargs/testsuite/inputs/foobar.xi, xargs/testsuite/xargs.gnu/r.exp, xargs/testsuite/xargs.gnu/r.xo, xargs/xargs.1:
	Use a blanks-only input file for cases where there is supposed to be no output

	* xargs/testsuite/inputs/blank.xi: Initial version.

	* xargs/xargs.1:
	Corrected a typo; also indicate that it's impossible to use xargs
	securely due to the race condition.

2005-01-05  James Youngman  <jay@gnu.org>

	* find/parser.c:
	Fixed Savannah bug 11495: fallthrough from -printf format processing
	from 'n' case to 'd' case.

2005-01-03  James Youngman  <jay@gnu.org>

	* doc/find.texi:
	Oops.  Had duplicated an entire section.  Fortunately this was after
	@bye, so there was no adverse effect.

	* NEWS: locate -b.

	* doc/find.texi, locate/locate.1: document locate -S

	* configure.in, doc/find.texi, locate/locate.1, locate/locate.c:
	Support locate -b as a synonym for locate --basename

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	distcheck

	* find/testsuite/config/unix.exp:
	Clean up (delete) find.out at at the end of the test.

	* NEWS, doc/find.texi, find/defs.h, find/find.1, find/find.c, find/parser.c, find/pred.c:
	Implemented the -samefile test for find

2005-01-02  James Youngman  <jay@gnu.org>

	* ChangeLog: Updated with recent changes.

	* NEWS:
	Bas van Gompel: two-line patch to locate.c to make locate's -i and -w
	options work if -e is in use.

	* THANKS: Added Bas van Gompel.

	* locate/locate.c:
	Bas van Gompel: (visit_exists) when testing for the existence of the
	file, check the real filename [printname], not the case-converted
	filename [testname].  Really these argument names are badly chosen.

	* find/find.1, doc/find.texi:
	Improved the documentation for -perm, with plenty of examples,
	following a comment by Dan Jacobson that the comment "Symbolic modes
	use mode 0 as a point of departure" is baffling and unhelpful.

	* locate/locate.c:
	Suggestion and patch from Bas van Gompel: (new_locate): Fix display of
	negative compression ratios.

2004-12-31  James Youngman  <jay@gnu.org>

	* NEWS: Brought up to date with recent changes

	* doc/find.texi:
	Don't need to nest the "race conditions with..." sections so deeply.

	* doc/find.texi: Corrected some spelling errors.

	* doc/find.texi: Added new "Security Considerations" chapter.

2004-12-23  James Youngman  <jay@gnu.org>

	* locate/locate.c:
	Applied bugfixes from Bas van Gompel <patch-findutils.buzz@bavag.tmfweb.nl>.
	(lc_strcpy): Zero-terminate result.
	(add_visitor): Update lastinspector.
	(visit_substring_match_casefold): fix off-by-one error.
	(new_locate): Move visit_exists down to improve performance.
	(new_locate): Don't fold case when getting stats.

2004-12-19  James Youngman  <jay@gnu.org>

	* doc/find.texi:
	Indicate that "cd /; find tmp -wholename /tmp" will never match anything.

	* doc/find.texi: Documented locate --statistics.

	* locate/locate.1: Documented the --statistics option.

	* locate/locate.c: Added support for the -S option.

2004-12-12  James Youngman  <jay@gnu.org>

	* NEWS: Added a summary of the changes so far.

	* find/tree.c: Made some of the error messages more self-explanatory

	* find/pred.c: Print pointers with %p, not %x.

	* find/find.c: Moved option data into struct options.

	* find/find.1: clarifications

	* find/testsuite/find.gnu/comma.exp:
	Limit the amount of searching with maxdepth.

	* doc/find.texi: clearer description of how -prune works

	* ChangeLog: Removed duplicate entry.

	* configure.in, find/defs.h, find/find.c, find/fstype.c, find/parser.c, find/pred.c, find/tree.c, find/util.c:
	Separated ariables representing current state from variable representing option information

2004-12-11  James Youngman  <jay@gnu.org>

	* find/parser.c: Readability improvement to the usage message.

	* find/find.c: Oops.  Fixed unmatched #endif.

	* find/testsuite/find.gnu/printf.exp, find/testsuite/find.gnu/printf.xo, THANKS, configure.in, find/testsuite/Makefile.am, find/testsuite/config/unix.exp:
	Fixed Savannah bug #11280

	* find/find.c:
	Remember to set path_length and curdepth in process_top_path().

2004-12-07  James Youngman  <jay@gnu.org>

	* find/fstype.c: Use xstat() not stat() to examine things.

	* find/find.c: Explain why #ifdef EOVERFLOW.

	* find/find.c: EOVERFLOW is not defined on UNICOS.

	* NEWS: Corrected typo.

2004-12-06  James Youngman  <jay@gnu.org>

	* ChangeLog: Brought up to date.

	* NEWS, configure.in: releasing 4.2.10

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	distcheck

	* ChangeLog: Updated prior to release of finsutils-4.2.10.

	* import-gnulib.sh, find/fstype.c:
	Use gnulib's mountlist module instead of grokking it ourselves.

	* configure.in:
	Removed all the out-of-date cruft for grokking getmntent().

	* xargs/xargs.c:
	Added the -I and -L options; also -E takes an argument which is not optional.

2004-12-05  James Youngman  <jay@gnu.org>

	* README, configure.in, find/defs.h, find/find.c, find/parser.c, find/pred.c, find/tree.c:
	Allow debug output to be turned on or off by saying --enable-debug on the configure command line

	* README:
	Removed disparaging (it is now, it probably wasn't then) comment about
	the production-readiness of Automake.

	* README: Qualify remarks about POSIX compliance.

	* NEWS, configure.in: Preparation for release 4.2.9

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	distcheck

	* ChangeLog: Brought up to date.

	* find/find.c:
	Avoid duplicate error message when we cannot chdir() into a subdirectory.

	* THANKS: Added recent thankees.

	* NEWS:
	Brought up to date with respect to the current set of fixed bugs.

	* NEWS, xargs/xargs.1, xargs/xargs.c:
	Implemented POSIX options -L, -I and -E

2004-12-03  James Youngman  <jay@gnu.org>

	* find/parser.c:
	-xdev is an option, not a test.   Fixes Savannah bug 11192.

	* find/find.1, xargs/xargs.1:
	Escape dashes with a backslash (for fix Savannah bug 11189).

2004-11-27  James Youngman  <jay@gnu.org>

	* find/find.c:
	More use of safely_chdir(). Also bugfix: -L should imply -noleaf.  Be more careful about when xstat should fall back on lstat() when stat() fails.

	* find/find.1: "necessary" only has one "C".

	* find/find.1:
	If stat() fails with ELOOP, we issue a diagnostic message.

2004-11-26  James Youngman  <jay@gnu.org>

	* find/find.c: Removed some unused code.

	* Makefile.am: Don't do anything in the 'intl' subdirectory

	* find/find.c:
	Enhanced safely_chdir() to the point where the test suite passes, and report infinite loops in the directory hierarchy

	* find/defs.h:
	belt and braces; ensure that SYMLINK_NEVER_DEREF has value zero

	* find/find.1:
	Describe our strategy for detecting and reporting infinite loops

2004-11-24  James Youngman  <jay@gnu.org>

	* doc/find.texi:
	Updated the discussion of th error messages for findutils-4.2.8.

	* configure.in: Next version will be 4.2.9...

	* find/find.c:
	Don't issue a warning if we notice the mounting of a filesystem that's
	likely just to be an automounter.

	* doc/find.texi, find/find.1:
	Explain how rounding is performed for -atime and friends.

	* xargs/xargs.c:
	Once we collect enough arguments (for the value specified by the -n
	option) to do an exec(), do it immediaely instead of waiting for the
	next one to arrive.  This fixes Savannah bug #7340.

	* ChangeLog, configure.in, NEWS: Prepare to release 4.2.8.

	* NEWS: Updates for 4.2.8.

	* configure.in: check for  sys/types.h

	* find/find.c:
	If wd_sanity_check() discovers that the mount table has changed, remember the updated device number and inode so that we also consider these to be valid on the way back up.

	* find/defs.h:
	Declarations of xmalloc() and friends belong in xalloc.h, not in defs.h

	* find/parser.c: avoid signed/unsigned warning, and #include xalloc.h

	* find/fstype.c:
	Changed to alloc get_mounted_devices() to compile on Solaris

	* README-CVS:
	Automake requires GNU m4, so point out that the reader needs that.

	* find/defs.h, find/find.c, find/fstype.c:
	When wd_sanity_check() fails, enumerate the mounted devices, rather than the mounted filesystem names

	* NEWS: prepare for 4.2.8

	* configure.in:
	Look for some Solaris headers which are used by get_mounted_devices()

	* lib/Makefile.am: don't build savedirtypes yet

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	updated po files

	* m4/nullsort.m4:
	Avoid suprious output of the test data when the tests fail.

2004-11-21  James Youngman  <jay@gnu.org>

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	Messages changed again

	* ChangeLog, configure.in: Preparing to release 4.2.7.

	* NEWS: Updated for release of 4.2.7.

	* import-gnulib.sh: Also need canonicalize module.

	* find/find.c:
	When checking to see if a filesystem has changed state, use an
	absolute pathname.

	* configure.in:
	No need to pause to allow James to view his handiwork, it (allegedly)
	works now.

	* configure.in:
	Oops.  Check for setlocale() to re-enable the i18n support which was
	accidentally disabled in 4.2.5.

	* find/find.c:
	Check to see if the new directory is a transitioned mount point by
	using its ABSOLUTE name, if we can figure it out.

	* doc/find.texi:
	Added guidance on some of the error messages.  Not the most common
	ones, but the ones where the user might most benefit from some handy
	hints or an explanation of what is going on.

	* find/pred.c:
	Actually emit an error message if we fail to stat a symlink (for
	reasons other than nonexistence of the link and infinite loop).

	* doc/texinfo.tex: Updated texinfo.tex

	* NEWS, configure.in, find/find.c, find/fstype.c:
	Enable the 'Warning: filesystem XXX has recently been mounted' check on Solaris, which prevents it exiting fatally when traversing an automount mount point

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	messages changed again

	* NEWS: Implemented xargs --arg-file.

	* doc/find.texi, xargs/xargs.1, xargs/xargs.c, NEWS:
	Implemented xargs --arg-file

	* find/find.c:
	Where a filesystem was recently (un)mounted, try togive its full name

	* configure.in:
	Try to avoid requesting -lsun if we don't seem to need it (e.g. on
	UNICOS where it is not present and trying to link against it produces
	a warning).

	* find/defs.h, lib/modetype.h: Guard against multiple inclusion

	* find/fstype.c:
	We now need <mntent.h> even if we are not using getmntent() to figure
	out the type of a filesystem, because wd_sanity_check() needs to
	enumerate the system mount points.

	* configure.in: Next release will be 4.2.7.

	* find/fstype.c:
	get_mounted_filesystems() should use getmntent() if that function is
	present, rather than just if configure didn't find anything better for
	filesystem_type_uncached() to use than that.

	* find/parser.c:
	If -delete is the only action on a file, don't assume the default
	-print action too.

	* ChangeLog, configure.in, po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	Preparation to release findutils-4.2.6.

	* find/Makefile.am, xargs/Makefile.am:
	Enable checking of support for --version and --help

	* locate/Makefile.am:
	Con't check command-line options for frcode, code or bigram

	* locate/code.c: Support --version and --help.

	* ChangeLog: *** empty log message ***

	* find/defs.h, find/find.c, find/fstype.c, lib/Makefile.am, lib/extendbuf.c, lib/extendbuf.h, NEWS:
	Avoid fatal error if automount mounts a filesystem on a directory because we chdir()ed into it

	* configure.in: Next release will be 4.2.6.

	* find/find.1:
	Indicate that the '-' flag does work for most fields.   Also provide
	an example of using the comma operator to traverse the filesystem just
	once but search for more than one thing.

	* doc/find.texi: Indicate that the '-' flag does work for most fields.

2004-11-19  James Youngman <jay@gnu.org>

	* configure.in: releaseing findutils-4.2.5

	* find/testsuite/Makefile.am, locate/testsuite/Makefile.am, xargs/testsuite/Makefile.am:
	If a directory has no Makefile.am, omit it from the parent's DIST_SUBDIRS - automake-1.9 requires this

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	updated by make distcheck

	* ChangeLog, NEWS: Updated for release 4.2.5.

	* find/find.1, doc/find.texi:
	Tell the reader that format flags may not work as they expect.

	* configure.in:
	Use the correct name for the macro gl_AC_TYPE_LONG_LONG (not
	jm_AC_TYPE_LONG_LONG).

2004-11-15  James Youngman <jay@gnu.org>

	* import-gnulib.sh:
	Avoid test -e because not all systems are POSIX-compliant (bug
	#11005).  Also don't need regex module any more if we're not building
	in intl.

	* Makefile.am, configure.in:
	These days gnulib likes to include 'libintl.h' which our very old intl/ directory lacks.   For the moment, disable use of the internal intl/ directory

	* doc/find.texi:
	Use @ref not @xref for a reference at the beginning of a sentence.

	* intl/Makefile.in:
	Make sure gnulib.lib is on the #include path (Savannah bug #11002)

	* locate/locate.c:
	Use base_name instead of basename - fixes Savannah bug 11003.

	* configure.in, find/defs.h, find/find.c, find/parser.c, find/pred.c, locate/bigram.c, locate/locate.c:
	Don't need banner to emphasise the location of the call to jy_SORTZ

2004-11-12  James Youngman <jay@gnu.org>

	* NEWS, doc/find.texi, find/defs.h, find/find.1, find/find.c, find/parser.c, find/pred.c, find/testsuite/find.gnu/posix-dflt.exp, find/testsuite/find.gnu/posix-dflt.xo, find/testsuite/find.gnu/posix-h.exp, find/testsuite/find.gnu/posix-h.xo, find/testsuite/find.gnu/posix-l.exp, find/testsuite/find.gnu/posix-l.xo, find/util.c:
	Implemented BSD option -P and also the correct default behaviour of find with respect to symlinks if neither -L nor -H is specified [i.e. same as -P]

2004-11-11  James Youngman <jay@gnu.org>

	* NEWS, doc/find.texi, find/defs.h, find/find.1, find/find.c, find/parser.c:
	Implemented -H and -L options.

	* find/util.c: Added in the -H and -L options on the usage message.

2004-11-10  James Youngman <jay@gnu.org>

	* doc/find.texi, find/find.1, find/parser.c, find/pred.c:
	Implemented %M and %A+ format specifiers

	* doc/find.texi, find/find.1, find/parser.c, find/pred.c:
	Documented the fact that only %d and %m format specifiers honour the various formatting flags

	* xargs/xargs.c:
	Get the right number of bytes in a Kilobyte (hint: it's not 1048; that
	was a typo, honest :)

	* po/pl.po: Applied Polish translations

2004-11-08  James Youngman <jay@gnu.org>

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sk.po, po/sv.po, po/tr.po:
	distcheck changed the po files again

	* locate/Makefile.am:
	Make install-data-hook honour the setting of DESTDIR so that "make
	DESTDIR=/tmp/foo install" works and puts localstater in the right
	place.

	* configure.in: We're now working on findutils-4.2.5.

	* doc/find.texi, xargs/xargs.1:
	Point out that xargs -i only splits input items at newlines

	* ChangeLog: Indicate that we released 4.2.4.

	* ChangeLog: Updated for release 4.2.4

	* NEWS, configure.in: Prepare for release of 4.2.4.

	* NEWS: Brought up to date with latest changes.

	* NEWS, doc/find.texi, find/defs.h, find/find.1, find/find.c, find/parser.c, po/da.po, po/de.po, po/es.po, po/findutils.pot, po/gl.po, po/id.po, po/ko.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sv.po:
	Turn warning messages off by default if stdin is not a tty; allow these to be controlled explicitly by options -warn and -nowarn

	* po/et.po, po/it.po: Updated translation files

	* po/sk.po: New translation file

	* po/fr.po, po/nl.po, po/tr.po: Updated translation files

	* configure.in: Added Slovak (sk) language.

	* xargs/xargs.c:
	Enforcing a lower limit on the value specified by -s makes the test
	suite fail.  Removed that lower limit.

	* locate/Makefile.am: Oops, multilocate doesn't exist yet.

	* NEWS: *** empty log message ***

	* doc/find.texi, locate/updatedb.1, locate/updatedb.sh:
	Added option --findoptions to updatedb

	* locate/Makefile.am, locate/locatedb.5, locate/updatedb.1, xargs/xargs.1:
	Fixed section numbers in manpage titles and cross-references

	* NEWS, doc/find.texi, xargs/xargs.1, xargs/xargs.c:
	Increased the default argument length and improved POSIX compliance of the handling of out-of-range values for the -s option

2004-11-07  James Youngman <jay@gnu.org>

	* m4/Makefile.am:
	Added in the extra files we need to distribute, nullsort.m4
	order-bad.bin order-good.bin

	* doc/find.texi: Documented locate's --limit option

	* locate/locate.1, locate/locate.c:
	Implmented --limit and corrected the implementation of the -i option.

2004-11-06  James Youngman <jay@gnu.org>

	* NEWS, doc/find.texi, locate/locate.1:
	Documented --wholename and --basename and updated the NEWS file

	* README-CVS:
	Give the autogen commands in a form that you can usefully cut and paste into a shell

	* NEWS: Options --null and --count) for locate

	* lib/nextelem.c:
	Don't return '.' for an empty path element, because the path we are splitting may not be intended to contain directories

	* configure.in: we're working on findutils-4.2.4 now

	* locate/Makefile.am: Substitute @SORT_SUPPORTS_Z@

	* doc/find.texi:
	Documented new locate option --null and newline handling

	* locate/locate.1, locate/locate.c:
	New locate options --null, --wholename, --basename, --count

	* locate/frcode.c, locate/updatedb.1, locate/updatedb.sh:
	correctly handle newlines in the file names

	* configure.in: Determine if sort -z works

	* m4/nullsort.m4, m4/order-bad.bin, m4/order-good.bin:
	jy_SORTZ: a macro to determine if the system has a sort command with a working -z option

2004-11-01  James Youngman <jay@gnu.org>

	* NEWS: Fixed "find -printf '%H\n'".

	* find/find.c:
	Avoid segfault if -printf %H is used where the matched file was the default, unspecified starting point, the current directory

2004-10-31  James Youngman <jay@gnu.org>

	* find/find.1, find/parser.c: NetBSD also supports -d.

	* find/find.1, doc/find.texi:
	Documented the behaviour of -daystart and -follow in more detail

	* find/parser.c: Corrected the usage message.

	* find/parser.c:
	When deciding whether to issue a warning about options following
	non-options, ignore any options whose position affects the tests
	(i.e. -daystart and -follow).

	* find/parser.c: -daystart is a positional option like -follow.

	* find/parser.c:
	Issue a warning message if an option is specified after a test or an
	action (because the user might have believed that the behaviour of the
	option is in some way conditional on the preceding tests).

	* locate/updatedb.sh:
	Oops; removed some test code that I shouldn't have checked in.

	* locate/updatedb.sh:
	Indicate that the old locate database format will shortly be unsupported.

	* doc/find.texi:
	Use @direntry instead of hard-coding START-INFO-DIR-ENTRY inside @ifinfo.

	* locate/updatedb.1: Updated default location of locatedb file.

	* README-alpha:
	Updated to give correct FTP location and to not talk about "test"
	versions of automake, which are no longer required.

	* locate/updatedb.sh:
	Incorporated the default list of filesystems to avoid from the Debian
	package.  Also added /afs and /sfs to the default pruned paths.

	* configure.in: Released findutils 4.2.3

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sv.po, po/tr.po:
	did make distcheck, which updates these files

	* find/defs.h, find/fstype.c:
	Use const qualifier in arguments to filesystem_type() to allow callers with const variables to use them

	* ChangeLog: Updated.

	* NEWS: Added new news.

	* find/find.c:
	Extra diagnositcs for the case where we have the error "%s changed
	during execution of %s" - that is when we chdir back to the parent
	directory only to find that it has changed.

2004-10-30  James Youngman <jay@gnu.org>

	* .cvsignore, NEWS, doc/find.texi, find/defs.h, find/find.1, find/parser.c, find/pred.c:
	Implemented the -quit action

	* NEWS, doc/find.texi, find/find.1, find/parser.c, find/pred.c:
	Refactored time handling routines in preparation for support of absolute timestamp comparison predicates

	* locate/locate.c:
	Applied Savannah patch #2952 ("getline off-by-one bugfix").

	* NEWS, doc/find.texi, find/defs.h, find/find.1, find/parser.c, find/pred.c:
	Added -delete action (Savannah patch #3454 with additions)

	* locate/locate.c:
	Applied Savannah patch #2692 (allowing get_short to process negative integers).

	* find/find.c:
	If we are iossuing an error message because $FIND_BLOCK_SIZE is set,
	ignore the setting of errno.

	* find/parser.c: More fixes for pedantic compiler warnings

	* NEWS, find/parser.c, find/tree.c: Eliminated some compiler warnings

	* find/find.c, find/parser.c, find/pred.c:
	Various fixes for compiler warninga sbout unreachable code or unused function arguments

	* intl/plural.y: Silence compiler warning about unused argument.

	* locate/testsuite/Makefile.am:
	Subdirectory "inputs" does not exist, so remove it from DIST_SUBDIRS.

	* locate/locate.c:
	Corrected the explanation of why we have to use no parentheses around
	the String argument to the N_ macro in its expansion.

	* configure.in: Nextr release is 4.2.3.

	* configure.in: IOndicate this is no longer the pristine release.

	* NEWS:
	Oops, comments for release 4.2.0 should have said 20480 bytes, not 2480.

	* lib/listfile.c:
	The -ls predicate should not truncate usernames.  Fixes Savannah bug #10800.

	* find/fstype.c, locate/locate.c:
	Fixes for Savannah bug #3727 (Intel icc compilation errors).

2004-10-25  James Youngman <jay@gnu.org>

	* doc/find.texi, find/find.1, find/parser.c, find/pred.c:
	Support -printf %D, which prints the device number of the containing filesystem

	* locate/updatedb.sh:
	Avoid confusion between James Woods and James Youngman, by using the
	disambiguating surname.

	* find/parser.c: Use RE_ICASE instead of re->translate.

	* configure.in, find/parser.c, find/pred.c, xargs/xargs.c:
	No need to #define _GNU_SOURCE if we use gl_INIT.

2004-10-24  James Youngman <jay@gnu.org>

	* ChangeLog: Prepared to release findutils-4.2.2.

	* ChangeLog, NEWS, po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sv.po, po/tr.po:
	Updates prior to release of 4.2.2

	* NEWS: Updated with news for findutils-4.2.2.

	* find/testsuite/config/unix.exp, lib/forcefindlib.c, lib/listfile.c, lib/modetype.h, lib/nextelem.c, locate/bigram.c, locate/code.c, locate/frcode.c, locate/locate.c, locate/locatedb.h, locate/testsuite/config/unix.exp, locate/updatedb.sh, xargs/testsuite/config/unix.exp, xargs/xargs.c, NEWS, find/defs.h, find/find.c, find/fstype.c, find/parser.c, find/pred.c, find/tree.c, find/util.c, import-gnulib.sh:
	Corrected typo in the address of the FSF office

	* lib/strspn.c: Updated FSF address.

	* m4/.cvsignore: 'cvs status' should ignore Makefile.in

	* m4/Makefile.am, Makefile.am, NEWS, README-CVS, configure.in, doc/texinfo.tex, find/defs.h, find/fstype.c, find/parser.c, find/pred.c, import-gnulib.sh, intl/bindtextdom.c, intl/dcgettext.c, intl/dcigettext.c, intl/dcngettext.c, intl/dgettext.c, intl/dngettext.c, intl/explodename.c, intl/finddomain.c, intl/gettext.c, intl/intl-compat.c, intl/l10nflist.c, intl/loadmsgcat.c, intl/localcharset.c, intl/localealias.c, intl/ngettext.c, intl/plural.y, intl/textdomain.c, lib/Makefile.am, lib/forcefindlib.c, lib/listfile.c, lib/nextelem.c, lib/strspn.c, lib/waitpid.c, locate/bigram.c, locate/code.c, locate/frcode.c, locate/locate.c, m4/findlib.m4, po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sv.po, po/tr.po, xargs/xargs.c:
	Use gnulib-tool --import to import the gnulib code, rather than the odd way we were doing it before

	* find/find.c, find/fstype.c, find/parser.c, find/pred.c, find/tree.c, find/util.c, locate/code.c, locate/locate.c, xargs/xargs.c:
	Work round an apparent compiler bug in HP-UX 11.23 for
	ia64

	* locate/locate.c:
	Work around what appears to be a C compiler bug in HP-UX 11.23 for
	ia64.

	* INSTALL, depcomp, install-sh, missing, mkinstalldirs:
	Updated from automake

	* locate/bigram.c, locate/code.c, locate/frcode.c, locate/locate.c, xargs/xargs.c, find/find.c:
	Avoid use of exit() within main, to silence warnings about unreachable code

2004-10-22  James Youngman  <jay@gnu.org>

	* doc/find.texi: Syntax corrections.

	* doc/find.texi: Indicate that "-exec {}+" is not yet supported.

	* find/find.1: Indicate that "{}+" is not yet supported.

	* find/testsuite/find.gnu/name-period.xo, find/testsuite/find.gnu/name-period.exp, find/find.1, doc/find.texi:
	The -name predicate must allow '*' to match '.foo' as demanded by IEEE
	Std 1003.2-1992 Interpretation #126.

	* find/pred.c:
	Remove use of FNM_PERIOD for -name as demanded by IEEE Std 1003.2-1992
	Interpretation #126

	* find/parser.c: Fix for compilation (on AIX 4.3) with GCC 2.x.

	* xargs/xargs.c:
	Changed the erorr message issued when there is an unmatched quote to
	point out that the user might have wanted to use the -0 option instead.

2004-10-17  James Youngman  <jay@gnu.org>

	* configure.in:
	Define intmax_t if it is not already defined - allows parser.c to compile on AIX 4.3

	* configure.in:
	Adjust version number to indicate that this s/w has moved on since the
	4.2.1 release.

	* configure.in: preparing to release 4.2.1

	* ChangeLog: updated with current changes

	* README-CVS: Updated to go with newer version of gnulib.

	* po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sv.po, po/tr.po:
	preparation for release

	* NEWS: Mention the changes to "trap".

	* NEWS: Brought up to date.

	* import-gnulib.sh:
	Use xalloc-die module from gnulib, since that has now been split out

	* find/parser.c:
	Check fnmatch() when other predicates that rely on fnmatch() are used.

	* find/parser.c: bug #10701: find needs fnmatch sanitycheck on startup

2004-10-16  James Youngman <jay@gnu.org>

	* import-gnulib.sh:
	Switch to requirement for GNU fnmatch because it supports FNM_CASEFOLD.

	* locate/updatedb.sh:
	Bug #9465: use of signal numbers for 'trap' is deprecated.  Should use
	names instead.  See
	http://www.opengroup.org/onlinepubs/009695399/utilities/trap.html,
	which indicates that support for signal numbers is optional, while
	support for signal names is mandatory.

	* configure.in:
	Indicate that this is the CVS version (once again) now that findutils
	4.2.0 has been released.

	* ChangeLog, configure.in, po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sv.po, po/tr.po:
	findutils 4.1.20 check-in for tagging

2004-10-02  James Youngman <jay@gnu.org>

	* po/Makefile.in.in:
	Search in $(top_srcdir) for mkinstalldirs, since that's where we keep it.

	* NEWS: Brought up to date, organised more clearly, and tidied up.

	* NEWS: brought up to date with recent changes

	* locate/testsuite/config/unix.exp, locate/testsuite/locate.gnu/ignore_case1.exp, locate/testsuite/locate.gnu/ignore_case3.exp, locate/updatedb.sh:
	Added new option --changecwd to updatedb so that the 'cd /' which it does can be compatible with the requirements of the test suite.  Specifically, the test suite relies on being able to use relative pathnames

	* find/pred.c:
	Fixed usage of human_readable() in '%k' format specifier to fix a bug
	reported by Dmitry V. Levin (arguments to human_readable() were
	specified in the wrong order, which resulted in a floating-point
	error).

2004-08-08  James Youngman <jay@gnu.org>

	* locate/updatedb.sh:
	cd to / to avoid inability to examine the current directory if we're
	invoked via cron (and hence in root's home directory for example).

	* doc/find.texi, find/find.1:
	Deprecate -path and -ipath in favour of -wholename and -iwholename

	* find/parser.c:
	As per RMS's suggestion, deprecate -path and -ipath in favour of
	-wholename and -iwholename.

	* locate/locate.c:
	Fixed Savannah bug #9923, in which get_short() returns large positive
	ints when it should be returning negative shorts.

	* xargs/xargs.1:
	Applied documentation improvements suggested by Dan Jacobson
	<jidanni@jidanni.org>.

	* xargs/xargs.c:
	Don't check size_of_environment against arg_max since that causes the
	test suite to fail.

	* xargs/xargs.1, xargs/xargs.c: Better documentation for the -i option

2004-05-03  James Youngman <jay@gnu.org>

	* find/find.1:
	document the various suffixes for -size and also the new
	option -ignore_readdir_race

	* locate/locate.c:
	Fixes Savannah bug #8623 (failure to check consistency of data
	read from locate database)

	* locate/updatedb.sh:
	Resolves Savannah bug 4380, that updatedb generates an empty
	database if one of the commands fails

	* NEWS: Talk about -ignore_readdir_race

	* doc/find.texi:
	Documented -ignore_readdir_race and -noignore_readdir_race

	* find/find.c:
	-ignore_readdir_race should have no effect if the reason for the
	 failure of stat(2) was anything other than ENOENT.

	* find/defs.h, find/find.c, find/parser.c:
	Fixed Savannah bug 4391 (readdir race condition leading to
	spurious error messages)

2004-04-24  James Youngman <jay@gnu.org>

	* README-CVS: Corrected the instructions for getting gnulib via CVS.

2004-04-13  James Youngman <jay@gnu.org>

	* doc/find.texi:
	Actioned Savannah bug #8558 (find complains when it tries to recurse
	into directories that it had removed).

2004-03-13  James Youngman <jay@gnu.org>

	* ChangeLog: Updated from checkin comments.

	* find/find.c:
	Oops, there is no access to the predicate name table if DEBUG is
	not #defined.

	* find/parser.c:
	Detect arithmetic overflow (poorly) in insert_time(), which diagnoses
	the failure to handle large arguments to -mtime.  The existing code
	does careful computation and then bungs the value into a time_t, which
	ruins all our careful effort.  The new code is not a great
	improvement.  We just check the result to detect overflow, rather than
	actually avoiding the overflow.

	* find/find.c:
	Fixed Debian bug #185202 by checking for any trailing predicates after
	the top-level invocation of get_expr() has done its work.

	* locate/locate.1, xargs/xargs.1:
	Fixed Debian bug 175372, inappropriate 'L' suffixes on manual
	page section indicators

	* find/find.1:
	Removed "L" suffixes from manual page section indicators, to fix
	Debian bug 175372.

	* debian/updatedb.conf:
	Updated with list of filesystems from current Debian release.  This
	includes devfs, for example.

	* xargs/xargs.1:
	Modified documentation of "-s" option to take into account the fix for
	Debian bug #176201.

	* xargs/xargs.c:
	Fixed Debian bug #176201, "xargs enviroment size limited to 20k", by
	reading a patch offered by Bob Proulx and implementing something
	substantially similar myself.

2004-01-03  James Youngman  <jay@gnu.org>

	* xargs/xargs.c:
	Indicate that prep_child_for_exec() fixes Savannah bug #3992.

	* xargs/xargs.c:
	Attach the stdin of xargs' child process to /dev/null so that if it
	tries to read from its stdin it doesn't consume any of the list of
	files that xargs is trying to use.

	* find/find.1:
	Documented that the -regex option follows Gnulib's re_match()
	implementation.

	* NEWS, locate/locate.c: Applied Savannah patch 2108

	* xargs/xargs.c: Applied Savannah patch 1500

	* find/find.1, doc/find.texi:
	Improved the documentation for the %k and %b format specifiers to
	-printf (Savannah bug #5034).  Also pointed out that this handling is
	different to that used by the "b" and "k" suffixes with "-size".

	* find/find.1: Improved the documentation for %k (Savannah bug #5034).

	* find/find.1:
	Improved the documentation for -print0 in the manpage, fixing Debian
	bug 111143.

	* README-CVS, find/pred.c, lib/listfile.c:
	Brought up-to-date with change in gnulib's human.c - we no longer
	use human_readable_inexact(), because it is no longer provided.

2003-08-08  James Youngman  <jay@gnu.org>

	* find/find.1:
	Documented the fact that -printf also supports the '\0' escape code.
	Added "STANDARDS CONFORMANCE" section.

2003-08-02  James Youngman  <jay@gnu.org>

	* find/find.1:
	Explain that braces are not special when performing filename matching
	with -name.

	* find/find.1:
	added example of the use of -exec to the EXAMPLES section

	* find/fstype.c, locate/locate.c:
	Savannah bug #4295 - implicit declarations of ctype.h functions

	* locate/locate.c:
	Savannah bug #4279 - missing newline on locate help message

	* find/find.1, xargs/xargs.1:
	Improved discussion of the -print0 option of find and the -0 option of xargs

2003-06-26  James Youngman  <jay@gnu.org>

	* import-gnulib.sh:
	Remove reference to nonexistent module "basename" ("dirname" exists
	and we already use that).

2003-06-21  James Youngman  <jay@gnu.org>

	* doc/find.texi:
	Indicate that xargs stops immediately if a command exits with status 255

	* xargs/xargs.1:
	Document the fact that xargs exits immediately with an error message
	if the command it executes exits with a status of 255.

2003-06-18  James Youngman  <jay@gnu.org>

	* find/find.1:
	Indicate that -fls and friends always create their output file

2003-06-16  James Youngman  <jay@gnu.org>

	* ChangeLog, find/find.1, locate/locate.1, locate/locatedb.5, locate/updatedb.1, xargs/xargs.1:
	Added BUGS section to manual pages.   This section includes information about known bugs and how to report new bugs.

	* AUTHORS: Identify the current maintainer.

	* TODO: Removed the TODO items which have now been done.

	* THANKS: Added Bruno Haible and Bob Proulx.

	* xargs/xargs.c: xargs/xargs.c (DO_MULTIBYTE): New macro.
	(mbstrstr): New function.
	(do_insert): Use it instead of strstr.

	* config.guess, config.sub:
	Use config.guess and config.sub from automake

	* find/fstype.c:
	Bruno Haible: (fstype_to_string) Don't define this function if
	HAVE_F_FSTYPENAME_IN_STATFS is defined.

	* configure.in:
	Bruno Haible: Prefer the 4.4BSD API (if present) to the 4.3BSD API,
	because some 4.4BSD systems have <mntent.h> but no /etc/mtab file.

	* doc/find.texi, find/find.1:
	Applied patch 1498 (documenting the backslash escape sequence)

	* locate/updatedb.sh: Applied (my own version of) Savannah patch 1601.

	* doc/find.texi:
	Applied Savannah patch #1547 (document the fact that printf
	field-width specifiers are supported).

	* xargs/xargs.c:
	Applied Savannah patch #1499 (adds final newline to usage message).

2003-06-14  James Youngman  <jay@gnu.org>

	* NEWS, configure.in:
	Updated version number to 4.2.0-CVS [not ready for release yet]

	* configure.in, doc/.cvsignore, doc/Makefile.in, find/.cvsignore, find/Makefile.am, find/Makefile.in, find/defs.h, find/find.c, find/fstype.c, find/parser.c, find/pred.c, find/testsuite/.cvsignore, find/testsuite/Makefile.in, find/testsuite/config/unix.exp, find/tree.c, find/util.c, import-gnulib.sh, intl/bindtextdom.c, intl/dcgettext.c, intl/dcigettext.c, intl/dcngettext.c, intl/dgettext.c, intl/dngettext.c, intl/explodename.c, intl/finddomain.c, intl/gettext.c, intl/intl-compat.c, intl/l10nflist.c, intl/loadmsgcat.c, intl/localcharset.c, intl/localealias.c, intl/ngettext.c, intl/plural.y, intl/textdomain.c, lib/.cvsignore
	also need stpcpy (e.g. for Solaris)

	* intl/dcigettext.c:
	plural_lookup: don't use a variable called "index", because we may
	have done "#define strchr index", in which case using a variable
	called index will prevent us calling strchr(p, ch) in the same scope.

	* find/defs.h, find/find.c, find/fstype.c, find/parser.c, find/pred.c, find/testsuite/config/unix.exp, find/tree.c, find/util.c, import-gnulib.sh, lib/Makefile.am, lib/listfile.c, lib/modetype.h, lib/nextelem.c, locate/bigram.c, locate/code.c, locate/frcode.c, locate/locate.c, locate/locatedb.h, locate/testsuite/config/unix.exp, locate/updatedb.sh, xargs/testsuite/config/unix.exp, xargs/xargs.c:
	Updated copyright years and the address of the FSF

	* aclocal.m4, config.h.in, configure:
	Removed files that are generated from other files (e.g. configure)

	* NEWS: Updated NEWS file for 4.1.20.

	* configure.in, lib/Makefile.am, po/POTFILES.in, po/da.po, po/de.po, po/es.po, po/et.po, po/findutils.pot, po/fr.po, po/gl.po, po/id.po, po/it.po, po/ko.po, po/nl.po, po/pl.po, po/pt_BR.po, po/ru.po, po/sv.po, po/tr.po:
	Updates to the i18n files to ensure that 'make dist' succeeds

	* lib/posix/.cvsignore, lib/posix/Makefile.am,
	lib/posix/Makefile.in, lib/posix/regex.h, lib/strftime.c,
	lib/strncasecmp.c, lib/strspn.c, lib/strstr.c, lib/strtol.c,
	lib/strtoul.c, lib/strtoull.c, lib/strtoumax.c, lib/wait.h,
	lib/waitpid.c, lib/xalloc.h, lib/xgetcwd.c, lib/xmalloc.c,
	lib/xstat.in, lib/xstrdup.c, lib/xstrtol.c, lib/xstrtol.h,
	lib/xstrtoul.c, lib/xstrtoul.h, lib/xstrtoumax.c, lib/yesno.c,
	locate/Makefile.am, locate/Makefile.in, locate/locate.c,
	locate/testsuite/Makefile.in, m4/.cvsignore, m4/ChangeLog,
	m4/Makefile.am, m4/Makefile.am.in, m4/Makefile.in, m4/README,
	m4/afs.m4, m4/assert.m4, m4/c-bs-a.m4, m4/check-decl.m4,
	m4/codeset.m4, m4/d-ino.m4, m4/d-type.m4, m4/error.m4,
	m4/fnmatch.m4, m4/fnmatchcase.m4, m4/fstypename.m4, m4/getline.m4,
	m4/gettext.m4, m4/glibc.m4, m4/glibc21.m4, m4/iconv.m4,
	m4/inttypes_h.m4, m4/isc-posix.m4, m4/jm-glibc-io.m4,
	m4/jm-macros.m4, m4/jm-mktime.m4, m4/lcmessage.m4, m4/libintl.m4,
	m4/link-follow.m4, m4/ls-mntd-fs.m4, m4/lstat-slash.m4,
	m4/lstat.m4, m4/malloc.m4, m4/mbstate_t.m4, m4/memcmp.m4,
	m4/prereq.m4, m4/progtest.m4, m4/readdir.m4, m4/realloc.m4,
	m4/regex.m4, m4/st_dm_mode.m4, m4/st_mtim.m4, m4/stat.m4,
	m4/strerror_r.m4, m4/strftime.m4, m4/timespec.m4, m4/uintmax_t.m4,
	m4/ulonglong.m4, m4/xstrtoumax.m4, xargs/Makefile.am,
	xargs/Makefile.in, xargs/testsuite/Makefile.in,
	find/testsuite/Makefile.in, lib/.cvsignore, lib/Makefile.am,
	lib/Makefile.in, lib/alloca.c, lib/ansi2knr.1, lib/ansi2knr.c,
	lib/argmatch.c, lib/argmatch.h, lib/basename.c, lib/basename.h,
	lib/dirname.c, lib/dirname.h, lib/error.c, lib/error.h,
	lib/fileblocks.c, lib/filemode.c, lib/filemode.h, lib/fnmatch.c,
	lib/fnmatch.h, lib/getline.c, lib/getline.h, lib/getopt.c,
	lib/getopt.h, lib/getopt1.c, lib/human.c, lib/human.h,
	lib/idcache.c, lib/malloc.c, lib/memcmp.c, lib/memcpy.c,
	lib/memset.c, lib/mktime.c, lib/modechange.c, lib/modechange.h,
	lib/pathmax.h, lib/quotearg.c, lib/quotearg.h, lib/realloc.c,
	lib/regex.c, lib/regex.h, lib/rpmatch.c, lib/savedir.c,
	lib/savedir.h, lib/stpcpy.c, lib/strcasecmp.c, lib/strdup.c,
	find/Makefile.am, find/Makefile.in, find/find.c, find/pred.c:
	Updated to work with current version of gnulib

	* import-gnulib.sh: New file.

	* config.h.in, configure, configure.in, doc/Makefile.in, import-gnulib.sh:
	Updated to work with current version of gnulib

	* README-CVS: New file.

	* Makefile.am, Makefile.in, README-CVS, aclocal.m4:
	Updated to work with current version of gnulib

2003-05-26  James Youngman <jay@gnu.org>

	* po/pl.po, pt_BR.po, ru.po, sv.po, tr.po, da.po, de.po, es.po,
	et.po, findutils.pot, fr.po, gl.po, id.po, it.po, ko.po, nl.po:
	Changes to allow compilation on non-GNU systems (i.e. for the
	macros that gnulib decides to #define to be effective)

2003-05-24  James Youngman <jay@gnu.org>

	* po/da.po, de.po, es.po, et.po, findutils.pot, fr.po, gl.po,
	id.po, it.po, ko.po, nl.po, pl.po, pt_BR.po, ru.po, sv.po, tr.po:
	also need stpcpy (e.g. for Solaris)

	* po/POTFILES.in, da.po, de.po, es.po, et.po, findutils.pot, fr.po,
	gl.po, id.po, it.po, ko.po, nl.po, pl.po, pt_BR.po, ru.po, sv.po,
	tr.po: Updates to the i18n files to ensure that 'make dist'
	succeeds

2001-06-09  Kevin Dalley  <kevin@seti.org>

	* intl/plural.c:
	Changes the location of bison.simple after running bison on local
	machine

	* ChangeLog: *** empty log message ***

	* Makefile.in, aclocal.m4, config.h.in, configure,
	doc/Makefile.in, find/Makefile.in, find/testsuite/Makefile.in,
	lib/Makefile.in, lib/posix/Makefile.in, locate/Makefile.in,
	locate/testsuite/Makefile.in, m4/Makefile.in, xargs/Makefile.in,
	xargs/testsuite/Makefile.in: Updates mostly from gettext-0.10.38

	* ABOUT-NLS: * ABOUT-NLS: updated from gettext-0.10.38.

	* configure.in: * configure.in: add tr to ALL_LINGUAS.

	* intl/config.charset, intl/dcigettext.c, intl/dcngettext.c,
	intl/dngettext.c, intl/libgnuintl.h, intl/localcharset.c,
	intl/locale.alias, intl/ngettext.c, intl/plural.y,
	intl/ref-add.sin, intl/ref-del.sin: updated from gettext-0.10.38

	* intl/cat-compat.c, intl/linux-msg.sed, intl/po2tbl.sed.in,
	intl/xopen-msg.sed, m4/ChangeLog: *** empty log message ***

	* m4/jm-macros.m4:
	* jm-macros.m4 (jm_MACROS): remove jm_ICONV, which is replaced by
	AM_ICONV, which is imported from gettext-0.10.38.  removed
	jm_GLIBC21, which is required in AM_GNU_GETTEXT, which is
	imported from gettext-0.10.38.

	* po/stamp-cat-id:	* stamp-cat-id: Remove file.

	* po/Makefile.in.in:	* Makefile.in.in: Upgrade to gettext-0.10.38.

	* po/ChangeLog:	* cat-id-tbl.c: Remove file.

	* po/de.po, po/es.po, po/et.po, po/fr.po:
	* fr.po, et.po, es.po, de.po: updated translations to
	findutils-4.1.7.

	* po/tr.po: * tr.po:  New Turkish translation.

	* m4/ChangeLog: *** empty log message ***

	* intl/dgettext.c, intl/explodename.c, intl/finddomain.c,
	intl/gettext.c, intl/gettext.h, intl/gettextP.h,
	intl/hash-string.h, intl/intl-compat.c, intl/l10nflist.c,
	intl/libgettext.h, intl/loadinfo.h, intl/loadmsgcat.c,
	intl/localealias.c, intl/plural.c, intl/textdomain.c,
	intl/ChangeLog, intl/Makefile.in, intl/VERSION,
	intl/bindtextdom.c, intl/dcgettext.c: Updated from gettext-0.10.38

	* m4/Makefile.am:
	reflects addition of codeset.m4 from gettext-0.10.38, automatically
	generated.

	* m4/codeset.m4, m4/gettext.m4, m4/glibc21.m4, m4/iconv.m4,
		m4/isc-posix.m4, m4/lcmessage.m4, m4/progtest.m4: *
		progtest.m4, lcmessage.m4, isc-posix.m4, iconv.m4,
		glibc21.m4, gettext.m4, codeset.m4: updated from
		gettext-0.10.38.

	* ChangeLog: *** empty log message ***

	* THANKS: added "Gerrit P. Haase" <gerrit.haase@t-online.de>

	* m4/ChangeLog, locate/testsuite/.cvsignore,
	xargs/testsuite/.cvsignore, config.h.in, configure, aclocal.m4,
	doc/.cvsignore: *** empty log message ***

	* m4/jm-macros.m4:	* jm-macros.m4 (jm_MACROS): add jm_FSTYPENAME

	* doc/Makefile.in: *** empty log message ***

	* doc/Makefile.am:
	* doc/Makefile.am (MOSTLYCLEANFILES): add find.cps, which is
	created by dvips.  This should be taken care of by automake, but
	the code is commented out.

2001-06-09  Kevin Dalley  <kevin@seti.org>

	* ABOUT-NLS: updated from gettext-0.10.38.

	* configure.in: add tr to ALL_LINGUAS.

	* doc/Makefile.am (MOSTLYCLEANFILES): add find.cps, which is
	created by dvips.  This should be taken care of by automake, but
	the code is commented out.

	* po/stamp-cat-id:	* stamp-cat-id: Remove file.

	* po/Makefile.in.in:	* Makefile.in.in: Upgrade to gettext-0.10.38.

	* po/ChangeLog:	* cat-id-tbl.c: Remove file.

	* po/de.po, es.po, et.po, fr.po:
	* po/fr.po, et.po, es.po, de.po: updated translations to
	findutils-4.1.7.

	* po/tr.po: * tr.po:  New Turkish translation.

2001-06-05  Kevin Dalley  <kevin@seti.org>

	* locate/updatedb.sh: replace "whoami" with "id -u" when testing
	for root.

2001-06-04  Kevin Dalley  <kevin@seti.org>

	* locate/testsuite/Makefile.am (DIST_SUBDIRS): remove second
	instance of DIST_SUBDIRS.

	* locate/Makefile.am (install-data-hook): changed install target
	to install-data-hook, which still installs other files.

	* doc/Makefile.am (MOSTLYCLEANFILES): added find.cps, which should
	probably be handled by automake.

	* doc/mdate-sh: removed file in doc directory.  It now exists only
	in top_srcdir, but this changed required a patch to automake.

2001-06-01  gettextize  <bug-gnu-utils@gnu.org>

	* Makefile.in.in: Upgrade to gettext-0.10.38.
	* cat-id-tbl.c: Remove file.
	* stamp-cat-id: Remove file.

2001-05-20  Kevin Dalley  <kevin@seti.org>

	* Version 4.1.7

	* lib/Makefile.am (EXTRA_DIST): add strcasecmp.c

	* find/testsuite/Makefile.am (EXTRA_DIST): new tests:
	find.gnu/name-opt.exp find.gnu/perm.exp find.gnu/perm.xo
	find.gnu/prune-default-print.exp find.gnu/prune-default-print.xo

	* configure.in: update to 4.1.7

	* config.sub, config.guess: upgraded to recent versions of
	config.sub and config.guess.

	* locate/updatedb.sh: Add space to "#! /bin/sh"

	* configure.in: Add id to ALL_LINGUAS

	* lib/Makefile.am (EXTRA_DIST):  getline.[ch] added
	(libfind_a_SOURCES): getline.[ch] removed since getline.c is not
	always needed.

	* po/da.po, de.po, es.po, et.po, fr.po, gl.po, id.po, it.po, ko.po,
	nl.po, pl.po, pt_BR.po, ru.po, sv.po: updated to reflect changes
	in source code.

	* po/id.po: New translation for Indonesia.

2001-05-20  Lionel CONS <lionel.cons@cern.ch>

	* find/find.c: Fixed security holes.  1.  There is a race
	condition between the lstat() to detect a symbolic link and the
	actual chdir().  2.  An attacker can move directories while find
	is _inside_ so that chdir(..) goes out of the intended file tree.

	* lib/modetype.h: support for Solaris door files is added.

	* lib/filemode.c: S_ISDOOR is undef'ed if STAT_MACROS_BROKEN

	* find/pred.c (pred_type): -D option (for Solaris door files) is
	added.

	* find/parser.c (insert_type):  -D option (for Solaris door files)
	is added.

	* find/find.1: -D option (for Solaris door files) is documented

	* doc/find.texi (Type): -D option (for Solaris door files) is
	documented

2001-05-02  Kevin Dalley  <kevin@seti.org>

	* configure.in: Change AC_CHECK_MEMBERS to conform to new
	autoconf.  Add Danish.

2001-04-28  Kevin Dalley  <kevind@rahul.net>

	* po/sv.po, ru.po, pt_BR.po, pl.po, nl.po, ko.po, it.po, gl.po,
	fr.po, et.po, es.po, de.po, findutils.pot:  new translations, and
	new source code to translate.

	* po/da.po: new Danish translation.

2001-01-20  Kevin Dalley  <kevin@seti.org>

	* doc/find.texi (Adding Tests): Place space in "#! /bin/sh".

	* find/testsuite/find.gnu/prune-default-print.xo,
	find/testsuite/find.gnu/prune-default-print.exp: test for "find
	. -prune" which passes after changes.  Also see name-opt.exp.

	* find/util.c (get_new_pred):
	* find/tree.c (set_new_parent):
	* find/parser.c (various parse functions):
	* find/find.c (main):
	(default_prints): new function
	* find/defs.h (struct predicate): added no_default_print
	side_effects are no separated from no_default_print.  predicates
	which cause side effects should not be reordered (optimized).
	predicates which cause printing should have printing turned off.
	Printing statements also cause side effects.

2000-10-29  Bruno Haible <haible@ilog.fr>

	* locate/code.c (main), doc/find.texi: improve handling of
	non-ASCII characters used old format.

2000-10-21  Paul Eggert  <eggert@twinsun.com>

	If open + fchdir fails, fall back on xgetcwd + chdir.
	The old code tested for this at compile-time,
	but SunOS 4.1.4 fchdir can fail at run-time.

	* find/defs.h (fchdir): Define to -1 if not available.
	* find/defs.h (starting_dir, starting_desc):
	Always declare.  starting_dir now points to const.
	* find/find.c (starting_dir, starting_desc): Likewise.
	* find/find.c (starting_dir):
	Now "." if starting_desc is nonnegative, for benefit of diagnostics.
	(main, process_top_path, process_dir):
	If open + fchdir fails, fall back on xgetcwd + chdir.
	* find/pred.c (launch): Likewise.

2000-10-20  Kevin Dalley  <kevin@seti.org>

	* xargs/xargs.c, locate/updatedb.sh, locate/locate.c (usage),
	find/parser.c (parse_help): add bug reporting address to help

2000-10-13  Kevin Dalley  <kevin@seti.org>

	* depcomp, lib/depcomp: depcomp moved from lib to .

	* po/sv.po, ru.po, pt_BR.po, pl.po, nl.po, ko.po, it.po, gl.po,
	fr.po, findutils.pot, et.po, es.po, de.po: updated after addition
	of lib/rpmatch.c

2000-10-11  Kevin Dalley  <kevind@rahul.net>

	* Version 4.1.6

	* locate/testsuite/config/unix.exp: set PRUNEFS to "" for the
	testsuite.

2000-10-10  Bruno Haible <haible@ilog.fr>

	* lib/Makefile.am (libfind_a_SOURCES): added yesno.c

	* lib/yesno.c, lib/rpmatch.c: new files.

	* find/pred.c: use function yesno().

2000-10-10  Kevin Dalley  <kevind@rahul.net>

	* locate/testsuite/Makefile.am: Added missing \ at end of
	EXTRA_DIST lines.

	* locate/testsuite/locate.gnu/ignore_case3.xo,
	locate/testsuite/locate.gnu/ignore_case3.exp,
	locate/testsuite/locate.gnu/ignore_case2.exp,
	locate/testsuite/locate.gnu/ignore_case1.xo,
	locate/testsuite/locate.gnu/ignore_case1.exp: place locatedb
	inside tmp directory, add subdir directory under tmp.

	* locate/testsuite/config/unix.exp: clean up tmp after test is
	finished.

2000-10-10  Kevin Dalley  <kevind@rahul.net>

	* locate/testsuite/config/unix.exp (Repository):

	* po/POTFILES.in: added lib/rpmatch.c

2000-10-09  Kevin Dalley  <kevind@rahul.net>

	* lib/fnmatch.c, lib/fnmatch.h: reverted to older version of
	fnmatch which works with Solaris.

	* locate/testsuite/config/unix.exp: dejagnu unix.exp

	* xargs/testsuite/config/unix.exp: remove temporary file

	* xargs/xargs.c: spelling correction

	* m4/prereq.m4: updated and changed some macros

	* m4/jm-macros.m4: replaced jm_FUNC_FNMATCH with
	kd_FUNC_FNMATCH_CASE_REPL

	* m4/timespec.m4, m4/strerror_r.m4, m4/mbstate_t.m4,
	m4/largefile.m4, m4/gettext.m4, m4/fnmatchcase.m4, m4/d-type.m4,
	m4/d-ino.m4, m4/c-bs-a.m4: new m4 macros.

	* m4/Makefile.am: add fnmatchcase.m4 and mbstate_t.m4

	* locate/testsuite/locate.gnu/ignore_case3.xo,
	locate/testsuite/locate.gnu/ignore_case3.exp,
	locate/testsuite/locate.gnu/ignore_case2.xo,
	locate/testsuite/locate.gnu/ignore_case2.exp,
	locate/testsuite/locate.gnu/ignore_case1.xo,
	locate/testsuite/locate.gnu/ignore_case1.exp,
	locate/testsuite/config/unix.exp: tests related to "--ignore-case"
	option.

	* locate/testsuite/locate.gnu: testsuite directory

	* locate/testsuite/Makefile.am (Repository):

	* locate/testsuite: add directory for locate testsuite

	* po/findutils.pot: updated file

	* po/sv.po, po/ru.po, po/pt_BR.po, po/pl.po, po/nl.po, po/ko.po,
	po/it.po, po/gl.po, po/fr.po, po/et.po, po/es.po, po/de.po:
	updated various po files.

	* locate/updatedb.sh: export TMPDIR, which is used by child
	processes.

	* locate/locate.1, locate/locate.c:  add "--ignore-case" option.

	* locate/Makefile.am: add testsuite subdirectory

	* find/testsuite/find.gnu/perm.xo,
	find/testsuite/find.gnu/perm.exp,
	find/testsuite/find.gnu/name-opt.xo,
	find/testsuite/find.gnu/name-opt.exp: added test suites

	* configure.in: add locate/testsuite/Makefile

	* doc/find.info*: removed from repository

	* doc/find.texi: add documentation for "-i" option.

	* aclocal.m4: removed from repository, as it is generated.

	* find/pred.c: fixes problem with "find -perm -0100".

	* lib/lstat.c, lib/stat.c: removed from repository.  These files
	are generated from lib/xstat.in.

2000-08-24  Kevin Dalley  <kevind@rahul.net>

	* doc/find.texi (Invoking xargs): changed @var{-s} to @samp{-s}.

2000-05-13  Kevin Dalley  <kevind@rahul.net>

	* find/tree.c (opt_expr): move iname and ipath to the front of the
	list of arguments.

	* doc/find.texi (Directories): changed wording for "-prune".

	* find/parser.c (parse_prune): set side_effects to true, to
	prevent prune from being moved in opt_expr.

2000-04-12  Kevin Dalley  <kevind@rahul.net>

	* doc/find.texi, doc/permi.texi: fix spellings, add LocalWords.

	* lib/Makefile.am: put getline.c back into libfind_a_SOURCES,
	since getstr is needed.

	* Version 4.1.5

	* po/POTFILES.in: updated list of files, updated po files.


2000-04-02  Paul Eggert  <eggert@twinsun.com>

	Add support for large files, and port to Solaris 8 and earlier
	versions.

	* lib/human.c (getenv): Depend on NEED_GETENV_DECL, not
	HAVE_DECL_GETENV.

	* lib/strftime.c (my_strftime): Make sure we call the system
	strftime, not ourselves, when invoking the underlying strftime.

	* m4/check-decl.m4 (jm_CHECK_DECLS): Remove memchr, nanosleep.

	* m4/jm-macros.m4 (jm_MACROS): Don't check for utime.h.  Do not
	require jm_BISON, jm_CHECK_TYPE_STRUCT_UTIMBUF, jm_FUNC_LCHOWN,
	jm_FUNC_CHOWN, jm_FUNC_NANOSLEEP, jm_FUNC_GROUP_MEMBER,
	jm_FUNC_PUTENV, jm_FUNC_GETGROUPS, AM_FUNC_GETLOADAVG,
	jm_SYS_PROC_UPTIME, jm_FUNC_FTRUNCATE, jm_FUNC_UTIME.  Do not
	replace strcasecmp, dup2, gethostname, getusershell, stime,
	strcspn, strpbrk, euidaccess, mkdir, rmdir, rpmatch, strndup,
	strverscmp, memchr, memmove.  Do not check for declaration of
	lchown.  Remove invocations of AM_FUNC_OBSTACK, AM_FUNC_STRTOD,
	POW_LIBM, jm_LANGINFO_CODESET, jm_ICONV.  Remove df tests.
	(jm_CHECK_ALL_TYPES): Include <sys/stat.h> when checking for
	struct stat.st_blksize.

	* m4/strftime.m4 (jm_FUNC_GNU_STRFTIME): Set environment variable
	in shell rather than using putenv, which isn't portable.

	* COPYING, lib/alloca.c, lib/dirname.c, lib/error.c,
	lib/savedir.c, lib/strstr.c, m4/check-decl.m4, m4/d-ino.m4,
	m4/d-type.m4, m4/getline.m4, m4/jm-glibc-io.m4, m4/jm-macros.m4,
	m4/jm-mktime.m4, m4/ls-mntd-fs.m4, m4/memcmp.m4, m4/prereq.m4,
	m4/readdir.m4, m4/regex.m4, m4/strftime.m4, m4/uintmax_t.m4: Sync
	to latest version from sh-utils-2.0g.

	* config.guess, config.sub, lib/argmatch.c, lib/argmatch.h,
	lib/human.c, lib/human.h, lib/memcpy.c, lib/quotearg.c,
	lib/quotearg.h, lib/strtoull.c, lib/strtoumax.c,
	lib/xstrtoumax.c, m4/c-bs-a.m4, m4/gettext.m4,
	m4/largefile.m4, m4/lcmessage.m4, m4/link-follow.m4,
	m4/progtest.m4, m4/strerror_r.m4, m4/timespec.m4,
	m4/xstrtoumax.m4: New files, taken from sh-utils-2.0g.

	* lib/ansi2knr.1, lib/ansi2knr.c, lib/basename.c, lib/getopt.h,
	lib/fnmatch.c, lib/fnmatch.h, lib/modechange.c: Sync to latest
	unreleased version of GNU tar (between 1.13.17 and 1.13.18).

	* lib/basename.h, lib/waitpid.c: New files, taken from same
	version of GNU tar.

	* lib/regex.c, lib/regex.h: Sync to GNU grep 2.4.2.

	* lib/posix/Makefile.am, lib/posix/regex.h: New files, taken from
	GNU grep 2.4.2.

	* lib/strftime.c: Sync to textutils 2.0e.

	* acconfig.h, depcomp, lib/strcasecmp.c, m4/check-type.m4,
	m4/const.m4, m4/decl.m4, m4/lfs.m4, m4/mktime.m4, m4/perl.m4,
	m4/putenv.m4, m4/uptime.m4, m4/utimbuf.m4, m4/utime.m4,
	m4/utimes.m4: Remove these files; no longer needed.

	* configure.in (AC_CANONICAL_HOST, AC_SYS_LARGEFILE,
	jm_AC_TYPE_UINTMAX_T): Add.
	(CACHE_IDS, FSTYPE_STATVFS, FSTYPE_USG_STATFS, FSTYPE_AIX_STATFS,
	FSTYPE_MNTENT, FSTYPE_STATFS, FSTYPE_GETMNT): Add comment, so that
	we don't need acconfig.h.
	(AC_CHECK_TYPE): Add ssize_t.
	(AC_REPLACE_FUNCS): Add waitpid.
	(AC_CHECK_FUNCS): Remove basename.
	(AC_FUNC_MKTIME): Remove.
	(LIBOBJS): Add no-ops to work around automake 1.4 bug.
	(AC_OUTPUT): Add lib/posix/Makefile.

	* find/defs.h: Include <config.h>, <sys/types.h>, <sys/stat.h>,
	<stdio.h>, <limits.h>, <inttypes.h>.  All includers changed to not
	include these files, and to include "defs.h" first (since config.h
	must be included first).
	(CHAR_BIT, S_ISUID, S_ISGID, S_ISVTX, S_IRUSR, S_IWUSR, S_IXUSR,
	S_IRGRP, S_IWGRP, S_IXGRP, S_IROTH, S_IWOTH, S_IXOTH, MOD_WXUSR,
	MODE_R, MODE_RW, MODE_RWX, MODE_ALL): New macros.
	(enum permissions_type): New enum.
	(struct long_val.negative): New member.
	(struct long_val.l_val): Now uintmax_t, not unsigned long.
	(struct size_val.size): Likewise.
	(struct perm_val): New type.
	(struct predicate.perm): Now struct perm_val, not unsigned long.
	(struct predicate.type): Now mode_t, not unsigned long.
	(list_file): New parameters current_time, output_block_size.
	All callers changed.
	(savedir, basename): Remove decls.
	(output_block_size, start_time): New extern vars.

	* find/find.c: Include <human.h>, <savedir.h>.
	(output_block_size, start_time): New vars.
	(main): Initialize them.  No need to check for negative st_size,
	since savedir now does it for us.

	* find/fstype.c: Include "dirname.h".
	(xatoi): Remove.
	(filesystem_type_uncached): Use xstrtoumax instead of xatoi.

	* find/parser.c: Include "xstrtol.h".
	(get_num_days, get_num, parse_amin, parse_cmin, parse_mmin,
	parse_size, parse_used, insert_time, insert_num): Compute using
	uintmax_t, not unsigned long.
	(parse_amin, parse_cmin, parse_mmin, parse_used, insert_time):
	Keep track of whether time was negative before converting it to an
	unsigned type.
	(parse_daystart): Don't assume that localtime succeeds; e.g. it
	can fail with 64-bit time_t and 32-bit tm_year.
	(parse_perm, insert_type): Compute using mode_t, not unsigned
	long.
	(insert_type): Use symbolic constants like MODE_ALL instead of
	traditional ones like 07777.  Set new kind member to indicate
	permissions type, instead of using unportable magic numbers.
	(make_segment): We will use human_readable to convert most numeric
	values, so simplify the cases.
	(get_num_days): Write in terms of get_num, to avoid duplicated
	code.
	(insert_time, insert_num): When debugging, convert large values to
	uintmax_t and output with %ju.
	(get_num): Use xstrtoumax to do the real work.

	* find/pred.c: Include "basename.h", "human.h".
	(DEV_BSIZE, ST_BLKSIZE, ST_NBLOCKSIZE): New macros, taken from
	fileutils.
	(ST_NBLOCKS): Replace with fileutils defn.
	(MAX): New macro.
	(ctime_format): New function.
	(pred_fprintf, format_date): Use human_readable to output large
	numbers portably.
	(pred_fprintf): Use ctime_format to output ctime-style dates.  Use
	base_name to compute the base name of a path.  With %m, output the
	mode portably using traditional numbers, even if the host uses
	some other numbering scheme.
	(pred_iname, pred_name): basename -> base_name.
	(pred_perm): Use new kind member to deduce permissions type,
	instead of relying on magic numbers.
	(pred_size): Compute using uintmax_t, not unsigned long.  Avoid
	overflow if file size is near the maximum.
	(pred_type): Compute using mode_t, not unsigned long.
	(launch): Use waitpid, not wait.  Check for EINTR.
	(format_date): Don't assume that localtime succeeds.

	* find/util.c (basename): Remove; we now use base_name.

	* lib/Makefile.am (SUBDIRS): New macro.
	(libfind_a_SOURCES): Add argmatch.h, argmatch.c, basename.h,
	basename.c, human.c, human.h, quotearg.c, quotearg.h, xstrtoumax.c.
	Remove error.h, error.c, getline.c.
	(EXTRA_DIST): Add mktime.c, regex.c.

	* lib/listfile.c: Include "human.h".
	(alloca): Declare, or include appropriate files to declare.
	(DEV_BSIZE, ST_NBLKSIZE, ST_NBLOCKS, ST_NBLOCKSIZE): New macros.
	(convert_blocks): Remove.
	(list_file): New current_time and output_block_size args.
	Revamp quite a bit, to handle large numbers correctly
	and to match GNU ls behavior more closely.

	* m4/Makefile.am (EXTRA_DIST): Add c-bs-a.m4, gettext.m4,
	largefile.m4, lcmessage.m4, link-follow.m4, progtest.m4,
	strerror_r.m4, xstrtoumax.m4.  Remove check-type.m4, const.m4,
	decl.m4, lfs.m4, mktime.m4, perl.m4, putenv.m4, timespec.m4,
	uptime.m4, utimbuf.m4, utime.m4, utimes.m4.

	* xargs/xargs.c (wait_for_proc): Retry wait if it fails with
	errno == EINTR.

2000-04-05  Kevin Dalley  <kevind@rahul.net>

	* xargs/Makefile.am:  add ansi2knr

	* xargs/xargs.c: add macros PARAMS rather than P_.  Add
	prototypes.

	* po/POTFILES: new file listing all POFILES.

	* m4/gl.po, m4/et.po: new files

	* m4/Makefile.am.in:  updated file

	* m4: update directory

	* locate/Makefile.am: create updatedb from updatedb.sh

	* locate/updatedb.sh, locate/updatedb.in: removed file.  Replaced
	by updatedb.sh

	* locate/frcode.c, locate/code.c, locate/bigram.c: add macros
	PARAMS rather than P_.  Add prototypes.

	* lib/xstat.in: new file

	* lib/Makefile.am: update to latest versions of library files.

	* find/testsuite/Makefile.am: add CLEANFILES

	* find/util.c: remove definition of basename

	* find/util.c, find/tree.c, find/pred.c, find/parser.c,
	find/fstype.c, find/find.c, find/defs.h: add macros PARAMS rather
	than P_, for consistency, change to prototypes

	* find/Makefile.am: Add prototypes and ansi2knr

	* configure.in: add Galition and Estonian languages.
	Miscellaneous other fixes.


2000-03-11  Kevin Dalley  <kevind@rahul.net>

	* lib/basename.c: Add file from libit.
	* lib/Makefile.am (libfind_a_SOURCES): add basename.c since it is
	no longer replaceable.

	* find/util.c: Remove definition of basename, which is now in
	lib/basename.c (as base_name).
	* find/pred.c: Use base_name, not basename.
	* find/defs.h: Likewise.

	* configure.in : Don't replace basename.  Now we use only
	base_name.

2000-02-26  Kevin Dalley  <kevind@rahul.net>

	* Version 4.1.4

	* lib/strtoul.c: added to distribution

	* configure.in: added strtoul to AC_REPLACE_FUNCS

	* configure.in: added jm_CHECK_ALL_TYPE

2000-02-23  Kevin Dalley  <kevind@rahul.net>

	* po/ChangeLog: removed, merged with top-level ChangeLog.

	* po/de.po: new version of German file.

	* po/gl.po, po/et.po: new languages, Estonian and Galician.

	* locate/updatedb.sh (PRUNEFS): enclose paths in quotes

2000-02-17  Kevin Dalley  <kevind@rahul.net>

	* po/it.po: new version of Italian file.

	* locate/updatedb.sh (prunefs_exp): have sed statement use '*'
	rather than the often unsupported '+'.

2000-02-13  Kevin Dalley  <kevind@rahul.net>

	* configure.in: removed AC_ARG_PROGRAM, which is already in
	AM_INIT_AUTOMAKE.

	* locate/Makefile.am (updatedb), locate/updatedb.sh: add
	transforms of find, frcode, bigram, and code back into
	updatedb.sh, which were accidentally removed.

2000-02-12  Kevin Dalley  <kevind@rahul.net>

	* lib/wait.h: updated address.

2000-01-26  Kevin Dalley  <kevind@rahul.net>

	* Version 4.1.3

	* acconfig.h: added internationalization.

	* intl/*: copied from tar-1.13.17.

	* locate/Makefile.am, locate/locate.c, locate/code.c:
	internationalized file.

	* locate/frcode.c, locate/bigram.c: include headers from ../lib
	directory.

	* xargs/Makefile.am, xargs/xargs.c: internationalized directory.

2000-01-26  Kevin Dalley  <kevind@rahul.net>

	* po/POTFILES.in: added list of files with translatable strings.

	* de.po, es.po, fr.po, it.po, ko.po, nl.po, pl.po, pt_BR.po,
	ru.po, sv.po: New, slightly out of date, files imported from the
	Translation Project: http://www.iro.umontreal.ca/contrib/po/HTML/,
	German, Spanish, French, Italian, Korean, Dutch, Polish, Brazilian
	Portuguese.


2000-01-24  Kevin Dalley  <kevind@rahul.net>

	* lib/xmalloc.c, lib/regex.c, lib/getopt.c: internationalization
	works with current version of gettext.

	* lib/getline.h : added declaration of getstr.
	* lib/Makefile.am (libfind_a_SOURCES): added getline.[ch] to
	standard compilation. Added internationalization.
	* find/Makefile.am (INCLUDES): corrected -I options for building
	in other directories.
	(LDADD): changes for internationalization.

	* configure.in (ALL_LINGUAS): added internationalization.
	getline.c is always compiled and linked, because of getstr.
	AM_GNU_GETTEXT

	* Makefile.am:
	(DISTCLEANFILES): added intl/libintl.h
	(AUTOMAKE_OPTIONS): added gnits to AUTOMAKE_OPTIONS
	(SUBDIRS): added intl and po

	* acconfig.h: added internationalization values

	* THANKS: added thanks file for gnits compatibility.

2000-01-22  Kevin Dalley  <kevind@rahul.net>

	* added intl directory.
	* created po directory and added existing po files from
	http://www.iro.umontreal.ca/contrib/po/HTML

	* Added internationalization, only with slightly out of date po
	files for many locales.

2000-01-18  Kevin Dalley  <kevind@rahul.net>

	* Version 4.1.2

	* locate/Makefile.am: remove creation of updatedb, since it is now
	made by configure

	* configure.in: updatedb is now created by configure.

	* xargs/Makefile.am: added testsuite to xargs directory

	* locate/updatedb.in: updatedb is now created by configure

	* locate/frcode.c, locate/code.c, locate/bigram.c: change return
	from main to int.  Replace getstr with getline, where possible.

	* locate/Makefile.am: place frcode, code, bigram in
	libexec_PROGRAMS

	* lib/xstrdup.c, lib/xmalloc.c, lib/xgetcwd.c, lib/xalloc.h,
	lib/strtol.c, lib/strstr.c, lib/strftime.c, lib/strdup.c,
	lib/stpcpy.c, lib/stat.c, lib/savedir.h, lib/savedir.c,
	lib/regex.h, lib/regex.c, lib/realloc.c, lib/pathmax.h,
	lib/modechange.h, lib/modechange.c, lib/mktime.c, lib/memset.c,
	lib/memcmp.c, lib/malloc.c, lib/lstat.c, lib/idcache.c,
	lib/getopt1.c, lib/getopt.c, lib/getopt.h, lib/getline.c,
	lib/getline.h, lib/fnmatch.c, lib/fnmatch.h, lib/filemode.c,
	lib/filemode.h, lib/fileblocks.c, lib/error.c, lib/error.h,
	lib/dirname.c, lib/alloca.c: updated to newer version of file from
	fileutils.

	* find/version.c: version number is now automatically generated by
	configure.

	* find/fstype.c (filesystem_type_uncached): fixes bug described as
	follows:  When 'find' looks for a fstype, it parses the /etc/mtab
	until it finds the good line. But, if there is, before the good
	line, a line whose mountpoint is unreachable, it fails.

	* doc/texinfo.tex: updated to newer version

	* doc/find.texi: added version.texi, fixed a few documentation bugs.

	* configure.in: new m4 features.

	* Makefile.am: moved testsuite to below corresponding directories
	find and xargs.

	* acconfig.h: updated to match new m4 files.

	* m4: added m4 directory, largely borrowed from Jim Meyering's
	fileutils.

2000-01-17  Kevin Dalley  <kevind@rahul.net>

	* doc/find.texi (Multiple Files): placed missing xargs in examples

	* find/testsuite/find.gnu/depth.exp: added find tests to test
	"-depth" bug.

	* doc/find.texi: include version.texi for automatic determination
	of version number, update bug report email address to
	bug-findutils@gnu.org.
	(Combining Primaries With Operators): add indices for "	,", "()",
	"-a", "-o", etc.

2000-01-17  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* find/tree.c (opt_expr): Never rearrange the arguments of the
	comma operator, since it is not commutative.  Remove useless
	assignment.2

2000-01-17  Jonathan R. Ferro <jferro@corwin.ece.cmu.edu>

	* find/find.c (process_path): fix problem with "-depth" which is
	tested in depth.exp test.

1999-08-15  Kevin Dalley  <Kevin Dalley <kevin@seti.org>>

	* find/fstype.c (filesystem_type_uncached): a stat failure with
	EACCESS will ignore this file system keep on looking.  Patch
	suggested by Vincent Danjean <vdanjean@ens-lyon.fr>.

1999-08-15  Mark Kettenis  <kettenis@gnu.org>

	* xargs/xargs.c (LONG_MAX): Define if necessary.
	(main): If ARG_MAX is -1 (that is sysconf
	(_SC_ARG_MAX) returns -1) the system does not impose a limit.  In
	that case, use LONG_MAX as the limit.

1999-08-15  Kevin Dalley  <Kevin Dalley <kevind@rahul.net>

	* find/version.c: version string is now set by config.h

1999-08-08  Kevin Dalley  <kevin@seti.org>

	* Version 4.1.1

	* README-alpha: added alpha README file

	* find/defs.h: move lstat declarations into defs.h

	* xargs/Makefile.am, testsuite/Makefile.am, locate/Makefile.am,
	lib/Makefile.am, find/Makefile.am, doc/Makefile.am, configure.in,
	Makefile.am: update for automake-1.4

1999-08-02  Kevin Dalley  <kevind@rahul.net>

	* AUTHORS: added file listing AUTHORS

	* lib/Makefile.am: modified code for EXTRA sources

1999-01-30  Kevin Dalley  <kevind@rahul.net>

	* added const to declaration of basename, which should satisfy
	Linux as well as Hurd (fixes bug #31325).

1998-12-04  Kevin Dalley  <kevind@rahul.net>

	* lib/nextelem.c: removed declaration of strdup and free, which
	meets GNU coding standards and allows compilation on more
	platforms.

	* find.texi: corrected explanation of -amin option which described
	hours instead of minutes

1998-09-26  Kevin Dalley  <kevind@rahul.net>

	* lib/getline.c: fix getstr so that it correctly handles long file
	paths

1998-09-20  Kevin Dalley  <kevind@rahul.net>

	* removed more function declarations to meet GNU coding standards

1998-08-30  Kevin Dalley  <kevind@rahul.net>

	* lib/nextelem.c: removed declaration of strdup and free, which
	meets GNU coding standards and allow compilation on sparc

	* corrected explanation of -amin option which described hours
	instead of minutes

1998-02-27  Kevin Dalley  <kevind@rahul.net>

	* locate/locate.c: add --existing option to locate, which only
	prints the names of files which still exist

1998-02-08  Kevin Dalley  <kevind@rahul.net>

	* locate/locate.c: corrected get_short so that it correctly
	returns negative numbers.

	* remove declarations of various string functions.  Removing the
	declarations almost matches the GNU Coding Standards.

1997-03-03  Kevin Dalley  <kevind@rahul.net>

	* xargs/xargs.c: xargs fixed to prevent occasional core dumping.

1997-01-11  Kevin Dalley  <kevind@rahul.net>

	* locate/updatedb.sh: add --localuser option to updatedb, which
	allows find to be run as nobody, while allowing database file to
	be created as root, change suggested by
	<Bernd_Eckenfels@Wittumstrasse13.76646Bruchsal.de>

1996-12-28  Kevin Dalley  <kevind@rahul.net>
	* added PRUNEFS as variable in updatedb and --prunefs as option to
	updatedb

1996-05-27  Kevin Dalley  <kevind@rahul.net>

	* updatedb.sh: when NETPATHS is used, only su to NETUSER if whoami
	is root
1996-04-27  Kevin Dalley  <kevind@rahul.net>

	* lib/getline.c (getstr): verify that nchars_avail is *really*
	greater than 0; set *n to a large enough number, stops some core
	dumping

1994-11-03  David J. MacKenzie  <djm@gnu.org>

	* Version 4.1.

	* locate/Makefile.am: Move updatedb from LIBSCRIPTS to SCRIPTS.

	* Makefile.am (distname): Change distribution name from find to
	  findutils.

	* testsuite/config/unix.exp: Don't abuse xfail; simulate it correctly.

	* locate/Makefile.am (CLEANFILES): Fix typo.

1994-11-02  David J. MacKenzie  <djm@gnu.org>

	* The big 4 0.

	* lib/listfile.c find/defs.h (list_file): Take a stream arg.
	* find/pred.c (pred_ls): pass it.
	* find/parser.c pred.c defs.h (parse_fls, pred_fls): New functions.

1994-10-25  David J. MacKenzie  <djm@gnu.org>

	* find/pred.c (pred_fprintf): Flush output after \c.  From Chapman
	Flack.

	* find/parser.c (insert_fprintf): Warn about unrecognized \ and %
	sequences.

1994-10-18  David J. MacKenzie  <djm@gnu.org>

	* find/defs.h parser.c pred.c tree.c util.c: Globally change
	"victim" to "primary".

	* find/parser.c (insert_fprintf): For 'c' format, don't lose the
	need_stat information.  From Chapman Flack.

	* doc/find.texi perm.texi: New files.
	* configure.in: Configure the doc directory.

	* find/pred.c (pred_regex): Check that the regex matched the whole
	file name.

1994-10-12  David J. MacKenzie  (djm@gnu.org>

	* find/parser.c: Add -mount as an alias for -xdev.
	From Klaus.Steinberger@physik.uni-muenchen.de (Klaus Steinberger).

	* lib/modechange.c: Make umask_value unsigned short.

	* xargs/xargs.c: Use symbolic constants in longopts.
	From Chapman Flack.

1994-10-05  David MacKenzie  <djm@gnu.org>

	* xargs/xargs.c (main, read_line, read_string, do_exec): Pass
	  along the lengths of the args.
	  (main): Calculate length of replace_pat.
	  (push_arg, do_insert): Use those lengths instead of calculating
	  them.

1994-10-04  David MacKenzie  <djm@gnu.org>

	* locate/updatedb.sh Makefile.in: Add substitutions to get
	  the transformed program names.

	* xargs/xargs.c: Put back the global variables for now.
	Rename some variables.  Increase default args_per_exec.
	Use boolean where applicable.
	(main): Reduce default arg_max by 2048 for POSIX.2.
	(read_string): Don't check EOF string.
	(read_line, read_string): Take initial args size into account.

1994-10-01  David MacKenzie  <djm@gnu.org>

	* find/pred.c (launch): Use pid_t.

	* xargs/xargs.c (EOF_STR): Define and use.
	[__STDC__]: Declare xrealloc and xmalloc using void *.
	* find/defs.h: Likewise.

	* find/defs.h: Only declare stpcpy if !HAVE_STPCPY.

	* xargs/xargs.c: Replace most global variables with structure
	  pointers passed as arguments.  Use pid_t.
	* lib/wait.h: Include sys/wait.h if HAVE_SYS_WAIT_H.
	* configure.in: Call AC_TYPE_MODE_T and AC_HEADER_SYS_WAIT.

	* xargs/xargs.c: Improve paging performance and memory
	  fragmentation by building command arguments in a pre-allocated
	  buffer and re-implementing the child pid list as an expandable
	  array.  From tsi@gpu.srv.ualberta.ca (Marc Aurele La France).

1994-09-29  David J. MacKenzie  (djm@gnu.org>

	* find/fstype.c (fstype_to_string): Add more cases.  Use
	  INITMOUNTNAMES if defined.
	* find/defs.h: Change boolean typedef from char to int.
	* configure.in: Check for mktime.

1994-09-27  Kaveh R. Ghazi  (ghazi@noc.rutgers.edu)

	* configure.in: Add AC_HEADER_STAT.
	* lib/listfile.c, lib/modetype.h: Add STAT_MACROS_BROKEN.

	* find/pred.c: Move the inclusion of defs.h ahead of the first
	  test of _POSIX_VERSION.

	* lib/xgetcwd.c: Remove _POSIX_VERSION, rely only on HAVE_GETCWD.

1994-09-26  David MacKenzie  <djm@gnu.org>

	* configure.in: Add AC_CONFIG_HEADER.
	* find/*.c locate/*.c xargs/*.c: Include config.h.
	* locate/updatedb.sh: Add --version; --old -> --old-format.

1994-09-25  David MacKenzie  <djm@gnu.org>

	* find/* [__STDC__]: Prototype declarations.

	* locate/updatedb.sh: Account for renaming code and frcode.

	* find/find.c (process_path): Store dev and ino of directories in
	  current branch to avoid symlink loops.  From DJ Delorie
	  <dj@ctron.com>.
	  (process_dir): If following symlinks, don't cd to ..; instead,
	  cd to the starting directory and then to the parent directory.
	  (main) [HAVE_FCHDIR]: Save the dev, ino of the starting directory.
	  (process_top_path) [HAVE_FCHDIR]: Use it.
	* find/pred.c (launch) [HAVE_FCHDIR]: Likewise.
	* defs.h [HAVE_FCHDIR]: Declare starting_desc instead of starting_dir.
	* configure.in: Check for dev_t, ino_t, fchdir, fcntl.h.

1994-09-23  David MacKenzie  <djm@gnu.org>

	* lib/listfile.c: Change #ifdef S_IFLNK to #ifdef S_ISLNK.
	From Andreas Luik <luik@isa.de>.

1994-09-22  David MacKenzie  <djm@gnu.org>

	* locate/locate.c (last_literal_end): Dynamically allocate enough
	  memory for the subpattern.

1994-09-21  David MacKenzie  <djm@gnu.org>

	* locate/locate.c (locate): Warn if database is >8 days old.
	From Ian Lance Taylor.

	* xargs/xargs.c (do_exec), find/pred.c (launch): Set SIGCHLD to
	  default.  From tsi@gpu.srv.ualberta.ca (Marc Aurele La France).
	* find/find.c pred.c util.c lib/listfile.c: Remove fflush(stdout)
	  calls before error.  error does it, and doesn't trash errno.
